package LaggsDefault5_GameType {
//--------------------------------------------------------------------------------------- begin package LaggsDefault5_GameType ---***---

//----------------------------------------------------------------------------------------------- Setup ---
function LaggsDefaultSetup()
{

   exec("scripts/LaggsDefault5_vehicle.cs");//load the modified vehicle functions
   exec("scripts/LaggsDefault5_camera.cs");//exec 1 modified function to fix observer camera spam

   //set mission cleanup for game over ------ * HACK ALERT! - We Hack around MapSupportPack Here :) *
   exec("scripts/LaggsDefault5_MissionOver.cs");//needed to set server back to default while using MapSupportPack

   if (Game.class $= "NoneGame" || $Host::BotsEnabled)
   {
      //%gravity = getGravity();
      //if (%gravity == -20)
      //{
         //error("Server Bots Enabled");
         error("Loading Lagg's... custom AI files :)");

         //exec all the modified ai scripts
         exec("scripts/LaggsDefault5_ai.cs");
         // includes                           exec("scripts/LaggsDefault5_aiDefaultTasks.cs");
         // includes                           exec("scripts/LaggsDefault5_aiObjectives.cs");
         // includes                           exec("scripts/LaggsDefault5_aiInventory.cs");
         // includes                           exec("scripts/LaggsDefault5_aiChat.cs");
         // includes                           exec("scripts/LaggsDefault5_aiObjectiveBuilder.cs");
         // includes                           exec("scripts/LaggsDefault5_serverTasks.cs");
         // includes                           exec("scripts/LaggsDefault5_aiVehicle.cs");//new file - Lagg... 9-30-2003

         //exec all the modifed support files to enhance the ai
         if (Game.class $= "SiegeGame")
            exec("scripts/LaggsDefault5_aiSiege.cs");//exec 2 modified functions from aiSiege.cs
         else if (Game.class $= "CTFGame")
            exec("scripts/LaggsDefault5_aiCTF.cs");//exec 2 modified functions from aiCTF.cs
            //exec("scripts/LaggsDefault5_aiStealARide.cs");
         else if (Game.class $= "DnDGame")
            exec("scripts/LaggsDefault5_aiDnD.cs");
         exec("scripts/LaggsDefault5_projectiles.cs");//exec 2 modified functions from projectiles.cs
         exec("scripts/LaggsDefault5_player.cs");//exec modified function Armor::onCollision to allow medium bots to pilot vehicles
         exec("scripts/LaggsDefault5_turret.cs");//allows turrets to fire at all enemy targets
         exec("scripts/LaggsDefault5_aiSupport.cs");//2 added functions for mortar/plasma turret fire, 2 spam fixes
         exec("scripts/LaggsDefault5_aiVehicleSupport.cs");//modified bomber/tank data blocks, modified MPB jammer,
                                               //     2 spam fixes for ai dismounting bomber and tank

         //lets load all the aiVehicle Files here - Lagg...
         exec("scripts/LaggsDefault5_aiNeedRide.cs");       // ai - pilots HAPC
         exec("scripts/LaggsDefault5_aiPilotShrike.cs");    // ai - pilots Shrike
         exec("scripts/LaggsDefault5_aiDeployVehicle.cs");  // ai - pilots & deploys MPB
         exec("scripts/LaggsDefault5_aiTank.cs");           // ai - tank crew
         exec("scripts/LaggsDefault5_aiBombingRun.cs");     // ai - bomber crew
         exec("scripts/LaggsDefault5_aiEasyRider.cs");      // ai - rides bike
         exec("scripts/LaggsDefault5_aiStealARide.cs");

         activatePackage(LaggsDefault5_Support);
         error("Activating Package LaggsDefault5_Support");

         //LaggsGameStartUp();//call this after Ai files are loaded - NOTE *
      //}
      //else
         //error("Server Gravity not set to default - Aborting Custom AI Setup :(");
   }
   else
   {
      error("Server Bots Disabled - Aborting Laggs... Custom AI Setup :(");
   }

   //-------------------------------------------------------------------------------------------------------------------------
   //count the number of deployables meant for gen defending - roberto
    $GenDefendDeployables[1] = 0; //team 1 
    $GenDefendDeployables[2] = 0; //team 2

    if (Game.class !$= "HuntersGame" && Game.class !$= "TeamHuntersGame" && Game.class !$= "RabbitGame" && Game.class !$= "DMGame" && Game.class !$= "LakRabbitGame")
    {
      %teamObjectives[1] = nameToId("MissionGroup/Teams/team1/AIObjectives");
      %teamObjectives[2] = nameToId("MissionGroup/Teams/team2/AIObjectives");

      %objCount[1] = %teamObjectives[1].getCount();
      %objCount[2] = %teamObjectives[2].getCount();

      for (%i = 1; %i < 3; %i++) //loop for team 1 and 2
      {
      	for (%b = 0; %b < %objCount[1]; %b++) //loop through all the objectives from the current team
      	{
      		%currentObj = %teamObjectives[%i].getObject(%b);
      		if (%currentObj.GenDefend == true)
      		{
      			$GenDefendDeployables[%i]++;
      		}
      	}
      	echo("Total GenDefend objectives for team " @ %i @ " is " @ $GenDefendDeployables[%i]);
      }
    }
    else
    {
      $GenDefendDeployables[1] = 0;
      $GenDefendDeployables[2] = 0;
    }

    if (!$Host::RPG_Active && $Host::MapRecords)
    {
      mapRecordsLoadData();
    }

   //-------------------------------------------------------------------------------------------------------------------------

   //call to setup everything the Bots need, also setsup custom Flip Flops
   LaggsGameStartUp();
}

//-------------------------------------------------------------------------------------------------------- GameStartUp ---

function LaggsGameStartUp()
{
   //$ObjectiveCounter[1] = 0;
   //$ObjectiveCounter[2] = 0;
 
   if ($missionRunning == false)
   {
      schedule(500, 0, LaggsGameStartUp);
      return;
   }
   SweepForPads(NameToID(MissionGroup)); 

  $Host::MinBotDifficulty = 0.99;
  $Host::MaxBotDifficulty = 0.99;

   switch$ ($Host::BotDifficulty)
   {
      case "Easy":
        $Host::RebalanceTeamBots = 1;
        $Host::HumanWeightAloneBonus = "0";
        $Host::BotHumanBalanceWeight = "1";
        $Host::Bot_Capper_Boost_Active = 1;
        $Host::Bot_Chaser_Boost_Active = 0;
        $Host::Bot_Chase_Speed = 0.25;
        $Host::Bot_Cap_Speed = 0.5;
        $Host::AdaptiveCTFBots = 0;
        $GainDesiredBot = 0;
      case "Medium":
        $Host::RebalanceTeamBots = 1;
        $Host::HumanWeightAloneBonus = "0";
        $Host::BotHumanBalanceWeight = "1";
        $Host::Bot_Capper_Boost_Active = 1;
        $Host::Bot_Chaser_Boost_Active = 1;
        $Host::Bot_Chase_Speed = 0.5;
        $Host::Bot_Cap_Speed = 0.75;
        $Host::AdaptiveCTFBots = 1;
        $GainDesiredBot = 1;
      case "Hard":
        $Host::RebalanceTeamBots = 1;
        $Host::HumanWeightAloneBonus = "1";
        $Host::BotHumanBalanceWeight = "2";
        $Host::Bot_Capper_Boost_Active = 1;
        $Host::Bot_Chaser_Boost_Active = 1;
        $Host::Bot_Chase_Speed = 1;
        $Host::Bot_Cap_Speed = 1;
        $Host::AdaptiveCTFBots = 1;
        $GainDesiredBot = 0;
      case "Custom":
      //nothing
      default:
        $Host::RebalanceTeamBots = 1;
        $Host::HumanWeightAloneBonus = "1";
        $Host::BotHumanBalanceWeight = "2";
        $Host::Bot_Capper_Boost_Active = 1;
        $Host::Bot_Chaser_Boost_Active = 1;
        $Host::Bot_Chase_Speed = 1;
        $Host::Bot_Cap_Speed = 1;
        $Host::AdaptiveCTFBots = 1;
        $GainDesiredBot = 0;
   }

   //we use GainDesiredBot so that 1 bot switches to the other team on Medium difficulty, but there's no need for it in non-team gametypes
   if (Game.class $= "HuntersGame" || Game.class $= "DMGame" || Game.class $= "LakRabbitGame")
   {
      $GainDesiredBot = 0;
   }

     //every X secs we record a bot's position, check 3 times until the next time to see if he's still there, and kill him
    if (isEventPending($StuckBotsSchedule))
    {
      cancel($StuckBotsSchedule);
      $StuckBotsSchedule = -1;
    }

    $StuckBotsSchedule = schedule(30000, 0, "checkStuckBots");

    //kick/add bots depending on the map preference
    %numHumans = 0;
     for(%i = 0; %i < ClientGroup.getCount(); %i++)
     {
        %cl = ClientGroup.getObject(%i);
        if(!%cl.isAIControlled())
        {
          %numHumans += 1;
        }
     }
     
     mapBalanceBots(%numHumans);

    // if (isEventPending($FirstBalanceBotsSchedule))
    // {
    //   cancel($FirstBalanceBotsSchedule);
    //   $FirstBalanceBotsSchedule = -1;
    // }

    // $FirstBalanceBotsSchedule = schedule(200, 0, "startFirstBotBalance", %numHumans);


    //-------------------------------------------------------------------------------------------------------------------------
   //count the number of ctfEmergency objectives - roberto
    // $ctfEmergencyObjs[1] = 0; //team 1 
    // $ctfEmergencyObjs[2] = 0; //team 2

    // %teamObjectives[1] = nameToId("MissionGroup/Teams/team1/AIObjectives");
    // %teamObjectives[2] = nameToId("MissionGroup/Teams/team2/AIObjectives");

    // %objCount[1] = %teamObjectives[1].getCount();
    // %objCount[2] = %teamObjectives[2].getCount();

    // for (%i = 1; %i < 3; %i++) //loop for team 1 and 2
    // {
    // 	for (%b = 0; %b < %objCount[1]; %b++) //loop through all the objectives from the current team
    // 	{
    // 		%currentObj = %teamObjectives[%i].getObject(%b);
    // 		if (%currentObj.ctfEmergency == true)
    // 		{
    // 			$ctfEmergencyObjs[%i]++;
    // 		}
    // 	}
    // 	echo("Total ctfEmergencyObjs objectives for team " @ %i @ " is " @ $ctfEmergencyObjs[%i]);
    // }

   //-------------------------------------------------------------------------------------------------------------------------
}


//------------------------------------------------------------------------------------------------------- SweepForPads ---

function SweepForPads(%simGroup)
{
   if(%SimGroup.getClassName() $= "SimGroup")
   {
      for (%i = 0; %i < %SimGroup.getCount(); %i++)
      {
         %obj = %SimGroup.getObject(%i);
         if (%obj.getClassName() $= "SimGroup")
         {
            SweepForPads(%obj);
         }
 
         if (%obj.getClassName() $= "StaticShape")
         {
            %type = %obj.getDataBlock().getName();
            if (%type $= "StationVehicle" || %type $= "MPBTeleporter")
            {
               //error("SweepForPads - HERE we go --------------------------------------------------");
               
               if (%type $= "StationVehicle")
               {
                  //echo("VPad added to $AIVehiclePadSet for bots to buy vehicles");
                  $AIVehiclePadSet.add(%obj);
               }
               else
               {
                  //echo("MPBteleporter added to $AIMPBTeleportSet for bots");
                  $AIMPBTeleportSet.add(%obj);
               }
                  
               if (Game.class !$= "SiegeGame")
               {
                  //error("Object team = " @ %obj.team);
                  
                  if (%obj.team > 0)
                  {
                     %homeTeam = %obj.team;

                     if(%obj.team == 1)
                       %enemyTeam = 2;
                     else
                        %enemyTeam = 1;

                     addVPadRepairObjective(%obj, %homeTeam);
                     //echo("calling addVPadRepairObjective team = " @ %homeTeam);
                     addVPadDestroyObjective(%obj, %enemyTeam);
                     //echo("calling addVPadDestroyObjective team = " @ %enemyTeam);
                  }
                  else
                  {
                     addVPadRepairObjective(%obj, 1);
                     addVPadRepairObjective(%obj, 2);
                        //echo("calling addVPadRepairObjective for both teams 1 and 2");

                     //don't add destroy for team 0 vpads
                     //addVPadDestroyObjective(%obj, 1);
                     //addVPadDestroyObjective(%obj, 2);
                         //echo("calling addVPadDestroyObjective for both teams 1 and 2");
                  }
               }
               else
               {
                  //for seige game we may need a little more work here ...
                  Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;
                  
                  if (%obj.team == (Game.defenseTeam || 0))
                  {
                     addVPadRepairObjective(%obj, Game.defenseTeam);
                     addVPadDestroyObjective(%obj, Game.offenseTeam);
                  }
                  else if (%obj.team == (Game.offenseTeam || 0))
                     addVPadRepairObjective(%obj, Game.offenseTeam);
               }
            }
         } 
      }
   }
}

//--------------------------------------------------------------------------------------------------- addVPadObjective ---
function addVPadRepairObjective(%object, %team)
{
   if (!isObject("T" @ %team @ "VPadRepairSet"))
   {
      %set = new SimGroup("T" @ %team @ "VPadRepairSet");
      MissionCleanup.add(%set);
   }
   else
      %set = nameToId("T" @ %team @ "VPadRepairSet");

   //create the repair objective
   %repairVPad = new AIObjective(AIORepairObject)
   {
           dataBlock = "AIObjectiveMarker";
           weightLevel1 = $AIWeightMortarTurret[1];
           weightLevel2 = $AIWeightRepairGenerator[1];
           description = "Repair the " @ %object.getDataBlock().getName();
           targetObject = %object.getDataBlock().getName();
           targetObjectId = %object;
           targetClientId = -1;
           offense = false;
           equipment = "RepairPack";
	        buyEquipmentSet = "MediumRepairSet";
           location             = %object.getWorldBoxCenter();
           position	     = %object.getWorldBoxCenter();
           group = %set;
   };

   $ObjectiveQ[%team].add(%repairVPad);
   %set.add(%repairVPad);
}

function addVPadDestroyObjective(%object, %team)
{
   if (!isObject("T" @ %team @ "VPadAttackSet"))
   {
      %set = new SimGroup("T" @ %team @ "VPadAttackSet");
      MissionCleanup.add(%set);
   }
   else
      %set = nameToId("T" @ %team @ "VPadAttackSet");


   //if (%object.pad.aiCanMortar || %object.vStation.aiCanMortar)
   if (%object.pad.aiCanMortar)
   {
      //create the mortar objective
      %destroyVPad = new AIObjective(AIOMortarObject)
      {
              dataBlock = "AIObjectiveMarker";
              weightLevel1 = $AIWeightMortarTurret[1];
              //weightLevel2 = 0;
              description = "Mortar the " @ %object.getDataBlock().getName();
              targetObject = %object.getDataBlock().getName();
              targetObjectId = %object;
              targetClientId = -1;
              offense = true;
              equipment = "Mortar MortarAmmo";
	      buyEquipmentSet = "HeavyAmmoSet";
              location             = %object.getWorldBoxCenter();
              position	     = %object.getWorldBoxCenter();
              group = %set;
      };
   }
   else
   {
      //create the destroy objective
      %destroyVPad = new AIObjective(AIODestroyObject)
      {
              dataBlock = "AIObjectiveMarker";
              weightLevel1 = $AIWeightAttackGenerator[1];
              //weightLevel2 = 0;
              description = "Destroy the " @ %object.getDataBlock().getName();
              targetObject = %object.getDataBlock().getName();
              targetObjectId = %object;
              targetClientId = -1;
              offense = true;
              desiredEquipment = "Plasma PlasmaAmmo";
	      buyEquipmentSet = "HeavyAmmoSet";
              location             = %object.getWorldBoxCenter();
              position	     = %object.getWorldBoxCenter();
              group = %set;
      };
   }

   $ObjectiveQ[%team].add(%destroyVPad);
   %set.add(%destroyVPad);   
}

//---------------------------------------------------------------- fix consol spam here for CTF Game
function CTFGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement)
{
// is this a vehicle kill rather than a player kill
    
   // console error message suppression
   if( isObject( %implement ) )
   {
      if( %implement.getDataBlock().getName() $= "AssaultPlasmaTurret" ||  %implement.getDataBlock().getName() $= "BomberTurret" ) // gunner
      {
         %vehicle = %implement.vehicleMounted;
         if(isObject(%vehicle))
         { 
            %clKiller = %implement.vehicleMounted.getMountNodeObject(1).client;
            //error("CTFGame::updateKillScores - Vehicle Turret Killer Here");
         }
         else
         {
            //error("CTFGame::updateKillScores - Vehicle is gone so forget it");
            return;
         }
      }
      else if(%implement.getDataBlock().catagory $= "Vehicles") // pilot
         %clKiller = %implement.getMountNodeObject(0).client;             
   }

   
   botTauntWhine(%clKiller, %clVictim); //make the bot taunt or cry when he dies or kills - roberto


   if(%game.testTurretKill(%implement))   //check for turretkill before awarded a non client points for a kill
   {
      %game.awardScoreTurretKill(%clVictim, %implement);
   }
   else if (%game.testKill(%clVictim, %clKiller)) //verify victim was an enemy
   {
      %value = %game.awardScoreKill(%clKiller);
      %game.shareScore(%clKiller, %value);
      %game.awardScoreDeath(%clVictim);

      if (%game.testGenDefend(%clVictim, %clKiller))
      {
         %game.awardScoreGenDefend(%clKiller);
      }

      if(%game.testCarrierKill(%clVictim, %clKiller))   
      { 
         %game.awardScoreCarrierKill(%clKiller);
      }
      else
      {
         if (%game.testFlagDefend(%clVictim, %clKiller))
         {
            %game.awardScoreFlagDefend(%clKiller);
         }
      }
      if (%game.testEscortAssist(%clVictim, %clKiller))
      {
         %game.awardScoreEscortAssist(%clKiller);     
      }

      rpgKillAward(%clKiller, %clVictim); //award stuff for a pvp kill - roberto 
      //map records awards
      %clKiller.killingSpree++;
      updateRecordsKills(%clKiller, %clKiller.killingSpree);
   }       
   else
   {        
      if (%game.testSuicide(%clVictim, %clKiller, %damageType))  //otherwise test for suicide
      {
         %game.awardScoreSuicide(%clVictim);     
      }
      else
      {
         if (%game.testTeamKill(%clVictim, %clKiller)) //otherwise test for a teamkill
            %game.awardScoreTeamKill(%clVictim, %clKiller);
      }
   }        
}

//fix consol spam
function CTFGame::countFlips(%game)
{
	return true;
}

function CTFGame::countFlipsHeld(%game, %team)
{
	%teamHeld = 0;
	// count how many flipflops each team holds
	%ffSet = nameToID("MissionCleanup/FlipFlops");
	if(%ffSet > 0)
	{
		%numFF = %ffSet.getCount();
		for(%j = 0; %j < %numFF; %j++)
		{
			%curFF = %ffSet.getObject(%j);
			if(%curFF.team == %team)
				%teamHeld++;
		}
	}

	return %teamHeld;
}

// called from player scripts
function DefaultGame::onClientKilled(%game, %clVictim, %clKiller, %damageType, %implement, %damageLocation)
{     
   %plVictim = %clVictim.player;
   %plKiller = %clKiller.player;
   %clVictim.plyrPointOfDeath = %plVictim.position;
   %clVictim.plyrDiedHoldingFlag = %plVictim.holdingFlag;
   %clVictim.waitRespawn = 1;

   cancel( %plVictim.reCloak );
   cancel(%clVictim.respawnTimer);
   %clVictim.respawnTimer = %game.schedule(($Host::PlayerRespawnTimeout * 1000), "forceObserver", %clVictim, "spawnTimeout" );

   // reset the alarm for out of bounds
   if(%clVictim.outOfBounds)
   {
      messageClient(%clVictim, 'EnterMissionArea', "");
   }

   // if (%damageType == $DamageType::suicide)
   // {
   //    %respawnDelay = 10;
   // }
   // else
   // {
      %respawnDelay = 2; //delay here

      //humans have longer spawn delays so bots have time to retrieve the dropped flag- roberto
      if (!%clVictim.isAIControlled())
      {
        %respawnDelay = $Host::HumanRespawnDelay;

        if ( $Host::HumanRespawnDelay $= "" || $Host::HumanRespawnDelay < 0 )
        {
          %respawnDelay = 1; 
        }
      }
   // }


   %game.schedule(%respawnDelay*1000, "clearWaitRespawn", %clVictim);
   // if victim had an undetonated satchel charge pack, get rid of it
   if(%plVictim.thrownChargeId != 0)
      if(!%plVictim.thrownChargeId.kaboom)
         %plVictim.thrownChargeId.delete();

   if(%plVictim.lastVehicle !$= "")
   {
      //lets try a test here to not set schedule if vehicle is destroyed - Lagg... 9/27/2006
      if(isObject(%plVictim.lastVehicle) && %plVictim.lastVehicle.getDamageState() !$= "Destroyed")
      {
         //error("defaultgame.cs - DefaultGame::onClientKilled - we have a vehicle - setting abandontimeout");

         schedule(15000, %plVictim.lastVehicle,"vehicleAbandonTimeOut", %plVictim.lastVehicle);
         %plVictim.lastVehicle.lastPilot = "";
      }
   }   

   // unmount pilot or remove sight from bomber   
   if(%plVictim.isMounted())
   {
      if(%plVictim.vehicleTurret)
         %plVictim.vehicleTurret.getDataBlock().playerDismount(%plVictim.vehicleTurret);
      else
      {
         %plVictim.getDataBlock().doDismount(%plVictim, true);
         %plVictim.mountVehicle = false;
      }
   }

   if(%plVictim.inStation)
      commandToClient(%plVictim.client,'setStationKeys', false);
   %clVictim.camera.mode = "playerDeath";

   // reset who triggered this station and cancel outstanding armor switch thread   
   if(%plVictim.station)
   {
      %plVictim.station.triggeredBy = "";
      %plVictim.station.getDataBlock().stationTriggered(%plVictim.station,0);
      if(%plVictim.armorSwitchSchedule)
         cancel(%plVictim.armorSwitchSchedule);
   }   

   //Close huds if player dies...
   messageClient(%clVictim, 'CloseHud', "", 'inventoryScreen');
   messageClient(%clVictim, 'CloseHud', "", 'vehicleHud');
   commandToClient(%clVictim, 'setHudMode', 'Standard', "", 0);

   // $weaponslot from item.cs
   %plVictim.setRepairRate(0);
   %plVictim.setImageTrigger($WeaponSlot, false);
   
   playDeathAnimation(%plVictim, %damageLocation, %damageType);
   playDeathCry(%plVictim);

   %victimName = %clVictim.name;

   %game.displayDeathMessages(%clVictim, %clKiller, %damageType, %implement);
   %game.updateKillScores(%clVictim, %clKiller, %damageType, %implement);

   // toss whatever is being carried, '$flagslot' from item.cs
   // MES - had to move this to after death message display because of Rabbit game type
   for(%index = 0 ; %index < 8; %index++)
   {
      %image = %plVictim.getMountedImage(%index);
      if(%image)
      {
         if(%index == $FlagSlot)
            %plVictim.throwObject(%plVictim.holdingFlag);
         else 
            %plVictim.throw(%image.item);
      }
   } 

   // target manager update
   setTargetDataBlock(%clVictim.target, 0);
   setTargetSensorData(%clVictim.target, 0);

   // clear the hud
   %clVictim.SetWeaponsHudClearAll();
   %clVictim.SetInventoryHudClearAll();
   %clVictim.setAmmoHudCount(-1);

   // clear out weapons, inventory and pack huds
   messageClient(%clVictim, 'msgDeploySensorOff', "");  //make sure the deploy hud gets shut off 
   messageClient(%clVictim, 'msgPackIconOff', "");  // clear the pack icon

   //clear the deployable HUD
   %plVictim.client.deployPack = false;
   cancel(%plVictim.deployCheckThread);
   deactivateDeploySensor(%plVictim);

   //if the killer was an AI...
   if (isObject(%clKiller) && %clKiller.isAIControlled())
      %game.onAIKilledClient(%clVictim, %clKiller, %damageType, %implement);


   // reset control object on this player: also sets 'playgui' as content
   serverCmdResetControlObject(%clVictim);

   // set control object to the camera   
   %clVictim.player = 0;
   %transform = %plVictim.getTransform();

   //note, AI's don't have a camera...
   if (isObject(%clVictim.camera))
   {
      %clVictim.camera.setTransform(%transform);
      %clVictim.camera.setOrbitMode(%plVictim, %plVictim.getTransform(), 0.5, 4.5, 4.5);
      %clVictim.setControlObject(%clVictim.camera);
   }

   //hook in the AI specific code for when a client dies
   if (%clVictim.isAIControlled())
   {
      aiReleaseHumanControl(%clVictim.controlByHuman, %clVictim);
      %game.onAIKilled(%clVictim, %clKiller, %damageType, %implement);
   }
   else
      aiReleaseHumanControl(%clVictim, %clVictim.controlAI);

   //used to track corpses so the AI can get ammo, etc...
   AICorpseAdded(%plVictim);

   //if the death was a suicide, prevent respawning for 5 seconds...
   %clVictim.lastDeathSuicide = false;
   if (%damageType == $DamageType::Suicide)
   {
      %clVictim.lastDeathSuicide = true;

      %suicideDelay = 1; 
      if (!%clVictim.isAIControlled())
      {
        %suicideDelay = $Host::HumanRespawnDelay;

        if ( $Host::HumanRespawnDelay $= "" || $Host::HumanRespawnDelay < 0 )
        {
          %suicideDelay = 1; 
        }
      }

      %clVictim.suicideRespawnTime = (getSimTime() + %suicideDelay); //  Respawn time = custom 
   }
}

//RPG: Award exp, roll for item drops and level up for a kill - Roberto
function rpgKillAward(%sourceObj, %target)
{
   if ($Host::RPG_Active)
   {
      if (isObject(%target) && isObject(%sourceObj)) //fucking console spam :/
      {
        %sourceIsDeployedTurret = false;

        //if the sourceObj is not directly the %client, but a deployed turret, we make a reference to the turret owner in the %client
        //%The %client gets all the sweet loot, not the %sourceObj
        if (%sourceObj.getClassName() $= "Turret")
        {
          if (isObject(%sourceObj.owner))
          {
            %client = %sourceObj.owner;
            %sourceIsDeployedTurret = true;
          }
          else
          {
            %client = %sourceObj;
          }
        }
        else 
        {
          %client = %sourceObj;
        }

        if (!%client.isAIControlled()) //bots do not have their data saved
        {
          //this will be modified by server exp rates, the armor size of the target, or the type of target if it's not a player, and also active consumable items
          //so modify this if you really wanna mess up with the EXP rates, and don't make it lower than 10
          %expAwarded = 10;  

          %targetTypeBonus = 0; //bonus that depends on the asset or vehicle destroyed, or flag cap or return
          %armorKillBonus = 0; //bonus depending on the enemy's armor size
          %deployedKillBonus = 0; //a kill made by someone's deployed turret
          %killMsg = "";
          %huntersReturn = false;

            //if the target's a player and not an object
            if ( isObject(%target.player) && %target.player.getClassName() $= "Player" )
            {
                //get their level and number of equipped items
                if (%target.isAIControlled())
                {
                  %targetLvl = %target.RPG_AI_lvl;
                  %targetEquip = %target.RPG_AI_equip;
                }
                else
                {
                  %targetLvl = %target.rpgDataSimset.lvl;
                  %targetEquip = %target.rpgDataSimset.equip;
                }

                switch$ (%target.player.getArmorSize()) //bonus exp for tougher enemies
                {
                    case "Light":
                      %killMsg = "[L" @ %targetLvl @ " " @ "E" @ %targetEquip @  "]" @ "Light kill";
                    case "Medium":
                      %armorKillBonus = 0.5;
                      %killMsg = "[L" @ %targetLvl @ " " @ "E" @ %targetEquip @  "]" @ "Medium kill";
                    case "Heavy":
                      %armorKillBonus = 1.0;
                      %killMsg = "[L" @ %targetLvl @ " " @ "E" @ %targetEquip @  "]" @ "Heavy kill";
                }
            }
            else //Else if it's a deployable, vehicle, flag, or base asset... Assets will decrease exp, vehicles/capping will give exp bonus.
            {
               %targetName = %target.getDataBlock().getName();
               switch$ ( %targetName )  
               {
                  case "GeneratorLarge" or "SolarPanel":
                  	if (Game.class !$= "HuntersGame" && Game.class !$= "TeamHuntersGame" && Game.class !$= "RabbitGame" && Game.class !$= "DMGame")
                  	{
	                    if (%target.team == %sourceObj.team) //if it was a repair
	                    {
	                      %targetTypeBonus = -0.2; //only 80% EXP from a normal kill 
	                      %killMsg = "Generator repaired";
	                    }
	                    else //else it was a destroy 
	                    {
	                      %targetTypeBonus = -0.2; //only 80% EXP from a normal kill 
	                      %killMsg = "Generator destroyed";
	                    }
	                }
	                else
	                {
	                	return;
	                }
                  case "AssaultVehicle" or "ScoutFlyer" or "ScoutVehicle": 
                      %targetTypeBonus = 0.6; //60% bonus for tanks, wildcats, shrikes
                      %killMsg = "Medium vehicle destroyed";
                  case "BomberFlyer" or "HAPCFlyer":
                      %targetTypeBonus = 0.8; //80% bonus for bombers and havocs
                      %killMsg = "Heavy vehicle destroyed";
                  case "MobileBaseVehicle":
                      %targetTypeBonus = 1.2; //120% bonus for MPB
                      %killMsg = "MPB destroyed";
                  case "Flag":
                      if ( $TeamFlag[%client.team].isHome && %client.player.holdingFlag !$= "" ) 
                      {
                        %targetTypeBonus = 2.0; //200% bonus for a flag cap
                        %killMsg = "Captured flag";
                      }
                      else //it's just a flag return
                      {
                        %targetTypeBonus = 0.2; //20% bonus for flag return
                        %killMsg = "Returned flag";
                      }
                  case "Flipflop":
                      if (Game.class $= "CTFGame")
                      {
                        %targetTypeBonus = -0.5; //50% LESS 
                        %killMsg = "Captured flipflop";
                      }
                      else if (Game.class $= "SiegeGame")
                      {
                        %targetTypeBonus = 0.5; //50% bonus
                        %killMsg = "Captured flipflop";
                      }
                      else if (Game.class $= "CnHGame")
                      {
                        %targetTypeBonus = -0.5; //50% LESS
                        %killMsg = "Captured flipflop";
                      }
                  case "Nexus":
                      if (Game.class $= "HuntersGame" || Game.class $= "TeamHuntersGame")
                      {
                        %huntersReturn = true;
                        %expAwarded = %client.flagCount * 2; //2 EXP per flag the hunter holds
                        %killMsg = "Returned " @ %client.flagCount @ " flags";
                      }
                  default:
                  	if (Game.class !$= "HuntersGame" && Game.class !$= "TeamHuntersGame" && Game.class !$= "RabbitGame" && Game.class !$= "DMGame")
                  	{
	                    if (%target.team == %sourceObj.team) //if it was a repair
	                    {
	                      %targetTypeBonus = -0.8; 
	                      %killMsg = "Asset repaired";
	                    }
	                    else //it was a destroy
	                    {
	                      %targetTypeBonus = -0.8; //deployables and other base assets get you only 20% EXP of a normal kill
	                      %killMsg = "Asset destroyed";
	                    }
                	}
                	else
                	{
                		return;
                	}
               }
            }

            //less exp if it's a kill made by a deployed turret
            if (%sourceIsDeployedTurret)
            {
              if (%targetTypeBonus >= 0) //90% less than a normal kill IF the value would not be too low
              {
                %deployedKillBonus = -0.9; 
              }
              %killMsg = (%killMsg @ " by deployed turret");
            }

            //if the target is a deployable or vehicle then it has an "rpgLvl" level to display
            if (%target.rpgLvl > 0)
            {
              %upgradeText = "";

              if (%target.rpgLvl * 0.02 != %target.rpgTotalHpMultiplier)
              {
                %upgradeText = "Upgraded ";
              }
              if (%target.rpgLvl * 0.02 != %target.rpgTotalDmgMultiplier)
              {
                %upgradeText = "Upgraded ";
              }
              if (%target.rpgLvl * 0.02 != %target.rpgTotalVehEngrMultiplier)
              {
                %upgradeText = "Upgraded ";
              }

              %killMsg = "[L." @ %target.rpgLvl @ "]" @ %upgradeText @ %killMsg;
            }

            //the event multipliers
            %rpgEventSmallExpRate = 1;
            %rpgEventBigExpRate = 1;

            if ($RPG_Event_Active_Big_Exp)
            {
              %rpgEventBigExpRate += $Host::RPG_Event_Big_Exp_Rate;
            }
            if ($RPG_Event_Active_Small_Exp)
            {
              %rpgEventSmallExpRate += $Host::RPG_Event_Small_Exp_Rate;
            }

            %expMultiplier = ( (%targetTypeBonus + %armorKillBonus + %deployedKillBonus + 1) * (%client.rpgDataSimset.exp_multiplier_from_consumable + 1) * $Host::RPG_Exp_Rate * %rpgEventSmallExpRate * %rpgEventBigExpRate);
            %finalExpAward = mFloor(%expAwarded  * %expMultiplier); //only allow integers
            %client.rpgDataSimset.exp += %finalExpAward;

          //if we leveled up
          if (%client.rpgDataSimset.exp >= %client.rpgDataSimset.exp_till_next_lvl && %client.rpgDataSimset.lvl < $RPG_Max_Player_lvl) 
          {
             rpgUpdateStats(%client);
             rpgUpdateName(%client);
             rpgUpdateTopThree(%client);

             %rewardMsg = ". \nReward: +2% weapon Damage & Health!";
             %rewardLineCount = 2;
             %rewardMsgDuration = 6;

             //Every 5 levels we show the deployables and vehicles get 20% better
             if ( (%client.rpgDataSimset.lvl % 5) == 0 )
             {
                %rewardMsg = ". \nReward: +2% weapon Damage & Health!\n+10% vehicle/deployable Damage & Health";
                %rewardLineCount = 3;
                %rewardMsgDuration = 9;
             }

             bottomPrint(%client, "<color:00f1ff>\You are now level " @ %client.rpgDataSimset.lvl @ %rewardMsg, %rewardMsgDuration, %rewardLineCount);
             messageClient( %client, 'MsgClient', "\c2Level up!\c4 You are now level " @  %client.rpgDataSimset.lvl @ ". Press [Beacon Key] to see your stats.~wfx/misc/flagcapture.wav");
             messageAllExcept(%client, -1, 'MsgClient', getTaggedString(%client.name) @ 'leveled up to lvl ' @ %client.rpgDataSimset.lvl @ ".");  //why not brag to others too? ;)
          }
          else //item rolls only when we don't level up because we can't show two bottomprints
          {
            if (%client.rpgDataSimset.lvl >= $RPG_Max_Player_lvl)
            {
              messageClient( %client, 'MsgClient', "\c2" @ %killMsg @ "\c4. Max lvl.\c2 Equipment parts: " @ %client.rpgDataSimset.equip @ "/" @ $totalRpgEquipItems);
            }
            else
            {
              messageClient( %client, 'MsgClient', "\c2" @ %killMsg @ "\c4 +" @ %finalExpAward @ " EXP.\c2 Current EXP: " @ %client.rpgDataSimset.exp @ " / " @ %client.rpgDataSimset.exp_till_next_lvl);
            }
             
             //Item roll! A Light kill gives us 0 bonus EXP multiplier, so it'll also give us a normal drop rate multiplier. A heavy gives us a x2 drop rate multiplier.
             %dropRateMultiplier = %targetTypeBonus + %armorKillBonus + %deployedKillBonus + 1;

			if (%huntersReturn)
			{
				%dropRateMultiplier = (-0.97 + (%client.flagCount * 0.03)); //3% multiplier per flag
			}

             rpgItemRoll(%client, %dropRateMultiplier, true, true);
          }

          $RPGStartSaving = 1;
        } //end
      }
   }
}

//used when leveling up, getting a consumable or an equip, etc. - roberto
function rpgUpdateStats(%client)
{
  %plSimset = %client.rpgDataSimset;
  %clPlayer = %client.player;

  //level up if needed
  if (%plSimset.exp >= %plSimset.exp_till_next_lvl && %plSimset.lvl < $RPG_Max_Player_lvl) 
  {
    %plSimset.lvl += 1;
    %plSimset.exp = 0;
    %plSimset.exp_till_next_lvl = mFloor(%plSimset.exp_till_next_lvl * 1.1);
  }
  
  //after max lvl, stop displaying EXP needed
  if (%plSimset.lvl >= $RPG_Max_Player_lvl)
  {
  	%plSimset.exp_till_next_lvl = 0;
  }

  %plSimset.max_hp_multiplier_from_lvl = %plSimset.lvl * 0.02;
  %plSimset.total_hp_multiplier = %plSimset.max_hp_multiplier_from_lvl + %plSimset.max_hp_multiplier_from_consumable + %plSimset.max_hp_multiplier_from_equip;
  %plSimset.max_dmg_multiplier_from_lvl = %plSimset.lvl * 0.02;
  %plSimset.total_dmg_multiplier = %plSimset.max_dmg_multiplier_from_lvl + %plSimset.max_dmg_multiplier_from_consumable + %plSimset.max_dmg_multiplier_from_equip;

  %plSimset.total_dmg_vs_light = %plSimset.dmg_vs_light_from_equip + %plSimset.dmg_vs_light_from_consumable;
  %plSimset.total_dmg_vs_medium = %plSimset.dmg_vs_medium_from_equip + %plSimset.dmg_vs_medium_from_consumable;
  %plSimset.total_dmg_vs_heavy = %plSimset.dmg_vs_heavy_from_equip + %plSimset.dmg_vs_heavy_from_consumable;

  if (%clPlayer.getInventory("EnergyPack") > 0)
  {
    %finalRecharge = ( (%clPlayer.getDataBlock().rechargeRate + 0.15) * (1 + %plSimset.engr_recovery_from_consumable + %plSimset.engr_recovery_from_equip) );
  }
  else
  {
    %finalRecharge = ( %clPlayer.getDataBlock().rechargeRate * (1 + %plSimset.engr_recovery_from_consumable + %plSimset.engr_recovery_from_equip) );
  }
  %clPlayer.setRechargeRate(%finalRecharge);
}


//used when leveling up, getting a consumable or an equip, etc. - roberto
function rpgItemRoll(%client, %dropRateMultiplier, %allowConsum, %allowEquip)
{
  //allowConsum/AllowEquip specifies if we can roll for those items and consumableSuccess/equipSuccess tells us if we landed a lucky roll
  %consumableSuccess = false;
  %equipSuccess = false;

  if (%allowConsum)
  {
    %consDropMultiplier = %dropRateMultiplier;

    if ($RPG_Event_Active_Cons_Drop_Rate)
    {
      %consDropMultiplier *= (1 + $Host::RPG_Event_Cons_Drop_Rate);
      //echo("RPG - 'Increased Consumable Droprate Event' is active. Droprate increased.");

    }

    %finalConsDropRate = $Host::RPG_Consumable_Drop_Rate * %consDropMultiplier * 100; //from 1 to 100

    //if the drop rate would result in no chance at all, increase the rate and the range so we have even a small chance
    %maxRange = 100;
    if (%finalConsDropRate < 1)
    {
    	//make it at least 1 and increase the range
    	%finalConsDropRate *= 10;
    	%maxRange *= 10; 
    }

    %consumableSuccess = %finalConsDropRate >= getRandom(1, %maxRange);
    //error("RPG -Item Roll-Final consumable drop rate- " @ %client.nameBase @ " " @ %finalConsDropRate);

    if (%consumableSuccess)
    {
      %fileFriendlyName = rpgReturnFileFriendlyName(%client.nameBase);
      %plSim = nameToID(%fileFriendlyName @ "_rpgData");

      //how many items are in this category?
      %rpgItemsInCat[0] = 5;
      %rpgItemsInCat[1] = 3;
      %rpgItemsInCat[2] = 2;
      %rpgItemsInCat[3] = 2;
      %rpgItemsInCat[4] = 1;
      %rpgItemsInCat[5] = 4;

      //the type of items we already have, we can only have one type active at the same time
      %categoryCount[0] = 0; //used when buying from inventory
      %categoryCount[1] = 0; //used when spawning a vehicle
      %categoryCount[2] = 0; //used when deploying an item
      %categoryCount[3] = 0; //automatically applied once you get it and deactivated on death (health and damage)
      %categoryCount[4] = 0; //automatically applied once you get it and deactivated on death (exp rate)
      %categoryCount[5] = 0; //automatically applied once you get it and deactivated on death (damage bonus vs player armor)

      //count our items categories first
      if (%plSim.weapon_ammo_from_consumable > 0 || %plSim.extra_grenades_from_consumable > 0 || %plSim.extra_mines_from_consumable > 0 || %plSim.extra_healthkits_from_consumable > 0 || %plSim.engr_recovery_from_consumable > 0)
      {
        %categoryCount[0]++;
      }
      if (%plSim.veh_hp_from_consumable > 0 || %plSim.veh_dmg_from_consumable > 0 || %plSim.veh_engr_recovery_from_consumable > 0)
      {
        %categoryCount[1]++;
      }
      if (%plSim.depl_hp_from_consumable > 0 || %plSim.depl_dmg_from_consumable > 0)
      {
        %categoryCount[2]++;
      }
      if (%plSim.max_hp_multiplier_from_consumable > 0 || %plSim.max_dmg_multiplier_from_consumable > 0)
      {
        %categoryCount[3]++;
      }
      if (%plSim.exp_multiplier_from_consumable > 0)
      {
        %categoryCount[4]++;
      }
      if (%plSim.dmg_vs_light_from_consumable > 0 || %plSim.dmg_vs_medium_from_consumable > 0 || %plSim.dmg_vs_heavy_from_consumable > 0)
      {
        %categoryCount[5]++;
      }

      //a random item in each category, empty if we can't get this type
      %rolledItemName[0] = "";
      %rolledItemName[1] = "";
      %rolledItemName[2] = "";
      %rolledItemName[3] = "";
      %rolledItemName[4] = "";
      %rolledItemName[5] = "";

      %validCategories = ""; //we can get items from these categories
      %validCategoriesCount = 0;

      %rpgTotalCatCount = 6; //how many types of item categories exist

      //now roll for a random item in each category, ONLY if we are allowed to get such an item type
      for (%b = 0; %b < %rpgTotalCatCount; %b++)
      {
        if (%categoryCount[%b] < 1) //if we don't have any items of this type
        {
          %randItemSlot = getRandom(0, %rpgItemsInCat[%b] - 1); //random item slot from this category depending on how many items it has in it
          %rolledItemName[%b] = $consumableList[%b, %randItemSlot]; 
          %validCategories = %validCategories @ %b @ " "; //we can pick this category randomly later
          %validCategoriesCount++;
        }
      }

      //error("RPG -Item Roll-Valid categories-Consumable- " @ %client.nameBase @ " " @ %validCategories);

      //if we can't get any type of item, set it to -1
      if (%validCategoriesCount < 1)
      {
        %rewardedItemName = -1;
      }
      else
      {
        %rolledItemNameSLOT = getWord(%validCategories, getRandom(0, %validCategoriesCount - 1));
        %rewardedItemName = %rolledItemName[%rolledItemNameSLOT];
      }


      // error("%rewardedItemName: " @ %rewardedItemName);
      //echo("%rewardedItemName: " @ %rewardedItemName);
      if (%rewardedItemName >= 0)
      {
        messageClient(%client, 'MsgClient', '~wfx/misc/coin.wav');
        %itmMsg = "";

        switch$ (%rewardedItemName)
        {
          case "Bullet box":
            %plSim.weapon_ammo_from_consumable = 0.15;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+15% weapon Ammo\n-Activated: After using inventory-";
            %plSim.unused_consumables++;
          case "Grenade belt":
            %plSim.extra_grenades_from_consumable = 2;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+2 extra Grenades\n-Activated: After using inventory-";
            %plSim.unused_consumables++;
          case "Mine belt":
            %plSim.extra_mines_from_consumable = 2;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+2 extra Mines\n-Activated: After using inventory-";
            %plSim.unused_consumables++;
          case "First aid kit":
            %plSim.extra_healthkits_from_consumable = 1;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+1 extra Healthkit\n-Activated: After using inventory";
            %plSim.unused_consumables++;
          case "JetPack fuel":
            %plSim.engr_recovery_from_consumable = 0.15;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+15% faster player Energy Recovery\n-Activated: After using inventory";
            %plSim.unused_consumables++;
          case "Artillery upgrade":
            %plSim.veh_dmg_from_consumable = 0.1;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+10% vehicle Damage\n-Activated: After buying vehicle";
            %plSim.unused_consumables++;
          case "Engine shield":
            %plSim.veh_hp_from_consumable = 0.05;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+5% vehicle Health\n-Activated: After buying vehicle";
            %plSim.unused_consumables++;
          case "Jet fuel":
            %plSim.veh_engr_recovery_from_consumable = 0.15;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+15% faster vehicle Energy Recovery\n-Activated: After buying vehicle";
            %plSim.unused_consumables++;
          case "Turret barrel upgrade":
            %plSim.depl_dmg_from_consumable = 0.2;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+20% deployed Turret Damage\n-Activated: After deploying turret";
            %plSim.unused_consumables++;
          case "Durable casing":
            %plSim.depl_hp_from_consumable = 0.1;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+10% Deployable Health\n-Activated: After deploying";
            %plSim.unused_consumables++;
          case "Damage amplifier":
            %plSim.max_dmg_multiplier_from_consumable = 0.1;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+10% weapon Damage\n-ACTIVE until you die-";
          case "Energy shield":
            %plSim.max_hp_multiplier_from_consumable = 0.05;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+5% Health\n-ACTIVE until you die-";
          case "Anabolic Steroids":
            %plSim.exp_multiplier_from_consumable = 0.25;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+25% EXP rate\n-ACTIVE until you die-";
          case "Decent bullets":
            %plSim.dmg_vs_light_from_consumable = 0.05;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+5% weapon Damage VS Light armor\n-ACTIVE until you die-";
          case "Better bullets":
            %plSim.dmg_vs_medium_from_consumable = 0.05;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+5% weapon Damage VS Medium armor\n-ACTIVE until you die-";
          case "Hardened bullets":
            %plSim.dmg_vs_heavy_from_consumable = 0.05;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+5% weapon Damage VS Heavy armor\n-ACTIVE until you die-";
          case "Armor-piercing bullets":
            %plSim.dmg_vs_light_from_consumable = 0.05;
            %plSim.dmg_vs_medium_from_consumable = 0.05;
            %plSim.dmg_vs_heavy_from_consumable = 0.05;
            %itmMsg = "<color:ffff00>\You got a consumable item: [" @ %rewardedItemName @ "]\n+5% weapon Damage VS all armor types\n-ACTIVE until you die-";
        }

        bottomPrint(%client, %itmMsg, 9, 3);
        error("RPG -Consumable item drop- " @ %client.nameBase @ " received: " @ %rewardedItemName);

        $RPGStartSaving = 1;
        rpgUpdateStats(%client);
        rpgUpdateTopThree(%client);
      }
      // else
      // {
      //   echo("Consumable item drop was successful but desired category is full.");
      // }
    } 
  }
  //-----------------------------------------------------
  //if we failed to get a consumable try getting a PERMANENT EQUIPMENT... at least until your stats are reset :)
  if (%allowEquip && !%consumableSuccess)
  {
    %equipDropMultiplier = %dropRateMultiplier;

    if ($RPG_Event_Active_Perm_Drop_rate)
    {
      %equipDropMultiplier *= (1 + $Host::RPG_Event_Equip_Drop_Rate);
      //echo("RPG - 'Increased Permanent Item Droprate Event' is active. Droprate increased.");

    }

    %finalEquipDropRate = $Host::RPG_Equip_Drop_Rate * %equipDropMultiplier * 100; //from 1 to 100

    //if the drop rate would result in no chance at all, increase the rate and the range so we have even a small chance
    %maxRange = 100;
    if (%finalEquipDropRate < 1)
    {
    	//make it at least 1 and increase the range
    	%finalEquipDropRate *= 10;
    	%maxRange *= 10; 
    }

    %equipSuccess = (%finalEquipDropRate >= getRandom(1, %maxRange));

    //error("RPG -Item Roll-Final equip drop rate- " @ %client.nameBase @ " " @ %finalEquipDropRate);

    if (%equipSuccess)
    {
      %fileFriendlyName = rpgReturnFileFriendlyName(%client.nameBase);
      %plSim = nameToID(%fileFriendlyName @ "_rpgData");

      %validItems = ""; //we can only get one of these items because we don't have it already
      %validItemsCount = 0;

      if (%plSim.owned_equip_0 $= "0") {%validItems = %validItems @ "0 "; %validItemsCount++;}
      if (%plSim.owned_equip_1 $= "0") {%validItems = %validItems @ "1 "; %validItemsCount++;}
      if (%plSim.owned_equip_2 $= "0") {%validItems = %validItems @ "2 "; %validItemsCount++;}
      if (%plSim.owned_equip_3 $= "0") {%validItems = %validItems @ "3 "; %validItemsCount++;}
      if (%plSim.owned_equip_4 $= "0") {%validItems = %validItems @ "4 "; %validItemsCount++;}
      if (%plSim.owned_equip_5 $= "0") {%validItems = %validItems @ "5 "; %validItemsCount++;}
      if (%plSim.owned_equip_6 $= "0") {%validItems = %validItems @ "6 "; %validItemsCount++;}
      if (%plSim.owned_equip_7 $= "0") {%validItems = %validItems @ "7 "; %validItemsCount++;}
      if (%plSim.owned_equip_8 $= "0") {%validItems = %validItems @ "8 "; %validItemsCount++;}
      if (%plSim.owned_equip_9 $= "0") {%validItems = %validItems @ "9 "; %validItemsCount++;}
      if (%plSim.owned_equip_10 $= "0") {%validItems = %validItems @ "10 "; %validItemsCount++;}
      if (%plSim.owned_equip_11 $= "0") {%validItems = %validItems @ "11 "; %validItemsCount++;}
      if (%plSim.owned_equip_12 $= "0") {%validItems = %validItems @ "12 "; %validItemsCount++;}
      if (%plSim.owned_equip_13 $= "0") {%validItems = %validItems @ "13 "; %validItemsCount++;}
      if (%plSim.owned_equip_14 $= "0") {%validItems = %validItems @ "14 "; %validItemsCount++;}
      if (%plSim.owned_equip_15 $= "0") {%validItems = %validItems @ "15 "; %validItemsCount++;}
      if (%plSim.owned_equip_16 $= "0") {%validItems = %validItems @ "16 "; %validItemsCount++;}
      if (%plSim.owned_equip_17 $= "0") {%validItems = %validItems @ "17 "; %validItemsCount++;}
      if (%plSim.owned_equip_18 $= "0") {%validItems = %validItems @ "18 "; %validItemsCount++;}
      if (%plSim.owned_equip_19 $= "0") {%validItems = %validItems @ "19 "; %validItemsCount++;}

      //error("RPG -Item Roll-Valid items-Equip- " @ %client.nameBase @ " " @ %validItems);

      //if we can't get any type of item, set it to -1
      if (%validItemsCount < 1)
      {
        %rewardedItemName = -1;
      }
      else
      {
        %rolledItemNameSLOT = getWord(%validItems, getRandom(0, %validItemsCount - 1));
        %rewardedItemName = $equipList[%rolledItemNameSLOT];
      }

      if (%rewardedItemName >= 0)
      {
        %plSim.equip++;
        messageClient(%client, 'MsgClient', '~wgui/vote_pass.wav');
        %itmMsg = "";

        switch$ (%rewardedItemName)
        {
          case "Titanium breastplate":
            %plSim.owned_equip_0 = 1;
            %plSim.max_hp_multiplier_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% Health\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Steel gauntlets":
            %plSim.owned_equip_1 = 1;
            %plSim.max_dmg_multiplier_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% weapon Damage\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Diamond earrings":
            %plSim.owned_equip_2 = 1;
            %plSim.max_dmg_multiplier_from_equip += 0.05;
            %plSim.veh_dmg_from_equip += 0.05;
            %plSim.depl_dmg_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% weapon/vehicle/deployable Damage\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Iron boots":
            %plSim.owned_equip_3 = 1;
            %plSim.depl_dmg_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% deployed turret Damage\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Iron helmet":
            %plSim.owned_equip_4 = 1;
            %plSim.depl_hp_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% deployable Health\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Titanium Tasset":
            %plSim.owned_equip_5 = 1;
            %plSim.veh_hp_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% vehicle Health\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Carbon fiber gloves":
            %plSim.owned_equip_6 = 1;
            %plSim.veh_dmg_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% vehicle Damage\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Silver Bracelet":
            %plSim.owned_equip_7 = 1;
            %plSim.veh_engr_recovery_from_equip = 0.1;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+10% faster vehicle Energy Recovery\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "High-quality jetpack":
            %plSim.owned_equip_8 = 1;
            %plSim.engr_recovery_from_equip = 0.1;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+10% faster player Energy Recovery\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Silver ring":
            %plSim.owned_equip_9 = 1;
            %plSim.extra_mines_from_equip = 1;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+1 extra Mine\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Gold ring":
            %plSim.owned_equip_10 = 1;
            %plSim.extra_grenades_from_equip = 1;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+1 extra Grenade\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Expensive necklace":
            %plSim.owned_equip_11 = 1;
            %plSim.weapon_ammo_from_equip = 0.15;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+15% weapon Ammo\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Tribal shield":
            %plSim.owned_equip_12 = 1;
            %plSim.max_hp_multiplier_from_equip += 0.05;
            %plSim.max_dmg_multiplier_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% Health & Damage\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Quality engine":
            %plSim.owned_equip_13 = 1;
            %plSim.veh_hp_from_equip += 0.05;
            %plSim.veh_dmg_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% vehicle Health & Damage\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Advanced turret":
            %plSim.owned_equip_14 = 1;
            %plSim.depl_hp_from_equip += 0.05;
            %plSim.depl_dmg_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% turret Health & Damage\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Fancy glasses":
            %plSim.owned_equip_15 = 1;
            %plSim.max_hp_multiplier_from_equip += 0.05;
            %plSim.veh_hp_from_equip += 0.05;
            %plSim.depl_hp_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% player/vehicle/deployable Health\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Small weapon upgrade":
            %plSim.owned_equip_16 = 1;
            %plSim.dmg_vs_light_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% weapon Damage VS Light armor\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Medium weapon upgrade":
            %plSim.owned_equip_17 = 1;
            %plSim.dmg_vs_medium_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% weapon Damage VS Medium armor\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Big weapon upgrade":
            %plSim.owned_equip_18 = 1;
            %plSim.dmg_vs_heavy_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% weapon Damage VS Heavy armor\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
          case "Ultimate weapons":
            %plSim.owned_equip_19 = 1;
            %plSim.dmg_vs_light_from_equip += 0.05;
            %plSim.dmg_vs_medium_from_equip += 0.05;
            %plSim.dmg_vs_heavy_from_equip += 0.05;
            %itmMsg = "<color:f1ff00>\You got a permanent item: [" @ %rewardedItemName @ "]\n+5% weapon Damage VS all armor types\nEquipment parts: " @ %plSim.equip @ "/" @ $totalRpgEquipItems;
        }

        if (%dropRateMultiplier == 999) //it was a Top 3 award
        {
          %plSim.has_equip_award--;
          %awardMessage = "<color:00f1ff>\Congratulations!\nYou got an Equipment part for being in last week's TOP 3 scoreboard.";
          bottomPrint(%client, %awardMessage, 8, 2);

          schedule(10000, 0, "bottomPrint", %client, %itmMsg, 15, 3);
          error("-RPG- " @ %client.nameBase @ " received an award for being in TOP 3 last time.");

          //award another item if needed
          if (%plSim.has_equip_award > 0)
          {
           schedule(28000, 0, "rpgItemRoll", %client, 999, false, true);
           error("Giving " @ %client.nameBase @ " ANOTHER equipment award in 28 seconds.");
          }
        }
        else
        {
          bottomPrint(%client, %itmMsg, 15, 3);
        }

        error("RPG -Equipment item drop- " @ %client.nameBase @ " received a 7 day item: " @ %rewardedItemName);

        $RPGStartSaving = 1;
        rpgUpdateStats(%client);
        rpgUpdateTopThree(%client);
      }
    } 
  }
}

//----------------------------------------------------------------------------------------- end package LaggsDefault5_GameType ---***---
};

function rpgUpdateTopThree(%client)
{
  //don't add us to the top 3 if we need a reset (if the server allows reset)
  if ( (%client.rpgDataSimset.last_reset_day !$= $Host::RPG_Reset_Day) && $Host::RPG_Allow_Top_Players_Reset )
  {
     return;
  }

  %fileFriendlyName = rpgReturnFileFriendlyName(%client.nameBase);

  %datReference[0, 0] = $rpgStatsSim.rpgTopData0_0;
  %datReference[0, 1] = $rpgStatsSim.rpgTopData0_1;
  %datReference[0, 2] = $rpgStatsSim.rpgTopData0_2;

  %datReference[1, 0] = $rpgStatsSim.rpgTopData1_0;
  %datReference[1, 1] = $rpgStatsSim.rpgTopData1_1;
  %datReference[1, 2] = $rpgStatsSim.rpgTopData1_2;

  %datReference[2, 0] = $rpgStatsSim.rpgTopData2_0;
  %datReference[2, 1] = $rpgStatsSim.rpgTopData2_1;
  %datReference[2, 2] = $rpgStatsSim.rpgTopData2_2;

  //Remember that the 4th player in the array is the %client
  %datReference[3, 0] = %fileFriendlyName;
  %datReference[3, 1] = %client.rpgDataSimset.lvl;
  %datReference[3, 2] = %client.rpgDataSimset.equip;

  for (%i = 0; %i < 3; %i++) //loop 3 times in total so the fourth player (the client) can get to the first place
  {

    for (%b = 4; %b > 0; %b--) //loop 4 times, 3 through the existing top 3 and 1 for the new client
    {
      //If we qualify for this position but we're already registered in a higher slot, don't register again
      %canRegister = !( (%b == 2 && (%datReference[1, 0] $= %fileFriendlyName || %datReference[0, 0] $= %fileFriendlyName)) || (%b == 1 && %datReference[0, 0] $= %fileFriendlyName) || (%b == 3 && (%datReference[2, 0] $= %fileFriendlyName || %datReference[1, 0] $= %fileFriendlyName || %datReference[0, 0] $= %fileFriendlyName)) );

      //if the level of the current player is higher than the level of the player above and that player is not us, again
      if ( (%datReference[%b, 1] > %datReference[%b - 1, 1]) && (%datReference[%b, 0] !$= %datReference[%b - 1, 0]) && %canRegister)
      {
        //store the temp data of the soon to be replaced player
        %tempData[0] = %datReference[%b - 1, 0];
        %tempData[1] = %datReference[%b - 1, 1];
        %tempData[2] = %datReference[%b - 1, 2];
        //go up in the list
        %datReference[%b - 1, 0] = %datReference[%b, 0];
        %datReference[%b - 1, 1] = %datReference[%b, 1];
        %datReference[%b - 1, 2] = %datReference[%b, 2];
        //and put the replaced player in our previous position
        %datReference[%b, 0] = %tempData[0];
        %datReference[%b, 1] = %tempData[1];
        %datReference[%b, 2] = %tempData[2];
      }
      //if we have equal levels and that player above is not us, the one with more permanent equipment wins
      else if ( %datReference[%b, 1] == %datReference[%b - 1, 1] && (%datReference[%b, 0] !$= %datReference[%b - 1, 0]) && %canRegister) 
      {
        if ( %datReference[%b, 2] > %datReference[%b - 1, 2] ) //if we have more equips...
        {
          //store the temp data of the soon to be replaced player
          %tempData[0] = %datReference[%b - 1, 0];
          %tempData[1] = %datReference[%b - 1, 1];
          %tempData[2] = %datReference[%b - 1, 2];
          //go up in the list
          %datReference[%b - 1, 0] = %datReference[%b, 0];
          %datReference[%b - 1, 1] = %datReference[%b, 1];
          %datReference[%b - 1, 2] = %datReference[%b, 2];
          //and put the replaced player in our previous position
          %datReference[%b, 0] = %tempData[0];
          %datReference[%b, 1] = %tempData[1];
          %datReference[%b, 2] = %tempData[2];
        }
      }
      //else just update our level and equipment if the player above is us and we're in the list
      else if (%fileFriendlyName $= %datReference[%b - 1, 0])
      {
        %datReference[%b - 1, 1] = %client.rpgDataSimset.lvl; 
        %datReference[%b - 1, 2] = %client.rpgDataSimset.equip; 
      }
    }
  }

  $rpgStatsSim.rpgTopData0_0 = %datReference[0, 0];
  $rpgStatsSim.rpgTopData0_1 = %datReference[0, 1];
  $rpgStatsSim.rpgTopData0_2 = %datReference[0, 2];
  $rpgStatsSim.rpgTopData1_0 = %datReference[1, 0];
  $rpgStatsSim.rpgTopData1_1 = %datReference[1, 1];
  $rpgStatsSim.rpgTopData1_2 = %datReference[1, 2];
  $rpgStatsSim.rpgTopData2_0 = %datReference[2, 0];
  $rpgStatsSim.rpgTopData2_1 = %datReference[2, 1];
  $rpgStatsSim.rpgTopData2_2 = %datReference[2, 2];
  $rpgStatsSim.rpgTopData3_0 = %datReference[3, 0];
  $rpgStatsSim.rpgTopData3_1 = %datReference[3, 1];
  $rpgStatsSim.rpgTopData3_2 = %datReference[3, 2];

  $RPGUpdateTopPlayers = true;
}

function botTauntWhine(%clKiller, %clVictim)
{
   %chance = ( 1 - ($HostGamePlayerCount / 100) - 0.57 );

   if (%chance < 0.06) { %chance = 0.06; }
   if (%chance > 0.27) { %chance = 0.27; }

   %shouldChatTaunt = getRandom();
   %shouldChatLose = getRandom();
   %tauntVoiceChance = %chance;
   %loseVoiceChance = (%tauntVoiceChance * 2);

   if (%shouldChatTaunt <= %tauntVoiceChance && isObject(%clKiller) && isObject(%clVictim)) 
   {
   	  if (%clKiller.isAIControlled() && %clVictim.isAIControlled())
   	  {
   	   	if (%clKiller.randomNameIndex !$= %clVictim.randomNameIndex) //don't taunt ourselves
   	   	{

          %finalName = getTaggedString(%clVictim.name);
          if ($Host::RPG_Active)
          {
            //cut the "LV.  " part from the name
            %finalName = getSubStr(%finalName, 6, 99);
          }

    			%text[0] = "Awww, poor little " @ %finalName @ " can barely dodge, ha ha ~wgbl.aww";
    			%text[1] = "Is that all you got, " @ %finalName @ "?  ~wgbl.aww";
    			%text[2] = "Next time try using your brain, " @ %finalName @ "  ~wgbl.brag";
    			%text[3] =  %finalName @ " was just... OWNED! ~wgbl.brag";
    			%text[4] = "Good game, " @ %finalName @ "!  ~wgbl.goodgame";
    			%text[5] = "That was fun, " @ %finalName @ "  ~wgbl.goodgame";
    			%text[6] = "Ha ha ha! ~wgbl.obnoxious";
    			%text[7] = "LOL ~wgbl.obnoxious";
    			%text[8] = "Too bad ~wgbl.aww";
    			%text[9] = "You suck, " @ %finalName @ "  ~wgbl.brag";
    			%text[10] = "You're really good at being terrible, " @ %finalName @ "  ~wgbl.sarcasm";
    			%text[11] = "When are you gonna get some skills, " @ %finalName @ "?  ~wgbl.when";
    			%text[12] = "When are you gonna be a challenge?  ~wgbl.when";
    			%text[13] = "Anytime... " @ %finalName @ " :)  ~wgbl.anytime";
    			%text[14] = "I am the greatest!  ~wgbl.brag";
    			%randText = mFloor(getRandom(0, 14.5));
    			cannedChatMessageAll(%clKiller, '\c4%1: %2', %clKiller.name, %text[%randText]);
	    }
	  }
   }
   else if (%shouldChatLose > %tauntVoiceChance && %shouldChatLose <= %loseVoiceChance && isObject(%clKiller) && isObject(%clVictim))
   {
   	  if (%clKiller.isAIControlled() && %clVictim.isAIControlled()) 
   	  {
   	   	if (%clKiller.randomNameIndex !$= %clVictim.randomNameIndex) //don't congratulate ourselves
   	   	{

          %finalName = getTaggedString(%clKiller.name);
          if ($Host::RPG_Active)
          {
            //cut the "LV.  " part from the name
            %finalName = getSubStr(%finalName, 6, 99);
          }

    			%text[0] = "I don't know... ~wgbl.dunno";
    			%text[1] = "Shazbot! ~wgbl.shazbot";
    			%text[2] = "Nice shot, " @ %finalName @ "! ~wgbl.shooting";
    			%text[3] = "Woohoo! ~wgbl.woohoo";
    			%text[4] = "Oops. ~wgbl.oops";
    			%text[5] = "Awwwwwwwrrrrr! ~wavo.deathcry_01";
    			%text[6] = "Aaaaaahhhhhhh! ~wavo.deathcry_02";
    			%text[7] = "Shazbot! ~wgbl.shazbot"; //another shazbot
    			%text[8] = "Shazbot! ~wgbl.shazbot"; //another shazbot
    			%text[9] = "Shazbot! ~wgbl.shazbot"; //another shazbot
    			%text[10] = "Oops. ~wgbl.oops";
    			%text[11] = "Awesome! ~wgbl.awesome";
    			%text[12] = "Nice move, " @ %finalName @ "!  ~wgbl.nice";
    			%text[13] = "Quiet!  ~wgbl.quiet";
    			%text[14] = "You rock, " @ %finalName @ "!  ~wgbl.rock";
    			%randText = mFloor(getRandom(0, 14.5));
    			cannedChatMessageAll(%clVictim, '\c4%1: %2', %clVictim.name, %text[%randText]);
	    }
	  }
   }
}
