//-------------------------------------------------------
//put everything back to default at mission end - Lagg...

function DefaultGame::gameOver( %game )
{
   //set the bool
   $missionRunning = false;

   if ($Host::MapRecords) { SaveMapRecords(); }

   //cancel any respawning vehicle threads - Lagg... 5-6-2005
   %group = nameToId("MissionCleanUp"); 
   for (%i = 0; %i < %group.getCount(); %i ++)
   {
      %obj = %group.getObject(%i);
      %name = %obj.getName();

      if(%name $= "PosMarker")
      {
         cancel(%obj.schedule);
         echo("Canceling Vehicle Respawn Thread - Lagg...");
      }
   } 

   CancelCountdown();
   CancelEndCountdown();
   
   //loop through all the clients, and do any cleanup...
   %count = ClientGroup.getCount();
   for (%i = 0; %i < %count; %i++)
   {
      %client = ClientGroup.getObject(%i);
      %player = %client.player;
      %client.lastTeam = %client.team;

      //reset map record vars
      %client.diskMidairs = 0;
      %client.plasmaMidairs = 0;
      %client.blasterMidairs = 0;
      %client.sniperHeadshots = 0;
      %client.killingSpree = 0;
      %client.rabbitKills = 0;
      
      if ( !%client.isAiControlled() )
      {
         %client.recordsMessageCount = 1;
         %client.endMission();
         messageClient( %client, 'MsgClearDebrief', "" );
         %game.sendDebriefing( %client );
         if(%client.player.isBomber)
            commandToClient(%client, 'endBomberSight');

         //clear the score hud...
         messageClient( %client, 'SetScoreHudHeader', "", "" );
         messageClient( %client, 'SetScoreHudSubheader', "", "");
         messageClient( %client, 'ClearHud', "", 'scoreScreen', 0 );
         
         // clean up the players' HUDs:
         %client.setWeaponsHudClearAll();
         %client.setInventoryHudClearAll();
      }
   }

   // Default game does nothing...  except lets the AI know the mission is over
   AIMissionEnd();

   //all this has to be done in the correct order or Crash, Bang, BOOM! $#&%
   error("DefaultGame::gameOver - resetting all files to server defaults");

   exec("scripts/aiSiege.cs");
   exec("scripts/aiCTF.cs");
   exec("scripts/aiDnD.cs");

   //$InvBanList[Siege, "SatchelCharge"] = 0;

   // Load server data blocks
   //exec("scripts/commanderMapIcons.cs");
   //exec("scripts/markers.cs"); 
   //exec("scripts/serverAudio.cs");
   //exec("scripts/damageTypes.cs");
   //exec("scripts/deathMessages.cs");
   //exec("scripts/inventory.cs");
   exec("scripts/camera.cs");
   //exec("scripts/particleEmitter.cs");    // Must exist before item.cs and explosion.cs
   //exec("scripts/particleDummies.cs");
   exec("scripts/projectiles.cs");//- if bots enabled - NOTE        // Must exits before item.cs
   exec("scripts/player.cs");//- if bots enabled - NOTE
   //exec("scripts/gameBase.cs");
   exec("scripts/staticShape.cs");
   //exec("scripts/weapons.cs");
   exec("scripts/turret.cs");
   exec("scripts/weapTurretCode.cs");//- if bots enabled - NOTE
   //exec("scripts/pack.cs");
   //exec("scripts/vehicles/vehicle_spec_fx.cs");    // Must exist before other vehicle files or CRASH BOOM
   exec("scripts/vehicles/serverVehicleHud.cs");
   //exec("scripts/vehicles/vehicle_shrike.cs");
   exec("scripts/vehicles/vehicle_bomber.cs");//- if bots enabled - NOTE
   //exec("scripts/vehicles/vehicle_havoc.cs");
   //exec("scripts/vehicles/vehicle_wildcat.cs");
   exec("scripts/vehicles/vehicle_tank.cs");//- if bots enabled - NOTE
   exec("scripts/vehicles/vehicle_mpb.cs");//- if bots enabled - NOTE
   exec("scripts/vehicles/vehicle.cs");            // Must be added after all other vehicle files or EVIL BAD THINGS
   exec("scripts/ai.cs");//- if bots enabled - NOTE
         //includes - exec("scripts/aiDebug.cs");
         //includes - exec("scripts/aiDefaultTasks.cs");
         //includes - exec("scripts/aiObjectives.cs");
         //includes - exec("scripts/aiInventory.cs");
         //includes - exec("scripts/aiChat.cs");
         //includes - exec("scripts/aiHumanTasks.cs");
         //includes - exec("scripts/aiObjectiveBuilder.cs");
         //includes - exec("scripts/aiBotProfiles.cs");
   //exec("scripts/item.cs");
   exec("scripts/station.cs");
   //exec("scripts/simGroup.cs");
   //exec("scripts/trigger.cs");
   exec("scripts/forceField.cs");
   //exec("scripts/lightning.cs");
   //exec("scripts/weather.cs");
   //exec("scripts/deployables.cs");
   //exec("scripts/stationSetInv.cs");
   //exec("scripts/navGraph.cs");
   //exec("scripts/targetManager.cs");
   //exec("scripts/serverCommanderMap.cs");
   //exec("scripts/environmentals.cs");
   //exec("scripts/power.cs");
   exec("scripts/serverTasks.cs");//- if bots enabled - NOTE
   //exec("scripts/admin.cs");
   //exec("prefs/banlist.cs");

   exec("scripts/hud.cs");
   error("!!! Fixing Hud.cs");

   deactivatePackage(LaggsDefault4_Support);
   error("Deactivating Package LaggsDefault4_Support");

   //we close our last package and we are done :)
   deactivatePackage(LaggsDefault4_GameType);
   error("Deactivating Package LaggsDefault4_GameType");

   //* Can't Use function defaultGame::gameOver in a package w/MapSupportPack in server files *
   exec("scripts/defaultGame.cs");//* HACK ALERT! - We Hacked around MapSupportPack Here :) *

   //NOTE LETS NOT DELETE ANY FILES AND SEE IF WE STILL GET UE
   //error("Cleaning up Lagg's .dso files");
   
   //if (Game.class $= "NoneGame" || $Host::BotsEnabled)
   //{
      //deleteFile("scripts/LaggsDefault4_aiNeedRide.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiPilotShrike.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiDeployVehicle.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiTank.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiBombingRun.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiEasyRider.cs.dso");      
      ////deleteFile("scripts/LaggsDefault4_ai.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiDefaultTasks.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiObjectives.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiInventory.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiChat.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiObjectiveBuilder.cs.dso");
      //deleteFile("scripts/LaggsDefault4_serverTasks.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiVehicle.cs.dso");

      //if (Game.class $= "SiegeGame")
         //deleteFile("scripts/LaggsDefault4_aiSiege.cs.dso");
      //else if (Game.class $= "CTFGame")
         //deleteFile("scripts/LaggsDefault4_aiCTF.cs.dso");
      //else if (Game.class $= "DnDGame")
         //deleteFile("scripts/LaggsDefault4_aiDnD.cs.dso");

      //deleteFile("scripts/LaggsDefault4_projectiles.cs.dso");
      //deleteFile("scripts/LaggsDefault4_player.cs.dso");
      //deleteFile("scripts/LaggsDefault4_turret.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiSupport.cs.dso");
      //deleteFile("scripts/LaggsDefault4_aiVehicleSupport.cs.dso");
   //}

   //deleteFile("scripts/LaggsDefault4_GameType.cs.dso");
   //deleteFile("scripts/LaggsDefault4_vehicle.cs.dso");
   //deleteFile("scripts/LaggsDefault4_camera.cs.dso");
   //deleteFile("scripts/LaggsDefault4_missionOver.cs.dso");    

   error("Come Again Soon - Lagg... :)");
}
