//taken from stations.cs fixes spam when the mpb gets destroyed
function MobileInvStation::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   //echo("MobileInvStation::damageObject");
   //echo("   ");

   //If vehicle station is hit then apply damage to the vehicle
   if (isObject(%targetObject.getObjectMount()))//check if mpb is still there - Lagg... 7-13-2004
      %targetObject.getObjectMount().damage(%sourceObject, %position, %amount, %damageType);
}

//taken from vehicles.cs file. fixes mpb deploy on siege switch sides - Lagg...
function VehicleData::onAdd(%data, %obj)
{
   //error("VehicleData::onAdd - LaggsDefault4_vehicle - " @ %obj.getDataBlock().getName());//debugging purposes - Lagg...

   Parent::onAdd(%data, %obj);
   if((%data.sensorData !$= "") && (%obj.getTarget() != -1))
      setTargetSensorData(%obj.getTarget(), %data.sensorData);
   %obj.setRechargeRate(%data.rechargeRate);

   // set full energy
   %obj.setEnergyLevel(%data.MaxEnergy);

   if(%obj.disableMove)
      %obj.immobilized = true;

   if(%obj.deployed)
   {
      if($countDownStarted)
      {
         //error("VehicleData::onAdd - LaggsDefault4_vehicle -  SCHEDULING a DEPLOY HERE");
         %data.schedule($Host::Siege::Halftime + 6000, "vehicleDeploy", %obj, 0, 1);
      }
      else
      {
         $VehiclesDeploy[$NumVehiclesDeploy] = %obj;
         $NumVehiclesDeploy++;
      }
   }
   if(%obj.mountable || %obj.mountable $= "")
      %data.isMountable(%obj, true);
   else
      %data.isMountable(%obj, false);
   
   %obj.setSelfPowered();
   //%data.canObserve = true;
}

////////////////////////////////////////////////////////////////////////////////
//               Mobile Point Base from classic mod                           //
//                       z0dd - ZOD, 4/24/02                                  //
////////////////////////////////////////////////////////////////////////////////

//allows MPB to deploy closer to objects
function MobileBaseVehicle::checkDeploy(%data, %obj)
{
   //echo("MobileBaseVehicle::checkDeploy");
   //echo("   ");

   %mask = $TypeMasks::VehicleObjectType | $TypeMasks::MoveableObjectType |
           $TypeMasks::StaticShapeObjectType | $TypeMasks::ForceFieldObjectType |
           $TypeMasks::ItemObjectType | $TypeMasks::PlayerObjectType | 
           $TypeMasks::TurretObjectType;

           //| $TypeMasks::StaticTSObjectType | $TypeMasks::InteriorObjectType;

   //%slot 1 = turret   %slot 2 = station
   %height[1] = 0;
   %height[2] = 0;
   %radius[1] = 2.4;
   %radius[2] = 2.4;
   %stationFailed = false;
   %turretFailed = false;
   
   for(%x = 1; %x < 3; %x++)
   {
      %posXY = getWords(%obj.getSlotTransform(%x), 0, 1);
      %posZ = (getWord(%obj.getSlotTransform(%x), 2) + %height[%x]);
      InitContainerRadiusSearch(%posXY @ " " @ %posZ, %radius[%x], %mask); 
   
      while ((%objFound = ContainerSearchNext()) != 0)
      {
         if(%objFound != %obj)
         {   
            if(%x == 1)
               %turretFailed = true;   
            else
               %stationFailed = true;   
            break;
         }
      }
   }
   
   //If turret, station or both fail the send back the error message...
   if(%turretFailed &&  %stationFailed)
      return "Both Turret and Station are blocked and unable to deploy.";
   if(%turretFailed)
      return "Turret is blocked and unable to deploy.";
   if(%stationFailed)
      return "Station is blocked and unable to deploy.";

   //Check the station for collision with the Terrain
   %mat = %obj.getTransform();
   for(%x = 1; %x < 7; %x+=2)
   {
      %startPos = MatrixMulPoint(%mat, %data.stationPoints[%x]);
      %endPos = MatrixMulPoint(%mat, %data.stationPoints[%x+1]);

      %rayCastObj = containerRayCast(%startPos, %endPos, $TypeMasks::TerrainObjectType, 0);
      if(%rayCastObj)
         return "Station is blocked by terrain and unable to deploy.";      
   }
   
   return "";   
}

//----------------------------------------------------------------------------------------------- let the mpb deploy next to buildings - Lagg... 7-5-2004
function MobileBaseVehicle::checkTurretDistance(%data, %obj)
{
   //echo("MobileBaseVehicle::checkTurretDistance");
   //echo("   ");

   %pos = getWords(%obj.getTransform(), 0, 2);
   InitContainerRadiusSearch(%pos, 20, $TypeMasks::TurretObjectType); // z0dd - ZOD, 6/21/02. Allow closer deploy. Was 100
   while ((%objFound = ContainerSearchNext()) != 0)
   {
      if(%objFound.getType() & $TypeMasks::TurretObjectType)
      {
         if(%objFound.getDataBlock().ClassName $= "TurretBase")
            return "Turret Base is in the area. Unable to deploy.";
      }
      else
      {
         %subStr = getSubStr(%objFound.interiorFile, 1, 4);
         if(%subStr !$= "rock" && %subStr !$= "spir" && %subStr !$= "misc")
            return "Building is in the area. Unable to deploy.";
      }        
   }
   return "";
}

//this allows modular mpb turret (taken from Classic mod)
function TurretData::replaceCallback(%this, %turret, %engineer)
{  
   // This is a valid replacement.  First, let's see if the engineer
   //  still has the correct pack in place...
   if (%engineer.getMountedImage($BackPackSlot) != 0)
   {
      %barrel = %engineer.getMountedImage($BackPackSlot).turretBarrel;
      if (%barrel !$= "")
      {
         // if there was a barrel there before, get rid of it
         %turret.unmountImage(0);
         // remove the turret barrel pack
         %engineer.setInventory(%engineer.getMountedImage($BackPackSlot).item, 0);
         // mount new barrel on base
         %turret.mountImage(%barrel, 0, false);
         
         // ------------------------------------------
         // z0dd - ZOD, 4/20/02. modular MPB turret
         %turname = %turret.getDatablock().getName();
         if(%turname $= "MobileTurretBase")
         {
            %turret.getObjectMount().barrel = %barrel;
         }
         // ------------------------------------------
      }
      else
      {
         // Player doesn't have the correct pack on...
      }
   }
   else
   {
      // Player doesn't have any pack on...
   }
}

//this allows modular mpb turret (taken from Classic mod)
function checkTurretMount(%data, %obj, %slot)
{
   // search for a turret base in player's LOS
   %eyeVec = VectorNormalize(%obj.getEyeVector());
   %srchRange = VectorScale(%eyeVec, 5.0); // look 5m for a turret base
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potTurret = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::TurretObjectType);
   if(%potTurret != 0)
   {
      %otherMountObj = "foo";

      %name = %potTurret.getDatablock().getName(); // z0dd - ZOD, 4/20/02. modular MPB turret
      if(%name $= "TurretBaseLarge" || %name $= "MobileTurretBase" || %name $= %otherMountObj) // z0dd - ZOD, 4/20/02. modular MPB turret
      {



         // ---------- Turret Lock Code by Byte ----------
         //-----------------------------------------------

         // Original Concept by t-b0n3
         // Come See Us @ irc.dynamix.com #t2mappers
         //
         // to bad they had this in the wrong function and
         // they removed pack from you even if you can't use it.
         // upgraded here - Lagg... 4-7-2005
         //
         // Code allows a Map Maker to select which barrels
         // they want to allow to be placed on each turret, if any.
         // Also, Allows Map Maker to lock turrets, so they can't be changed
         //
         // Turret Dynamics: (add these to the turrets you wish to modify)
         //
         // isPermanent = 0 or 1
         // AARemoved = 0 or 1
         // ElfRemoved = 0 or 1
         // MissileRemoved = 0 or 1
         // PlasmaRemoved = 0 or 1
         // MortarRemoved = 0 or 1
         // TargetAll = 0 or 1

         %barrel = %obj.getMountedImage($BackPackSlot).turretbarrel ;//added - Lagg... 4-4/2005
         %barrelslot = %obj.getMountedImage($BackPackSlot);//added - Lagg... 4-4/2005

         // is turret not to be changed?
         if (%potTurret.isPermanent == "1")
         {
            messageClient(%obj.client, 'MsgClient', '\c2All Barrel change Restricted on this turret.~wfx/powered/station_denied.wav');
            //messageclient(%obj.client, 0, "Sorry, You cannot change Barrels on this turret");
            return;
         }

         // do we want to use AA?
         if (%barrel $= "AABarrelLarge" && %potTurret.AARemoved == "1")
         {
            messageClient(%obj.client, 'MsgClient', '\c2AA Barrel change Restricted on this turret.~wfx/powered/station_denied.wav');
            //messageclient(%obj.client, 0, "Sorry, Can't Use AA on this turret");
            //%obj.setInventory(%obj.getMountedImage($BackPackSlot).item, 0);//stop - Lagg...
	    return;
         }

         // do we want to use Elf?
         if (%barrel $= "ElfBarrelLarge" && %potTurret.ElfRemoved == "1")
         {
            messageClient(%obj.client, 'MsgClient', '\c2Elf Barrel change Restricted on this turret.~wfx/powered/station_denied.wav');
            //messageclient(%obj.client, 0, "Sorry, Can't Use Elf on this turret");
            //%obj.setInventory(%obj.getMountedImage($BackPackSlot).item, 0);//stop - Lagg...
            return;
         }

         // do we want to use Missles?
         if (%barrel $= "MissileBarrelLarge" && %potTurret.MissileRemoved == "1")
         {
            messageClient(%obj.client, 'MsgClient', '\c2Missle Barrel change Restricted on this turret.~wfx/powered/station_denied.wav');
            //messageclient(%obj.client, 0, "Sorry, Can't Use Missles on this turret");
            //%obj.setInventory(%obj.getMountedImage($BackPackSlot).item, 0);//stop - Lagg...
	         return;
         }

         // do we want to use Plasma?
         if (%barrel $= "PlasmaBarrelLarge" && %potTurret.PlasmaRemoved == "1")
         {
            messageClient(%obj.client, 'MsgClient', '\c2Sorry, Plasma Barrel change Restricted on this turret.~wfx/powered/station_denied.wav');
            //messageclient(%obj.client, 0, "Sorry, Can't Use Plasma on this turret");
            //%obj.setInventory(%engineer.getMountedImage($BackPackSlot).item, 0);//stop - Lagg...
	    return;
         }

         // do we want to use Mortars?
         if (%barrel $= "MortarBarrelLarge" && %potTurret.MortarRemoved == "1")
         {
            messageClient(%obj.client, 'MsgClient', '\c2Sorry, Mortar Barrel change Restricted on this turret.~wfx/powered/station_denied.wav');
            //messageclient(%obj.client, 0, "Sorry, Can't Use Mortars on this turret");
            //%obj.setInventory(%engineer.getMountedImage($BackPackSlot).item, 0);//stop - Lagg...
	    return;
         }



         // found a turret base, what team is it on?
         if(%potTurret.team == %obj.client.team)
         {
            if(%potTurret.getDamageState() !$= "Enabled")
	    {
               // the base is destroyed
               messageClient(%obj.client, 'MsgBaseDestroyed', "\c2Turret is disabled, cannot mount barrel."); // z0dd - ZOD, 4/20/02. modular MPB turret
               %obj.setImageTrigger($BackpackSlot, false);
            }
            else
            {
               // it's a functional turret base on our team! stick the barrel on it
               messageClient(%obj.client, 'MsgTurretMount', "\c2Mounting barrel pack on turret."); // z0dd - ZOD, 4/20/02. modular MPB turret
               serverPlay3D(TurretPackActivateSound, %potTurret.getTransform());
               %potTurret.initiateBarrelSwap(%obj);
            }
         }
         else
         {
            // whoops, wrong team
            messageClient(%obj.client, 'MsgTryEnemyTurretMount', "\c2Cannot mount a barrel on an enemy turret base!");
            %obj.setImageTrigger($BackpackSlot, false);
         }
      }
      else
      {
         // tried to mount barrel on some other turret type
         messageClient(%obj.client, 'MsgNotTurretBase', "\c2Can only mount a barrel on a turret base.");
         %obj.setImageTrigger($BackpackSlot, false);
      }
   }
   else
   {
      // I don't see any turret
      messageClient(%obj.client, 'MsgNoTurretBase', "\c2No turret within range.");
      %obj.setImageTrigger($BackpackSlot, false);
   }
}

//-----------------------------------------------------------------------
//add mpb inventory station to the $aiinventory set so bots can use it
//allows modular turret and teleporter as well (taken from Classic mod)
function MobileBaseVehicle::vehicleDeploy(%data, %obj, %player, %force)
{

   //echo("MobileBaseVehicle::vehicleDeploy(%data, %obj, %player, %force)");
   //error("MobileBaseVehicle::vehicleDeploy(" @ %data @ ", " @ %obj @ ", " @ %player @ ", " @ %force @ ")");
   //echo("   ");
 
   if(VectorLen(%obj.getVelocity()) <= 0.1 || %force)
   {
      if(%obj.isDeployed)
      {
         //error("MobileBaseVehicle::vehicleDeploy - IT IS DELPoYED");//------------------------------------------- remove here

         if(%obj.schedule !$= "")
         {
        
            //error("MobileBaseVehicle::vehicleDeploy - IT IS DELPYED AND HAS A SCHEDULE");
            //error("data = " @ %data @ ", obj = " @ %obj @ ", force = " @ %force);
            //echo("   ");
         }
      }

      %deployMessage = "";
      //echo("calling function CheckTurretdistance");//------------------------------------------------------------------------- remove here
      if( (%deployMessage = %data.checkTurretDistance(%obj)) $= "" || %force)
      {
         if(%obj.station $= "")
         {
            if( (%deployMessage = %data.checkDeploy(%obj)) $= "" || %force)
            {
               %obj.station = new StaticShape() {
                  scale = "1 1 1";
                  dataBlock = "MobileInvStation";
                  lockCount = "0";
                  homingCount = "0";
                  team = %obj.team;
                  vehicle = %obj;
                  rpgLvl = %obj.rpgLvl;
                  rpgTotalHpMultiplier = %obj.rpgTotalHpMultiplier;
                  rpgTotalDmgMultiplier = %obj.rpgTotalDmgMultiplier;
               };

               //add the station to the $AIInventorySet - Lagg... 9-18-2003
               if ($Host::BotsEnabled)
                  $AIInvStationSet.add(%obj.station);
                
               %obj.station.startFade(0,0,true);
               %obj.mountObject(%obj.station, 2);
               %obj.station.getDataBlock().createTrigger(%obj.station);
               %obj.station.setSelfPowered();
               %obj.station.playThread($PowerThread,"Power");
               %obj.station.playAudio($HumSound,StationHumSound);
               %obj.station.vehicle = %obj;
               %obj.turret = new turret() {
                  scale = "1 1 1";
                  dataBlock = "MobileTurretBase";
                  lockCount = "0";
                  homingCount = "0";
                  team = %obj.team;
                  rpgLvl = %obj.rpgLvl;
                  rpgTotalHpMultiplier = %obj.rpgTotalHpMultiplier;
                  rpgTotalDmgMultiplier = %obj.rpgTotalDmgMultiplier;
               };                
               %obj.turret.setDamageLevel(%obj.getDamageLevel());
               %obj.mountObject(%obj.turret, 1);
               %obj.turret.setSelfPowered();
               %obj.turret.playThread($PowerThread,"Power");
               
               //%obj.turret.mountImage(MissileBarrelLarge, 0 ,false);
               // -----------------------------------------------------
               // z0dd - ZOD, 4/25/02. modular MPB turret
               if(%obj.barrel !$= "")
               {
                  %obj.turret.mountImage(%obj.barrel, 0 ,false);
               }
               else
               {
                  %obj.turret.mountImage(MissileBarrelLarge, 0 ,false);
               }
               // -----------------------------------------------------

               %obj.beacon = new BeaconObject() {
                  dataBlock = "DeployedBeacon";
                  position = %obj.position;
                  rotation = %obj.rotation;
                  team = %obj.team;
               };
               %obj.beacon.setBeaconType(friend);
               %obj.beacon.setTarget(%obj.team);

               //we dont want to set up teleporter for respawning MPBs - Lagg... 10-1-2003
               //have to do search for spawns when teleporting, in case the area became blocked (future project)
               if (!%obj.deployed)
                  checkSpawnPos(%obj, 20);
            }
         }
         else
         {
            %obj.station.setSelfPowered();
            %obj.station.playThread($PowerThread,"Power");
            %obj.turret.setSelfPowered();
            %obj.turret.playThread($PowerThread,"Power");
         }
         if(%deployMessage $= "" || %force)
         {
            if(%obj.turret.getTarget() == -1)
            {   
               %obj.turret.setTarget(%obj.turret.target);
            }   
            %obj.turret.setThreadDir($DeployThread, true);
            %obj.turret.playThread($DeployThread,"deploy");
            %obj.turret.playAudio($DeploySound, MobileBaseTurretDeploySound);
         
            %obj.station.notDeployed = 1;
            %obj.setThreadDir($DeployThread, true);
            %obj.playThread($DeployThread,"deploy");  
            %obj.playAudio($DeploySound, MobileBaseDeploySound);
            %obj.deployed = 1;
            %obj.deploySchedule = "";
            %obj.disableMove = true;
            %obj.setFrozenState(true);
            if(isObject(%obj.shield))
               %obj.shield.delete();

            %obj.shield = new forceFieldBare()
            {
               scale = "1.22 1.8 1.1";
               dataBlock = "defaultTeamSlowFieldBare";
               team = %obj.team;
            };
            %obj.shield.open();
            setTargetSensorData(%obj.getTarget(), MPBDeployedSensor);
         }
      }
      if(%deployMessage !$= "")
         messageClient(%player.client, '', %deployMessage); 

      return true;
   }
   else
   {
      return false;
   }
}

//-------------------------------------------------------------------------------------------------

function createVehicle(%client, %station, %blockName, %team , %pos, %rot, %angle)
{
   %obj = %blockName.create(%team);   
   if(%obj)
   {
      //-----------------------------------------------
      // z0dd - ZOD, 4/25/02. MPB Teleporter.
      if ( %blockName $= "MobileBaseVehicle" )
      {
         //we don't want to set up teleport pad for respawning MPBs - Lagg... 10-1-2003
         if (%obj.respawn <= 0)
         {
            %station.station.teleporter.MPB = %obj;
            %obj.teleporter = %station.station.teleporter;
         }
      }
      //-----------------------------------------------
      %station.ready = false;
      %obj.team = %team;
      %obj.useCreateHeight(true);
      %obj.schedule(5500, "useCreateHeight", false);
      %obj.getDataBlock().isMountable(%obj, false);
      %obj.getDataBlock().schedule(6500, "isMountable", %obj, true);
      
      %station.playThread($ActivateThread,"activate2");
      %station.playAudio($ActivateSound, ActivateVehiclePadSound);

      vehicleListAdd(%blockName, %obj);
      MissionCleanup.add(%obj);
                                  
      %turret = %obj.getMountNodeObject(10);
      if(%turret > 0)
      {
         %turret.setCloaked(true);
         %turret.schedule(4800, "setCloaked", false);
      }
      
      %obj.setCloaked(true);
      %obj.setTransform(%pos @ " " @ %rot @ " " @ %angle);
   
      %obj.schedule(3700, "playAudio", 0, VehicleAppearSound);
      %obj.schedule(4800, "setCloaked", false);
      
      if(%client.player.lastVehicle)
      {
         %client.player.lastVehicle.lastPilot = "";
         vehicleAbandonTimeOut(%client.player.lastVehicle);
         %client.player.lastVehicle = "";
      }   
      %client.player.lastVehicle = %obj;
      %obj.lastPilot = %client.player;

      // play the FX
      %fx = new StationFXVehicle()
      {
         dataBlock = VehicleInvFX;
         stationObject = %station;
      };

      if ( %client.isVehicleTeleportEnabled() )
         %obj.getDataBlock().schedule(5000, "mountDriver", %obj, %client.player);
   }
   if(%obj.getTarget() != -1)
      setTargetSensorGroup(%obj.getTarget(), %client.getSensorGroup());
   // We are now closing the vehicle hud when you buy a vehicle, making the following call
   // unnecessary (and it breaks stuff, too!)
   //VehicleHud.updateHud(%client, 'vehicleHud');
}

function StationVehiclePad::createStationVehicle(%data, %obj)
{
   // z0dd - ZOD - Founder(founder@mechina.com), 4/20/02
   // This code used to be called from StationVehiclePad::onAdd
   // This was changed so we can add the station to the mission group
   // so it gets powered properly and auto cleaned up at mission end

   // Get the v-pads mission group so we can place the station in it.
   %group = %obj.getGroup();

   // Set the default transform based on the vehicle pads slot
   %xform = %obj.getSlotTransform(0);
   %position = getWords(%xform, 0, 2);
   %rotation = getWords(%xform, 3, 5);
   %angle = (getWord(%xform, 6) * 180) / 3.14159;

   // Place these parameter's in the v-pad datablock located in mis file.
   // If the mapper doesn't move the station, use the default location.
   if(%obj.stationPos $= "" || %obj.stationRot $= "")
   {
      %pos = %position;
      %rot = %rotation @ " " @ %angle;
   }
   else
   {
      %pos = %obj.stationPos;
      %rot = %obj.stationRot;
   }

   %sv = new StaticShape() {
	scale = "1 1 1";
      dataBlock = "StationVehicle";
	lockCount = "0";
	homingCount = "0";
	team = %obj.team;
      position = %pos;
      rotation = %rot;
   };

   // Add the station to the v-pads mission group for cleanup and power.
   %group.add(%sv);
   %sv.setPersistent(false); // set the station to not save.

   // Apparently called to early on mission load done, call it now.
   %sv.getDataBlock().gainPower(%sv);

   // Create the trigger
   %sv.getDataBlock().createTrigger(%sv);
   %sv.pad = %obj;
   %obj.station = %sv;
   %sv.trigger.mainObj = %obj;
   %sv.trigger.disableObj = %sv;

   // Set the sensor group.
   if(%sv.getTarget() != -1)
      setTargetSensorGroup(%sv.getTarget(), %obj.team);

   //Remove unwanted vehicles
   if(%obj.scoutVehicle !$= "Removed")
	   %sv.vehicle[scoutvehicle] = true;
   if(%obj.assaultVehicle !$= "Removed")
	   %sv.vehicle[assaultVehicle] = true;
   if(%obj.mobileBaseVehicle !$= "Removed")
   {
      %sv.vehicle[mobileBasevehicle] = true;
      // z0dd - ZOD, 4/20/02. Enable MPB Teleporter.
      %sv.getDataBlock().createTeleporter(%sv, %group);// --- not used in mission No Quarter - Lagg... *
   }
   if(%obj.scoutFlyer !$= "Removed")
	   %sv.vehicle[scoutFlyer] = true;
   if(%obj.bomberFlyer !$= "Removed")
	   %sv.vehicle[bomberFlyer] = true;
   if(%obj.hapcFlyer !$= "Removed")
   	%sv.vehicle[hapcFlyer] = true;
}

//--------------------------------------------------------------------------------------------------
function StationVehicle::createTeleporter(%data, %obj, %group)
{
   //// %obj = Teleport Object

   // %obj = StationVehiclePad
   // %data = Teleport Datablock
   // %group = Vehicle Pads Mission Group

   %Teleporter = new StaticShape() {
      scale = "1 1 1";
      dataBlock = "MPBTeleporter";
      lockCount = "0";
      homingCount = "0";
      team = %obj.team;
   };
   %obj.teleporter = %Teleporter;
   %Teleporter.vStation = %obj.pad;

   %trans = %obj.pad.getSlotTransform(0);
   %vSPos = getWords(%trans,0,2);
   %vRot =  getWords(%trans,3,5);
   %vAngle = getWord(%trans,6);
   %matrix = VectorOrthoBasis(%vRot @ " " @ %vAngle + 0.36);
   %yRot = getWords(%matrix, 3, 5);
   %pos = vectorAdd(%vSPos, vectorScale(%yRot, -31.5));

   // Place these parameter's in the v-pad datablock located in mis file.
   // If the mapper doesn't move the teleporter, use the default location.
   if(%obj.pad.teleporterPos !$= "" || %obj.pad.teleporterRot !$= "")
   {
      %pos = %obj.pad.teleporterPos;
      %vRot = %obj.pad.teleporterRot;
      %Teleporter.setTransform(%pos @ " " @ %vRot);

   }
   else
      %Teleporter.setTransform(%pos @ " " @ %vRot @ " " @ %vAngle);

   // Add the teleporter to the v-pads mission group for cleanup and power.
   %group.add(%Teleporter);
   %Teleporter.setPersistent(false); // set the teleporter to not save in the editor.

   // Apparently called to early on mission load done, call it now.
   %Teleporter.getDataBlock().gainPower(%Teleporter);

   // Set the sensor group.
   if(%Teleporter.getTarget() != -1)
      setTargetSensorGroup(%Teleporter.getTarget(), %obj.team);

   // Allow players to use it.
   %Teleporter.disabled = 0;
}

function MPBTeleporter::onCollision(%data, %obj, %col)
{
   if(%col.getDataBlock().className !$= "Armor" || %col.getState() $= "Dead" || %col.teleporting)
      return;

   if(isObject(%col))
   {
      if(%obj.team == %col.client.team)
      {
         if(!%obj.isDisabled())
         {
            if(%obj.isPowered())
            {
               if(isObject(%obj.MPB) && %obj.MPB.fullyDeployed)
               {
                  if(%obj.disabled == 0)
                  {
                     %col.lastWeapon = ( %col.getMountedImage($WeaponSlot) == 0 ) ? "" : %col.getMountedImage($WeaponSlot).getName().item;
                     %col.unmountImage($WeaponSlot);
                     %pos = %obj.position;
                     %col.setvelocity("0 0 0");
                     %col.setMoveState(true);
                     %rot = getWords(%col.getTransform(), 3, 6);
                     %col.setTransform(getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 0.6 @ " " @ %rot);
                     %col.teleporting = 1;
                     %col.startFade( 1000, 0, true );
                     %col.playAudio($PlaySound, StationVehicleAcitvateSound);

                     %obj.disabled = 1; // Disable the teleporter to more then one person at a time for a time.
                     %obj.setThreadDir($ActivateThread, TRUE);
                     %obj.playThread($ActivateThread, "activate");

                     %data.sparkEmitter(%obj);
                     %data.schedule(2000, "teleportout", %obj, %col);
                     %data.schedule(4000, "teleportingDone", %obj, %col);
                  }
                  else
                     messageClient(%col.client, 'MsgTeleportRecharging', '\c2Teleporter is recharging please stand by. ~wfx/powered/nexus_deny.wav'); 
               }
               else
                  MessageClient(%col.client, "MsgNoMPB", 'MPB is not deployed.');
            }
            else
               messageClient(%col.client, 'MsgStationNoPower', '\c2Teleporter is not powered.');
         }
         else
            messageClient(%col.client, 'MsgStationDisabled', '\c2Teleporter is disabled.');
      }
      else
         messageClient(%col.client, 'MsgStationDenied', '\c2Access Denied -- Wrong team.~wfx/powered/station_denied.wav');
   }
   else
      return;
}

function MPBTeleporter::teleportOut(%data, %obj, %player)
{
   if(isObject(%obj.MPB))
   {
      %index = -1;
      for(%x=0; %x < %obj.MPB.spawnPosCount; %x++)
      {
         %index = mFloor(getRandom() * %obj.MPB.spawnPosCount);
         InitContainerRadiusSearch(%obj.MPB.spawnPos[%index], 2, $TypeMasks::MoveableObjectType);
         if(ContainerSearchNext() == 0)
            break;
         else
            %index = -1;
      }
      if(%index >= 0)
      {
         %player.setTransform(%obj.MPB.spawnPos[%index] @ " " @ getWords(%obj.MPB.getTransform(), 3, 6));
      }
      else
      {
         messageClient(%player.client, 'MsgTeleFailed', 'No Valid teleporting positions.');
         %player.teleporting = 0;
      }
   }
   else
   {
      messageClient(%player.client, 'MsgTeleFailed', 'No Valid teleporting positions because MPB was destroyed');
      %player.teleporting = 0;
   }
   %data.schedule(1000, "teleportIn", %player);
}

function MPBTeleporter::teleportIn(%data, %player)
{
   %data.sparkEmitter(%player); // z0dd - ZOD, 4/24/02. teleport sparkles
   %player.startFade(1000, 0, false );
   %player.playAudio($PlaySound, StationVehicleDeactivateSound);
}

function MPBTeleporter::reEnable(%data, %obj)
{
   %obj.disabled = 0;
}

function MPBTeleporter::sparkEmitter(%data, %obj)
{
   if (isObject(%obj.teleportEmitter))
      %obj.teleportEmitter.delete();

   %obj.teleportEmitter = new ParticleEmissionDummy() {
      position = %obj.position;
      rotation = "1 0 0 0";
      scale = "1 1 1";
      dataBlock = defaultEmissionDummy;
      emitter = "MPBTeleportEmitter";
      velocity = "1";
   };
   MissionCleanup.add(%obj.teleportEmitter);
   %obj.teleportEmitter.schedule(800, "delete");

   if (isObject(%obj.teleEmitter))
      %obj.teleEmitter.delete();

   %obj.teleEmitter = new ParticleEmissionDummy() {
      position = %obj.position;
      rotation = "1 0 0 0";
      scale = "1 1 1";
      dataBlock = defaultEmissionDummy;
      emitter = "FlyerJetEmitter";
      velocity = "1";
   };
   MissionCleanup.add(%obj.teleEmitter);
   %obj.teleEmitter.schedule(700, "delete");
}

function MPBTeleporter::teleportingDone(%data, %obj, %player)
{
   %player.setMoveState(false);
   %player.teleporting = 0;
   %player.station = "";
   %data.reEnable(%obj);
   if(%player.getMountedImage($WeaponSlot) == 0)
   {
      if(%player.inv[%player.lastWeapon])
         %player.use(%player.lastWeapon); 
      else
         %player.selectWeaponSlot( 0 );
   }
}

//------------------------------------------------------------------------------------------
// Gets called from function MobileBaseVehicle::vehicleDeploy(%data, %obj, %player, %force).
// Passes this information to the MPBTeleporter::teleportOut function.
//------------------------------------------------------------------------------------------

function checkSpawnPos(%MPB, %radius)
{
   for(%y = -1; %y < 1; %y += 0.25)
   {
      %xCount=0;
      for(%x = -1; %x < 1; %x += 0.25)
      {
         $MPBSpawnPos[(%yCount * 8) + %xCount] = %x @ " " @ %y; 
         %xCount++;
      }
      %yCount++;
   }
   %count = -1;

   for(%x = 0; %x < 64; %x++)
   {
      %pPos = getWords(%MPB.getTransform(), 0, 2);
      %pPosX = getWord(%pPos, 0);
      %pPosY = getWord(%pPos, 1);
      %pPosZ = getWord(%pPos, 2);
      
      %posX = %pPosX + ( getWord($MPBSpawnPos[%x],0) * %radius);
      %posY = %pPosY + (getWord($MPBSpawnPos[%x],1) * %radius);
      
      %terrHeight = getTerrainHeight(%posX @ " " @ %posY);

      if(mAbs(%terrHeight - %pPosZ) < %radius )
      {
         %mask = $TypeMasks::VehicleObjectType     | $TypeMasks::MoveableObjectType   |
                 $TypeMasks::StaticShapeObjectType | $TypeMasks::StaticTSObjectType   | 
                 $TypeMasks::ForceFieldObjectType  | $TypeMasks::ItemObjectType       | 
                 $TypeMasks::PlayerObjectType      | $TypeMasks::TurretObjectType     |
                 $TypeMasks::InteriorObjectType;

         InitContainerRadiusSearch(%posX @ " " @ %posY @ " " @ %terrHeight, 2, %mask);
         if(ContainerSearchNext() == 0)
            %MPB.spawnPos[%count++] = %posX @ " " @ %posY @ " " @ %terrHeight;                  
      }
   }   
   %MPB.spawnPosCount = %count;
}

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//                                                  Vehicle Modifications and Fixes here, UE fixes                           - Lagg... 5-26-2005  ^^^
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

//**************************************************************
//* DAMAGE FUNCTIONS
//**************************************************************

function VehicleData::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType, %momVec, %theClient, %proj)
{
   //error("VehicleData::damageObject - ");

   if(%proj !$= "")
   {
      if(%amount > 0 && %targetObject.lastDamageProj !$= %proj)
      {
         %targetObject.lastDamageProj = %proj;
         %targetObject.lastDamageAmount = %amount;
      }
      else if(%targetObject.lastDamageAmount < %amount)
         %amount = %amount - %targetObject.lastDamageAmount;
      else
         return;
   }
      
   // check for team damage
   if (isObject(%sourceObject))
      %sourceClient = %sourceObject ? %sourceObject.getOwnerClient() : 0;
   else
      %sourceClient = "0";
      
   %targetTeam = getTargetSensorGroup(%targetObject.getTarget());

   if(%sourceClient)
      %sourceTeam = %sourceClient.getSensorGroup();
   else if(isObject(%sourceObject) && %sourceObject.getClassName() $= "Turret")
      %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
   else
      %sourceTeam = %sourceObject ? getTargetSensorGroup(%sourceObject.getTarget()) : -1;

    // vehicles no longer obey team damage -JR
//    if(!$teamDamage && (%targetTeam == %sourceTeam) && %targetObject.getDamagePercent() > 0.5)
//       return;
    //but we do want to track the destroyer
    if(%sourceObject)
    {
        %targetObject.lastDamagedBy = %sourceObject;
        %targetObject.lastDamageType = %damageType;
    }
    else 
        %targetObject.lastDamagedBy = 0;


   // Scale damage type & include shield calculations...
   if (%data.isShielded)
      %amount = %data.checkShields(%targetObject, %position, %amount, %damageType);
   
   
   %damageScale = %data.damageScale[%damageType];
   if(%damageScale !$= "")
      %amount *= %damageScale;
      
   if(%amount != 0)
      %targetObject.applyDamage(%amount);
      
   if(%targetObject.getDamageState() $= "Destroyed" )
   {
      if( %momVec !$= "")
         %targetObject.setMomentumVector(%momVec);
   }
}      

function VehicleData::onImpact(%data, %vehicleObject, %collidedObject, %vec, %vecLen)
{
   if(isObject(%vehicleObject) && %vehicleObject.getDamageState() !$= "Destroyed")
   {
      if(%vecLen > %data.minImpactSpeed)
         %data.damageObject(%vehicleObject, 0, VectorAdd(%vec, %vehicleObject.getPosition()),
           %vecLen * %data.speedDamageScale, $DamageType::Ground);

      //I wonder why the game has so many errors? - Lagg... 4/19/2009
      %vDataBlock = %vehicleObject.getDataBlock();

      // associated "crash" sounds
      if(%vecLen > %vDataBlock.hardImpactSpeed)
      {
         //error("VehicleData::onImpact - play hard impact sound : " @ %vDataBlock @ " ???");
         %vehicleObject.playAudio(0, %vDataBlock.hardImpactSound);
      }
      else if(%vecLen > %vDataBlock.softImpactSpeed)
      {
         //error("VehicleData::onImpact - play soft impact sound : " @ %vDataBlock @ " ???");
         %vehicleObject.playAudio(0, %vDataBlock.softImpactSound);
      }
   }
   else
      error("FIXED A DAM UE --- --- --- FIXED A DAM UE --- Lagg... - 10/12/2006");
}   

//---------------------------------------------------------------------------------------------------------------
//                                                                1st vehicle gets hit and damaged by something -
//---------------------------------------------------------------------------------------------------------------

//used to fix UE error when vehicle Blows up - Lagg... 9-23-2006
function VehicleData::onDamage(%this,%obj)
{
   //error("VehicleData::onDamage - LaggsDefault4_Vehicle.cs - " @ %this.getName());

   //%damage = %obj.getDamageLevel();
   //if (%damage >= %this.destroyedLevel)
   //{
      //if(%obj.getDamageState() !$= "Destroyed")
      //{
         //if(%obj.respawnTime !$= "")
            //%obj.marker.schedule = %obj.marker.data.schedule(%obj.respawnTime, "respawn", %obj.marker); 
         //%obj.setDamageState(Destroyed);
      //}
   //}
   //else
   //{
      //if(%obj.getDamageState() !$= "Enabled")
         //%obj.setDamageState(Enabled);
   //}

   if (%obj.getDamageState() !$= "Destroyed")
   {
      %damage = %obj.getDamageLevel();
      if (%damage >= %this.destroyedLevel)
      {
         if(%obj.respawnTime !$= "")
            %obj.marker.schedule = %obj.marker.data.schedule(%obj.respawnTime, "respawn", %obj.marker); 
         %obj.setDamageState(Destroyed);
      }
   }
} 

//used to fix UE error when tank Blows up - Lagg... 5-26-2005
function AssaultVehicle::onDamage(%this, %obj)
{
   //error("AssaultVehicle::onDamage - LaggsDefaultMPB.cs");//debugging purposes - Lagg...

   if (%obj.getDamageState() !$= "Destroyed")
   {
      if(isObject(%obj.getMountNodeObject(10)))
         (%obj.getMountNodeObject(10)).setDamagelevel(%obj.getDamageLevel());
      Parent::onDamage(%this, %obj);
   }
}

//--------------------------------------------------------------------------------------------------

//used to fix UE error - Lagg... 5-26-2005
function BomberFlyer::onDamage(%this, %obj)
{
   //error("BomberFlyer::onDamage");//debugging purposes - Lagg...

   if (%obj.getDamageState() !$= "Destroyed")
   {
      if(isObject(%obj.getMountNodeObject(10)))
         (%obj.getMountNodeObject(10)).setDamagelevel(%obj.getDamageLevel());
      Parent::onDamage(%this, %obj);
   }
}

//--------------------------------------------------------------------------------------------------

//used to fix UE error when MPB Blows up - Lagg... 5-26-2005
function MobileBaseVehicle::onDamage(%this, %obj)
{
   //error("MobileBaseVehicle::onDamage");//debugging purposes - Lagg...

   if (%obj.getDamageState() !$= "Destroyed")
   {
      if(isObject(%obj.getMountNodeObject(1)))
         (%obj.getMountNodeObject(1)).setDamagelevel(%obj.getDamageLevel());
      Parent::onDamage(%this, %obj);
   }
}

//---------------------------------------------------------------------------------------------------

function VehicleData::onDestroyed(%data, %obj, %prevState)
{
   //error("VehicleData::onDestroyed - LaggsDefault4_Vehicle.cs");//debugging purposes - Lagg...

   if(%obj.lDamageSchedule !$= "")
   {
      cancel(%obj.lDamageSchedule);
      %obj.lDamageSchedule = "";
   }

   if(%obj.lastDamagedBy)
   {
       %destroyer = %obj.lastDamagedBy;
       game.vehicleDestroyed(%obj, %destroyer);

       //error("vehicleDestroyed( "@ %obj @", "@ %destroyer @")");
   }

   //apply damage to anyone or anything that is nearby    
   radiusVehicleExplosion(%data, %obj);

   if(%obj.turretObject)//********************************************************MAYBE PROBLEM HERE, BOTS DO NOT CONTROLL TURRETS
   {
      if(%obj.turretObject.getControllingClient())
      {
         //error("VehicleData::onDestroyed - we have a Player controlling turret");//debugging purposes - Lagg...
         %obj.turretObject.getDataBlock().playerDismount(%obj.turretObject);
      }         
   }

   //throw everyone out of the vehicle in a random kinda way :)
   for(%i = 0; %i < %obj.getDatablock().numMountPoints; %i++)
   {
      if (%obj.getMountNodeObject(%i)) {
         %flingee = %obj.getMountNodeObject(%i);
         %flingee.getDataBlock().doDismount(%flingee, true);
         %xVel = 250.0 - (getRandom() * 500.0);
         %yVel = 250.0 - (getRandom() * 500.0);
         %zVel = (getRandom() * 100.0) + 50.0;
         %flingVel = %xVel @ " " @ %yVel @ " " @ %zVel;
         %flingee.applyImpulse(%flingee.getTransform(), %flingVel);
         //echo("got player..." @ %flingee.getClassName());
         %flingee.damage(0, %obj.getPosition(), 0.4, $DamageType::Crash); 
      }
   }

   //delete any turrets, beacons or stations from the vehicle
   %data.deleteAllMounted(%obj);

   // ---------------------------------------------------------------------------------
   // z0dd - ZOD - Czar, 6/24/02. Move this vehicle out of the way so nothing collides 
   // with it.
   if(%data.getName() $= "BomberFlyer" || %data.getName() $= "MobileBaseVehicle" || %data.getName() $= "AssaultVehicle")
   {
      //error("VehicleData::onDestroyed(%data, %obj, %prevState)  - LaggsDefault4_vehicle.cs -");
      //echo("%data = " @ %data.getName() @ ", %obj = " @ %obj @ ", %prevState = " @ %prevState); 

      if(isEventPending(%obj.schedule))
      {
         //error("VehicleData::onDestroyed - WE HAVE A SCHEDULE RUNNING ON THIS BITCH (Vehicle) !!! DAM IT!!!");
         cancel(%obj.schedule);//added to test for UE Fix here - Lagg... 9/3/2006
      }
   
      %obj.setFrozenState(true);
      %obj.schedule(2000, "delete");
      //%data.schedule(500, 'onAvoidCollisions', %obj);//opps typo here
      
      %data.schedule(500, "onAvoidCollisions", %obj);
   }
   else
   {
      //error("VehicleData::onDestroyed it was NOT A TANK  - LaggsDefault4_vehicle.cs -");

      if(isEventPending(%obj.schedule))
      {
         error("VehicleData::onDestroyed - WE HAVE A SCHEDULE RUNNING ON THIS BITCH (Vehicle) !!! DAM IT!!!");
         cancel(%obj.schedule);//added to test for UE Fix here - Lagg... 9/3/2006
      }

      %obj.setFrozenState(true); 
      %obj.schedule(500, "delete");
   }
}

//--------------------------------------------------------------------------------------------------------------------
//trying to fix UE when Tank or Bomber blows up -------------------------------^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

//spam fix for MPB Vehicle on Blow UP
//the problem is the MPB forcefield shield is not mounted to vehicle object,
//We could rewrite the MPB or just do a little fix here this way. Note if two
//MPB's are fully deployed next to each other and one blows up you will encounter spam, but
//what is the chance of that happening? heh, heh  - Lagg... 11-12-2003

//also noticed there is a problem with the Tank Turret as well - Lagg... 5-14-2005

function radiusVehicleExplosion(%data, %vehicle)
{
   if (!isObject(%vehicle))
   {
      error("radiusVehicleExplosion - DO WE EVER SEE THIS ERROR ???");
      return;
   }

   //if (%vehicle.getDataBlock().getName() $= "AssaultVehicle")//debugging purposes - Lagg...
      //error("radiusVehicleExplosion - Tank - LaggsDefault4_Vehicle.cs");//debugging purposes - Lagg...

   // this is a modified version of RadiusExplosion() from projectiles.cs
   %position = %vehicle.getPosition();

   //removed ForceFieldObjectType here to stop spam
   //trying to figure out why it was there in the first place
   //can't apply damage to a ff and we check for ff later 
   //to see if you are protected by one - Lagg... 11-12-2003

   //InitContainerRadiusSearch(%position, %data.explosionRadius, $TypeMasks::PlayerObjectType |
                                                 //$TypeMasks::VehicleObjectType     |
                                                 //$TypeMasks::MoveableObjectType    |
                                                 //$TypeMasks::StaticShapeObjectType |
                                                 //$TypeMasks::TurretObjectType      |
                                                 //$TypeMasks::ItemObjectType);

   //Changed to search only for stuff that we can damage - Lagg... 9/25/2006
   InitContainerRadiusSearch(%position, %data.explosionRadius, $TypeMasks::PlayerObjectType |
                                                 $TypeMasks::VehicleObjectType |
                                                 $TypeMasks::TurretObjectType |
                                                 $TypeMasks::SensorObjectType |
                                                 $TypeMasks::StationObjectType |
                                                 $TypeMasks::GeneratorObjectType);

   %numTargets = 0;
   while ((%targetObject = containerSearchNext()) != 0)
   {
      %name = %targetObject.getDataBlock().getName();//debugging purposes - Lagg...
      //echo("radiusVehicleExplosion LaggsDefault4_vehicles.cs - targetObject = " @ %name);//debugging purposes - Lagg...

      //if explosion radius includes vehicle or parts of same vehicle skip - Lagg... 11-12-2003(updated Lagg... 5-18-2005)	
      if(%targetObject == %vehicle || %targetobject == %vehicle.turretObject || %targetObject == %vehicle.station ||
        %targetObject == %vehicle.turret || %targetObject == %vehicle.beacon)
         continue;

      %dist = containerSearchCurrRadDamageDist();

      if (%dist > %data.explosionRadius)
         continue;

      if (%targetObject.isMounted())
      {
         %mount = %targetObject.getObjectMount();
	 if(%mount == %vehicle)
         {
            //error("radiusVehicleExplosion - #1");
            continue;
         }

         %found = -1;
         for (%i = 0; %i < %mount.getDataBlock().numMountPoints; %i++)
         {
            if (%mount.getMountNodeObject(%i) == %targetObject)
            {
               %found = %i;
               break;
            }
         }
      
         if (%found != -1)
         {
            if (%mount.getDataBlock().isProtectedMountPoint[%found] && (%mount != %vehicle))
               continue;
         }
      }

      %targets[%numTargets]     = %targetObject;
      %targetDists[%numTargets] = %dist;
      %numTargets++;
   }

   for (%i = 0; %i < %numTargets; %i++)
   {
      %targetObject = %targets[%i];
      %dist = %targetDists[%i];

      %coverage = calcExplosionCoverage(%position, %targetObject,
                                        ($TypeMasks::InteriorObjectType |
                                         $TypeMasks::TerrainObjectType |
                                         $TypeMasks::ForceFieldObjectType));
      if (%coverage == 0)
         continue;

      %amount = (1.0 - (%dist / %data.explosionRadius)) * %coverage * %data.explosionDamage;
      %targetData = %targetObject.getDataBlock();

      %momVec = "0 0 1";
      
      if(%amount > 0)
      {
         //echo(" ");
         //error("radiusVehicleExplosion - applying damage to a " @ %targetData.getName());// ------------------------------------------ error message here !

         %targetData.damageObject(%targetObject, %sourceObject, %position, %amount, $DamageType::Explosion, %momVec);

         //echo("Target Number = " @ %i @ ", of " @ %numTargets @ "/ Damage amount = " @ %amount);// ---------------------------- error message here !
         //echo(" ");
      }
   }
}

//-------------------------------------------------------------------------------------------------------------------------

function VehicleData::onRemove(%this, %obj)
{
   //error("VehicleData::onRemove - " @ %obj.getDataBlock().getName());

   // if there are passengers/driver, kick them out
   %this.deleteAllMounted(%obj);
   for(%i = 0; %i < %obj.getDatablock().numMountPoints; %i++)
      if (%obj.getMountNodeObject(%i)) {
         %passenger = %obj.getMountNodeObject(%i);
         %passenger.unmount();
      }
   vehicleListRemove(%obj.getDataBlock(), %obj);
   if(%obj.lastPilot.lastVehicle == %obj)
      %obj.lastPilot.lastVehicle = "";      

   Parent::onRemove(%this, %obj);
}
//----------------------------
//BEOWULF ASSAULT VEHICLE
//----------------------------

function AssaultVehicle::deleteAllMounted(%data, %obj)
{
   //original was
   //%turret = %obj.getMountNodeObject(10);
   //if(!%turret)
   //   return;

   //if(%client = %turret.getControllingClient())
   //{
   //   %client.player.setControlObject(%client.player);
   //   %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);   
   //   %client.player.mountVehicle = false;
   //}
   //%turret.schedule(2000, delete);

   //error("AssaultVehicle::deleteAllMounted");

   %turret = %obj.getMountNodeObject(10);
   if(!%turret)
   //if(!isObject(%turret))
   {
      //THIS IS WORKING GOOD!!!
      //error("WE DONT HAVE A TURRET ON THIS TANK! WTF! - AssaultVehicle::deleteAllMounted");
      return;
   }
   else
   {
      if(isEventPending(%turret.schedule))
         error("THIS TURRET HAS A SCHEDULE RUNNING !!! SON OF A BITCH !!! - AssaultVehicle::deleteAllMounted");
   }

   //hmmm, Bots do not controll turrets, that could be a problem - Lagg... 8/31/2006
   //if(%client = %turret.getControllingClient())

   //get the client from the vehicle seat
   %client = %obj.getMountNodeObject(1).client;
   if(isObject(%client))
   {
      //echo("We Have a ");

      if(!%client.isAIControlled())
      {
         //echo("Human Controlling the Tank Turret");
         %client.player.setControlObject(%client.player);
      }
      else
      {
         //echo("Bot in Tank Turret, CEASE FIRE!");
         %turretDB = %client.turretMounted.getDataBlock();
         %turretDB.onTrigger(%client.turretMounted, 0, false);
      }

      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);   
      %client.player.mountVehicle = false;
   }
   
   //lets just delete the turret now instead of scheduling, so it can't happen more than 1 time per vehicle - Lagg... 9/2/2006
   //echo("AssaultVehicle::deleteAllMounted - deleting the Dam Tank Turret");
   %turret.schedule(2000, delete);
   //%turret.delete();
}

//----------------------------
// THUNDERSWORD BOMBER
//----------------------------

function BomberFlyer::deleteAllMounted(%data, %obj)
{
   //original was
   //if(isObject(%obj.beacon))
   //   %obj.beacon.schedule(50, delete);

   //%turret = %obj.getMountNodeObject(10);
   //if(!%turret)
   //   return;

   //%turret.altTrigger = 0;
   //%turret.fireTrigger = 0;
   
   //if(%client = %turret.getControllingClient())
   //{
   //   commandToClient(%client, 'endBomberSight');
   //   %client.player.setControlObject(%client.player);
   //   %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);
   //   %client.player.mountVehicle = false;

   //   %client.player.bomber = false;
   //   %client.player.isBomber = false;
   //}
   //%turret.schedule(2000, delete);

   //error("function BomberFlyer::deleteAllMounted(%data, %obj)");

   if(isObject(%obj.beacon))
   {
      //echo("BomberFlyer::deleteAllMounted - Delete beacon");
      %obj.beacon.schedule(50, delete);
   }

   %turret = %obj.getMountNodeObject(10);
   if(!%turret)
   //if(!isObject(%turret))
   {
      //error("WE DONT HAVE A TURRET ON THIS BOMBER! WTF! - BomberFlyer::deleteAllMounted");
      return;
   }
   else
   {
      //echo("BomberFlyer::deleteAllMounted - ok we have a turret");

      if(isEventPending(%turret.schedule))
      {
         //error("THIS TURRET HAS A SCHEDULE RUNNING !!! SON OF A BITCH !!! - BomberFlyer::deleteAllMounted");
      }
   }

   %turret.altTrigger = 0;
   %turret.fireTrigger = 0;
   
   
   //hmmm, Bots do not controll turrets, that could be a problem - Lagg... 8/31/2006
   //if(%client = %turret.getControllingClient())

   //get the client from the vehicle seat
   %client = %obj.getMountNodeObject(1).client;
   if(isObject(%client))
   {
      //echo("We Have a");

      if(!%client.isAIControlled())
      {
         //echo("Human Controlling the Bomber Turret");
         commandToClient(%client, 'endBomberSight');
         %client.player.setControlObject(%client.player);
      }
      else
      {
         //echo("Bot in Bomber Turret, Cease Fire!");
         %turretDB = %client.turretMounted.getDataBlock();
         %turretDB.onTrigger(%client.turretMounted, 0, false);
      }

      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);
      %client.player.mountVehicle = false;

      %client.player.bomber = false;
      %client.player.isBomber = false;
   }

   //echo("function BomberFlyer::deleteAllMounted - Deleting The Dam Bomber Turret");
   %turret.schedule(2000, delete);
}

//spam fix from vehicle.cs - Lagg 12-9-2003
function MobileBaseVehicle::deleteAllMounted(%data, %obj)
{
   //error("MobileBaseVehicle::deleteAllMounted - LaggsDefault4_Vehicle.cs");//debugging purposes - Lagg...

   //if(%obj.station !$= "")
   if(isObject(%obj.station))
   {
      %obj.station.getDataBlock().onLosePowerDisabled(%obj.station);
      %obj.unmountObject(%obj.station);
      %obj.station.trigger.schedule(2000, delete);
      %obj.station.schedule(2000, delete);
   }
   //if(%obj.turret !$= "")
   if(isObject(%obj.turret))
   {
      %obj.turret.getDataBlock().onLosePowerDisabled(%obj.turret);
      %obj.unmountObject(%obj.turret);
      %obj.turret.schedule(2000, delete);
   }
   if(isObject(%obj.shield))
      %obj.shield.schedule(2000, delete);
                            
   if(isObject(%obj.beacon))
   {
      %obj.beacon.schedule(0, delete);   	
   }
}

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

//--------------------------------------------------------------------------------------------- siege gamespam fix ---
function SiegeGame::vehicleDestroyed(%game, %vehicle, %destroyer)
{
  //needed to prevent Siege Game consol spam - Lagg... 11-12-2003   
}

//--------------------------------------------------------------------------------------------------------------------
//set up the mpb teleprter on team switch sides - Lagg...
function SiegeGame::objectSwapVehiclePads(%game, %this)
{
   %defTeam = %game.offenseTeam == 1 ? 2 : 1;

   if(%this.getDatablock().getName() $= "StationVehicle")
   {
      if(%this.getTarget() != -1)
      {
         // swap the teams of both the vehicle pad and the vehicle station
         if(getTargetSensorGroup(%this.getTarget()) == %game.offenseTeam)
         {
            setTargetSensorGroup(%this.getTarget(), %defTeam);
            %this.team = %defTeam;
            setTargetSensorGroup(%this.pad.getTarget(), %defTeam);
            %this.pad.team = %defTeam;
            // z0dd - ZOD, 4/20/02. Switch the teleporter too.
            setTargetSensorGroup(%this.teleporter.getTarget(), %defTeam);
            %this.teleporter.team = %defTeam;
         }
         else if(getTargetSensorGroup(%this.getTarget()) == %defTeam)
         {
            setTargetSensorGroup(%this.getTarget(), %game.offenseTeam);
            %this.team = %game.offenseTeam;
            setTargetSensorGroup(%this.pad.getTarget(), %game.offenseTeam);
            %this.pad.team = %game.offenseTeam;
            // z0dd - ZOD, 4/20/02. Switch the teleporter too.
            setTargetSensorGroup(%this.teleporter.getTarget(), %game.offenseTeam);
            %this.teleporter.team = %game.offenseTeam;
         }
      }
   }
}

//---------------------------------------------------------------------------------------------------------
//modified so respawning mpb can deploy, added to $AIVehicleSet ----------------------- - Lagg... 9-17-2003
function VehicleData::respawn(%data, %marker)
{

   //error("VehicleData::respawn - LaggsDefault4_vehicle");
   //error(" %data = " @ %data);
   //error("   ");

   %mask = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::TurretObjectType;
   InitContainerRadiusSearch(%marker.getWorldBoxCenter(), %data.checkRadius, %mask);
   if(containerSearchNext() == 0)    
   {
      %newObj = %data.create(%marker.curTeam, %marker);
      %newObj.startFade(1000, 0, false);
      %newObj.setTransform(%marker.getTransform());

      setTargetSensorGroup(%newObj.target, %newObj.team);
      $AIVehicleSet.add(%newObj);//adding Vehicle to $AiVehicleSet - Lagg...
      MissionCleanup.add(%newObj);
      %data.onAdd(%newObj);// <-- New line: This adds the turret for bomber/tank - Thanks Lt. Earthworm
      if (%marker.deployed)
      {
         error("VehicleData::respawn - Scheduling a deploy in 6 seconds with a FORCE - LaggsDefault4_Vehicle.cs"); //debugging purposes - Lagg...
         %data.schedule(6000, "vehicleDeploy", %newObj, 0, 1);
      }  
   }
   else
   {
      error("VehicleData::respawn we are block so schedule a check again in 3 seconds");

      %marker.schedule = %data.schedule(3000, "respawn", %marker);
   }
}

//------------------------------------------------------------------------------
//this should fix tank respawn error - thanks Lt. Earthworm
//function HoverVehicleData::create(%block, %team, %oldObj)//fix here - Lagg 1-23-2004
function HoverVehicleData::create(%data, %team, %oldObj)
{
   if(%oldObj $= "")
   {
      %obj = new HoverVehicle() 
      {
         //dataBlock  = %block;//fix here
         dataBlock  = %data;
         respawn    = "0";
         teamBought = %team;
         team = %team;
      };
   }
   else
   {
      %obj = new HoverVehicle() 
      {
         dataBlock  = %data;
         respawn    = "0";
         teamBought = %team;
         team = %team;
         mountable = %oldObj.mountable;
         disableMove = %oldObj.disableMove;
         resetPos = %oldObj.resetPos;
         respawnTime = %oldObj.respawnTime;
         marker = %oldObj;
      }; 
   }

   %obj.rpgLvl = 1;
   %obj.rpgTotalHpMultiplier = 0.02;
   %obj.rpgTotalDmgMultiplier = 0.02;
   %obj.rpgTotalVehEngrMultiplier = 0;
   
   return(%obj);
}

//------------------------------------------------------------------------------------
//well this fixes a typo in the function name - Lagg... 1-23-2004
//this should be included inside a package because exec will not overwrite it at mission done * (Note to Lagg)
//function HoverVehicleData::switchSides(%data, %oldObj)
function HoverVehicleData::switchSidesSetPos(%data, %oldObj)
{
   %team = %oldObj.curTeam == 1 ? 2 : 1;
   %oldObj.curTeam = %team;
   %obj = new HoverVehicle()
   {
      dataBlock  = %data;
      respawn    = "0";
      teamBought = %team;
      team = %team;
      mountable = %oldObj.mountable;
      disableMove = %oldObj.disableMove;
      resetPos = %oldObj.resetPos;
      respawnTime = %oldObj.respawnTime;
      marker = %oldObj;
   };
   %obj.setTransform(%oldObj.getTransform());
   return(%obj);
}

//---------------------------------------------------------------------------------------------------------------
//made a change here to allow deploy of mpb when switching sides ------------------------------- - Lagg 9-18-2003
function WheeledVehicleData::switchSidesSetPos(%data, %oldObj)
{
   %team = %oldObj.curTeam == 1 ? 2 : 1;
   %oldObj.curTeam = %team;
   %obj = new WheeledVehicle() 
   {
      dataBlock  = %data;
      respawn    = %oldObj.respawn;//added - Lagg... 12-15-2003
      teamBought = %team;
      team = %team;
      mountable = %oldObj.mountable;
      disableMove = %oldObj.disableMove;
      resetPos = %oldObj.resetPos;
      deployed = %oldObj.deployed;
      respawnTime = %oldObj.respawnTime;
      marker = %oldObj;
   };   
   %obj.setTransform(%oldObj.getTransform());

   if (%obj.deployed && $Host::warmupTime <= 0)
      %data.schedule($Host::Siege::Halftime + 6000, "vehicleDeploy", %obj, 0, 1);
       
   return(%obj);
}

//------------------------------------------------------------------------
//fixes MPB falling through terrain bug                - Lagg... 5-26-2005
//borroring more stuff from ZOD (version2)
function MobileBaseVehicle::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.station = "";
   %obj.turret = "";
   %obj.beacon = "";

   %obj.schedule(500, "playThread", $AmbientThread, "ambient");

   //echo("MPB " @ %obj @ " created.  Starting black-hole thread.");
   %obj.checkFreefall();
}

//----------------------------
// THUNDERSWORD BOMBER
//----------------------------

//----------------------------------------------------------------------------
//added bomb sight for pilot to assist in game performance - Lagg... 5-26-2005   --- REMOVE THIS FUNCTION
function BomberFlyer::playerMounted(%data, %obj, %player, %node)
{
   //error("n/BomberFlyer::playerMounted - ");
   //echo("     data = " @ %data.getName());
   //echo("     obj = " @ %obj.getdataBlock().getName());
   //echo("     node = " @ %node);
   //echo(" ");
   
   if(%node == 0)
   {
      // pilot position
      %player.setPilot(true);
      commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);

      //added to give te pilot something to aim with - Lagg...
      commandToClient(%player.client, 'startBomberSight');

      %turret = %obj.getMountNodeObject(10);
      %turret.rpgLvl = %obj.rpgLvl;
      %turret.rpgTotalHpMultiplier = %obj.rpgTotalHpMultiplier;
      %turret.rpgTotalDmgMultiplier = %obj.rpgTotalDmgMultiplier;
   }
   else if(%node == 1)
   {
      // bombardier position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      commandToClient(%player.client, 'startBomberSight');
      %turret.bomber = %player;
      $bWeaponActive = 0;
      %obj.getMountNodeObject(10).selectedWeapon = 1;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);

	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
      %player.isBomber = true;
   }
   else
   {
      // tail gunner position     
      commandToClient(%player.client, 'setHudMode', 'Passenger', "Bomber", %node);
   }
   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);

   // send the string of passengers to all mounted players
   for(%i = 0; %i < %data.numMountPoints; %i++)
      if(%obj.getMountNodeObject(%i) > 0)
         commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

//---------------------------------------------------------------------------------
//check for MPB falling through terrain
function WheeledVehicle::checkFreefall(%obj)					
{
   //echo("WheeledVehicle::checkFreefall");

   if(getword(%obj.getposition(), 2) > -2000)
   {
      cancel(%obj.freefallThread);
      %obj.freefallThread = %obj.schedule(10000, checkFreefall);
      return;
   }
   //if (%obj.getMountNodeObject(%i))
   if (%obj.getMountNodeObject(0))
   {
      %passenger = %obj.getMountNodeObject(0);

      if(%passenger.isMounted())
         %passenger.getDataBlock().doDismount(%passenger);

      %passenger.scriptKill(0);
      
      //%passenger.unmount();
      //error("WheeledVehicle::checkFreefall - MPB Driver was scriptKilled :) " @ getTaggedString(%client.name));
   }
   echo("BLACK HOLE: MPB " @ %obj @ " found at " @ %obj.position @ "m altitude and was destroyed");
   messageteam(%obj.team, 'msg', "\c2Your team's MPB fell into a black hole and was destroyed~wfx/misc/lightning_impact.wav");
   %obj.damage(0, %obj.position, 99999, $DamageType::Lightning);
}

//---------------------------------------------------------------------------------
//cancel the MPB's scheduled thread - Lagg... 5-12-2005
function VehicleData::onRemove(%this, %obj)
{
   //error("VehicleData::onRemove - " @ %this.getName());

   //remove any mounted turrets, beacons, etc...
   %this.deleteAllMounted(%obj);

   // if there are passengers/driver, kick them out
   for(%i = 0; %i < %obj.getDatablock().numMountPoints; %i++)
      if (%obj.getMountNodeObject(%i))
      {
         %passenger = %obj.getMountNodeObject(%i);
         %passenger.unmount();
      }

   //cancel check for MPB falling through terrain - Lagg... 5-12-2005
   if (%obj.freefallThread !$= "")
      cancel(%obj.freefallThread);

   vehicleListRemove(%obj.getDataBlock(), %obj);
   if(%obj.lastPilot.lastVehicle == %obj)
      %obj.lastPilot.lastVehicle = "";      

   Parent::onRemove(%this, %obj);
}

//don't let would be modders mess everything up - Lagg...
$VehicleRespawnTime        = 15000;
$Vehiclemax[ScoutVehicle]     = 4;
$VehicleMax[AssaultVehicle]   = 3;
$VehicleMax[MobileBaseVehicle]  = 1;
$VehicleMax[ScoutFlyer]       = 4;
$VehicleMax[BomberFlyer]      = 2;
$VehicleMax[HAPCFlyer]        = 2;
