package No_Quarter_Siege {
// ---------------------------------------------------------------------------- begin No_Quarter_Siege package ------------------------------------------

//------------------------------------------------------------------------------------------------ SiegeGame::gameOver ---

function SiegeGame::gameOver( %game )
{	
   deactivatePackage(No_Quarter_Siege);
   error("SiegeGame::gameOver - deacitavting No_Quarter_Siege package");
   SiegeGame::gameOver( %game );
}

//----------------------------------------------------------------------------------------------

function SiegeGame::claimFlipflopResources(%game, %flipflop, %team)
{
   %defTeam = game.offenseTeam == 1 ? 2 : 1;

   %group = %flipflop.getGroup();
   %group.setTeam(%team);

   //set the waypoint to the appropriate team
   if(%flipflop.waypoint)
   {
      %wayPoint = %flipflop.waypoint;
      game.switchWaypoint(%wayPoint);
   }
   
   // make this always visible in the commander map (gets reset when sensor group gets changed)
   setTargetAlwaysVisMask(%flipflop.getTarget(), 0xffffffff);

   //lets do custom spawning stuff here
   if (%flipflop == nameToId("TowerFlipFlop"))
   {
      if (%team == %defTeam)
      {
         nameToId("NorthSpawn").sphereWeight = 100;
         nameToId("WestSpawn").sphereWeight = 100;
         nameToId("EastSpawn").sphereWeight = 100;
         nameToId("TowerDefense").sphereWeight = 50;
         nameToId("MainBase").sphereWeight = 50;
         nameToId("TowerOffense").sphereWeight = 0;
      }
      else if (%team == game.offenseTeam)
      {
         nameToId("TowerOffense").sphereWeight = 100;
         nameToId("NorthSpawn").sphereWeight = 0;
         nameToId("WestSpawn").sphereWeight = 0;
         nameToId("EastSpawn").sphereWeight = 0;
         nameToId("MainBase").sphereWeight = 100;         
         nameToId("TowerDefense").sphereWeight = 0;
      }
   }   
}


//------------------------------------------------------------------------------------------------

function FlipFlop::playerTouch(%data, %flipflop, %player)
{
   %client = %player.client;
   %flipTeam = %flipflop.team;

   if(%flipTeam == %client.team)
      return false;

   %defTeam = game.offenseTeam == 1 ? 2 : 1;

   if (%flipflop == nameToId("Objective"))
   {
      if(%player.team != Game.offenseTeam)
      return;

      rpgKillAward(%player.client, %flipflop); //award stuff for a flipflip capture - roberto

      %siegeCapturedIn = getSimTime() - Game.startTimeMS;
      updateRecordsSpecial(%player.client, %siegeCapturedIn);

      //%defTeam = Game.offenseTeam == 1 ? 2 : 1;
      Game.capPlayer[Game.offenseTeam] = stripChars( getTaggedString( %player.client.name ), "\cp\co\c6\c7\c8\c9" );

      // Let the observers know:
      messageTeam( 0, 'MsgSiegeTouchFlipFlop', '\c2%1 captured the %2 base!~wfx/misc/flipflop_taken.wav', %player.client.name, $TeamName[%defTeam] );

      // Let the teammates know:
      messageTeam( %player.team, 'MsgSiegeTouchFlipFlop', '\c2%1 captured the %2 base!~wfx/misc/flipflop_taken.wav', %player.client.name, $TeamName[%defTeam] );

      // Let the other team know:
      %losers = %player.team == 1 ? 2 : 1;
      messageTeam( %losers, 'MsgSiegeTouchFlipFlop', '\c2%1 captured the %2 base!~wfx/misc/flipflop_lost.wav', %player.client.name, $TeamName[%defTeam]);

      logEcho(%player.client.nameBase@" (pl "@%player@"/cl "@%player.client@") captured team "@%defTeam@" base");
       
      Game.allObjectivesCompleted();
   }
   else if (%flipflop == nameToId("TowerFlipFlop")) 
   {
      %teamName = game.getTeamName(%client.team);

      // Let the observers know:
      messageTeam( 0, 'MsgClaimFlipFlop', '\c2%1 claimed %2 for %3.~wfx/misc/flipflop_taken.wav', %client.name, Game.cleanWord( %flipflop.name ), %teamName );

      // Let the teammates know:
      messageTeam( %client.team, 'MsgClaimFlipFlop', '\c2%1 claimed %2 for %3.~wfx/misc/flipflop_taken.wav', %client.name, Game.cleanWord( %flipflop.name ), %teamName );

      // Let the other team know:
      %losers = %client.team == 1 ? 2 : 1;
      messageTeam( %losers, 'MsgClaimFlipFlop', '\c2%1 claimed %2 for %3.~wfx/misc/flipflop_lost.wav', %client.name, Game.cleanWord( %flipflop.name ), %teamName );

      logEcho(%client.nameBase@" (pl "@%player@"/cl "@%client@") claimed flipflop "@%flipflop@" for team "@%client.team);

      //change the skin on the switch to claiming team's logo
      setTargetSkin(%flipflop.getTarget(), game.getTeamSkin(%player.team));
      setTargetSensorGroup(%flipflop.getTarget(), %player.team);

      // if there is a "projector" associated with this flipflop, put the claiming team's logo there
      if(%flipflop.projector > 0)
      {
         %projector = %flipflop.projector;
         // axe the old projected holo, if one exists
         if(%projector.holo > 0)
            %projector.holo.delete();
          
         %newHolo = getTaggedString(game.getTeamSkin(%client.team)) @ "Logo";

         %projTransform = %projector.getTransform();

         // below two functions are from deployables.cs
         %projRot = rotFromTransform(%projTransform);
         %projPos = posFromTransform(%projTransform);

         // place the holo above the projector (default 10 meters)
         %hHeight = %projector.holoHeight;
         if(%hHeight $= "")
            %hHeight = 10;
         %holoZ = getWord(%projPos, 2) + %hHeight;
         %holoPos = firstWord(%projPos) SPC getWord(%projPos,1) SPC %holoZ;

         %holo = new StaticShape() 
         {
            rotation = %projRot;
            position = %holoPos;
            dataBlock = %newHolo;
         };
         // dump the hologram into MissionCleanup
         MissionCleanup.add(%holo);

         // associate the holo with the projector
         %projector.holo = %holo;
      }

      // convert the resources associated with the flipflop
      Game.claimFlipflopResources(%flipflop, %client.team);
      
      //call the ai function
      Game.AIplayerCaptureFlipFlop(%player, %flipflop);
      return true;
   }
}

//---------------------------------------------------------------------------------------

function FlipFlop::objectiveInit(%data, %flipflop)
{
   %defTeam = game.offenseTeam == 1 ? 2 : 1;

   if (%flipflop == nameToId("objective"))
   {
      Game.regObjective(%flipflop);
      setTargetSkin(%flipflop.getTarget(), $teamSkin[%defTeam]);//set to team skin
   }
   else
   {
      // add this flipflop to missioncleanup
      %flipflopSet = nameToID("MissionCleanup/FlipFlops");

      if(%flipflopSet <= 0)
      {
         %flipflopSet = new SimSet("FlipFlops");
         MissionCleanup.add(%flipflopSet);
      }
      %flipflopSet.add(%flipflop);

      // see if there's a holo projector associated with this flipflop
      // search the flipflop's folder for a holo projector
      // if one exists, associate it with the flipflop

      %flipflop.projector = 0;
      %folder = %flipflop.getGroup();
      for(%i = 0; %i < %folder.getCount(); %i++) 
      {
         %proj = %folder.getObject(%i);
         // weird, but line below prevents console error
         if(%proj.getClassName() !$= "SimGroup" && %proj.getClassName() !$= "InteriorInstance")
            if(%proj.getDatablock().getName() $= "LogoProjector") 
            {
               %flipflop.projector = %proj;
               %flipflop.projector.holo = 0;//set to team skin
               break;
            }
      }

      // may have been hidden
      %target = %flipFlop.getTarget();

      if(%target != -1)
      {
         // set flipflop to base skin
         setTargetSkin(%target, $teamSkin[%defTeam]);//set to team skin

         // make this always visible in the commander map
         setTargetAlwaysVisMask(%target, 0xffffffff);

         // make this always visible in the commander list
         setTargetRenderMask(%target, getTargetRenderMask(%target) | $TargetInfo::CommanderListRender);
      }
   }
}

//---------------------------------------------------------------------------------------

function SiegeGame::AIplayerCaptureFlipFlop(%game, %player, %flipFlop)
{
  //do nothing 
}

//---------------------------------------------------------------------------------------

function SiegeGame::missionLoadDone(%game)
{

   nameToId("NorthSpawn").sphereWeight = 100;
   nameToId("WestSpawn").sphereWeight = 100;
   nameToId("EastSpawn").sphereWeight = 100;
   nameToId("TowerDefense").sphereWeight = 50;

   nameToId("MainBase").sphereWeight = 50;
   nameToId("TowerOffense").sphereWeight = 0;
	
   Parent::missionLoadDone(%game);

   Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;
}

//do the gens down stuff here
function Generator::onDisabled(%data, %obj)
{
   Parent::onDisabled(%data, %obj);

   if (%obj == nameToId("BaseGenerator1") || %obj == nameToId("BaseGenerator2"))
   {
      //send it through the power control function
      powerSimgroup(nameToId("BaseGens"));

      if (nameToId("BaseGens").powerCount == 1)
      {		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
               bottomPrint(%client, "<color:FF0000>\Base Main Power Generators Disabled", 8, 1);
            else if (%client.team == Game.offenseTeam)
               bottomPrint(%client, "<color:8BBD03>\Base Main Power Generators Disabled", 8, 1);
         }
      }
   }

   if (%obj == nameToId("EntranceFFGenS") || %obj == nameToId("EntranceFFGenN"))
   {
      //send it through the power control function
      powerSimgroup(nameToId("EntGens"));

      if (nameToId("EntGens").powerCount == 1)
      {		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
               bottomPrint(%client, "<color:FF0000>\Entrance Force Field Generators Disabled", 8, 1);
            else if (%client.team == Game.offenseTeam)
               bottomPrint(%client, "<color:8BBD03>\Entrance Force Field Generators Disabled: Main Base Access Granted", 8, 1);
         }
      }
   }

   if (%obj == nameToId("InnerFFGenerator1") || %obj == nameToId("InnerFFGenerator2"))
   {
      //send it through the power control function
      powerSimgroup(nameToId("InnerFFGens"));

      if (nameToId("InnerFFGens").powerCount == 1)
      {		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
               bottomPrint(%client, "<color:FF0000>\Inner Base Force Field Generators Disabled", 8, 1);
            else if (%client.team == Game.offenseTeam)
               bottomPrint(%client, "<color:8BBD03>\Inner Base Force Field Generators Disabled: Inner Base Access Granted", 8, 1);
         }
      }
   }

   if (%obj == nameToId("SwitchGenerator"))
   {
      if (nameToId("SwitchGenerator").getGroup().powerCount == 0)
      {		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
               bottomPrint(%client, "<color:FF0000>\Objective Switch ForceField Generator Disabled: Objective Switch Exposed", 8, 1);
            else if (%client.team == Game.offenseTeam)
               bottomPrint(%client, "<color:8BBD03>\Objective Switch ForceField Generator Disabled: Objective Switch Exposed", 8, 1);
         }
      }
   }
}

//----------------------------------------------------------------------------------------------------------------------------------------------

//the gens up stuffs
function Generator::onEnabled(%data, %obj, %prevState)
{
   Parent::onEnabled(%data, %obj, %prevState);

   if (%obj == nameToId("BaseGenerator1") || %obj == nameToId("BaseGenerator2"))
   {
      //send it through the power control function
      powerSimgroup(nameToId("BaseGens"));

      if (nameToId("BaseGens").powerCount > 1)
      {	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
               bottomPrint(%client, "<color:8BBD03>\Base Main Power Generators Restored", 8, 1);
            else if (%client.team == Game.offenseTeam)
               bottomPrint(%client, "<color:FF0000>\Base Main Power Generators Restored", 8, 1);
         }
      }
   }

   if (%obj == nameToId("EntranceFFGenS") || %obj == nameToId("EntranceFFGenN"))
   {
      //send it through the power control function
      powerSimgroup(nameToId("EntGens"));

      if (nameToId("EntGens").powerCount > 1)
      {	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
               bottomPrint(%client, "<color:8BBD03>\Entrance Force Field Generators Restored", 8, 1);
            else if (%client.team == Game.offenseTeam)
               bottomPrint(%client, "<color:FF0000>\Entrance Force Field Generators Restored: Main Base Access Denied", 8, 1);
         }
      }
   }

   if (%obj == nameToId("InnerFFGenerator1") || %obj == nameToId("InnerFFGenerator2"))
   {
      //send it through the power control function
      powerSimgroup(nameToId("InnerFFGens"));

      if (nameToId("InnerFFGens").powerCount > 1)
      {	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
               bottomPrint(%client, "<color:8BBD03>\Inner Base Force Field Generators Restored", 8, 1);
            else if (%client.team == Game.offenseTeam)
               bottomPrint(%client, "<color:FF0000>\Inner Base Force Field Generators Restored: Inner Base Access Denied", 8, 1);
         }
      }
   }

   if (%obj == nameToId("SwitchGenerator"))
   {
      if (nameToId("SwitchGenerator").getGroup().powerCount > 0)
      {	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
               bottomPrint(%client, "<color:8BBD03>\Objective Switch Force Field Generator Restored", 8, 1);
            else if (%client.team == Game.offenseTeam)
               bottomPrint(%client, "<color:FF0000>\Objective Switch Force Field Generator Restored", 8, 1);
         }
      }
   }
}

function SiegeGame::halftime(%game, %reason)
{
   Parent::halftime(%game, %reason);

   Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;

   //reset spwan sphere weights
   nameToId("NorthSpawn").sphereWeight = 100;
   nameToId("WestSpawn").sphereWeight = 100;
   nameToId("EastSpawn").sphereWeight = 100;

   nameToId("EntranceDefense").sphereWeight = 50;
   nameToId("MainBase").sphereWeight = 50;
   nameToId("TowerOffense").sphereWeight = 0;

   %flipflop = nameToId("TowerFlipFlop");

   //change the skin on the switch to defense team's logo
   setTargetSkin(%flipflop.getTarget(), game.getTeamSkin(Game.defenseTeam));
   setTargetSensorGroup(%flipflop.getTarget(), Game.defenseTeam);

   Game.claimFlipflopResources(%flipflop, Game.defenseTeam);
   
   //clear bottom print messages
   clearBottomPrintAll();
}

function SiegeGame::halftimeOver( %game )
{
   // drop all players into mission
   %game.dropPlayers();

   //setup the AI for the second half
   %game.aiHalfTime();
   
   // start the mission again (release players)
   %game.halfTimeCountDown( 0 );

   //redo the objective waypoints
   %game.findObjectiveWaypoints();

   //set up ai vehicle functions for second half - Lagg... 10-2-2003   
   SweepForPads(NameToID(MissionGroup));
}

function SiegeGame::claimSpawn(%game, %obj, %newTeam, %oldTeam)
{
   //we don't claim spawns this way - Lagg... 12-9-2003   
}

function GameStartUp()
{
   $ObjectiveCounter[1] = 0;
   $ObjectiveCounter[2] = 0;
 
   if ($missionRunning == false)
   {
      schedule(500, 0, GameStartUp);
      return;
   }
   SweepForPads(NameToID(MissionGroup)); 
}

function SweepForPads(%simGroup)
{
   Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;

   if(%SimGroup.getClassName() $= "SimGroup")
   {
      for (%i = 0; %i < %SimGroup.getCount(); %i++)
      {
         %obj = %SimGroup.getObject(%i);
         if (%obj.getClassName() $= "SimGroup")
         {
            SweepForPads(%obj);
         }
 
         if (%obj.getClassName() $= "StaticShape")
         {
            if (%obj.getDataBlock().getName() $= "StationVehicle")
            {
               //addVPadObjective(%obj);
                $AIVehiclePadSet.add(%obj);
            }
            if (%obj.getDataBlock().getName() $= "MPBTeleporter")
            {
               //addVPadObjective(%obj);
               $AITeleportSet.add(%obj);
            }
            //but the defTeam Holo at mission start and halftime
            if (%obj == nameToId("TowerFlipFlop"))
            {
               // if there is a "projector" associated with this flipflop, put the claiming team's logo there
               if(%obj.projector > 0)
               {
                  %projector = %obj.projector;
                  // axe the old projected holo, if one exists
                  //if(%projector.holo > 0)
                  if(isObject(%projector.holo))
                     %projector.holo.delete();
          
                  %newHolo = getTaggedString(game.getTeamSkin(Game.defenseTeam)) @ "Logo";

                  %projTransform = %projector.getTransform();
                  // below two functions are from deployables.cs
                  %projRot = rotFromTransform(%projTransform);
                  %projPos = posFromTransform(%projTransform);
                  // place the holo above the projector (default 10 meters)
                  %hHeight = %projector.holoHeight;
                  if(%hHeight $= "")
                     %hHeight = 10;
                  %holoZ = getWord(%projPos, 2) + %hHeight;
                  %holoPos = firstWord(%projPos) SPC getWord(%projPos,1) SPC %holoZ;

                  %holo = new StaticShape() 
                  {
                     rotation = %projRot;
                     position = %holoPos;
                     dataBlock = %newHolo;
                  };
                  // dump the hologram into MissionCleanup
                  MissionCleanup.add(%holo);
                  // associate the holo with the projector
                  %projector.holo = %holo;
                  
                  error("Setting HOLO PROJECTOR: Defense Team");
               }
            }
         }      
      }
   }
}

function addVPadObjective(%object)
{
   if(%object.team > 0)
   {
      %homeTeam = %object.team;
      if(%homeTeam == 1)
         %enemyTeam = 2;
      else
         %enemyTeam = 1;

      //create the repair objective
      %repairVPad = new AIObjective(AIORepairObject)
                     {
						      dataBlock = "AIObjectiveMarker";
                        weightLevel1 = $AIWeightRepairTurret[1];
                        weightLevel2 = $AIWeightRepairTurret[2];
                        description = "Repair the " @ %object.getDataBlock().getName();
                        targetObject = %object.getDataBlock().getName();
                        targetObjectId = %object;
                        targetClientId = -1;
                        offense = true;
                        equipment = "RepairPack";
								buyEquipmentSet = "MediumRepairSet";
                        location             = %object.getWorldBoxCenter();
		        position	     = %object.getWorldBoxCenter();
                     };
      MissionCleanup.add(%repairVPad);
      $ObjectiveQ[%homeTeam].add(%repairVPad);

      //for siege game we add it twice
     // MissionCleanup.add(%repairVPad);
      //$ObjectiveQ[%enemyTeam].add(%repairVPad);

      //create the mortar objective
      %mortarVPad = new AIObjective(AIOMDestroyObject)
                     {
						      dataBlock = "AIObjectiveMarker";
                        weightLevel1 = $AIWeightRepairTurret[1];
                        weightLevel2 = $AIWeightRepairTurret[2];
                        description = "Mortar the " @ %object.getDataBlock().getName();
                        targetObject = %object.getDataBlock().getName();
                        targetObjectId = %object;
                        targetClientId = -1;
                        offense = true;
                        equipment = "Mortar MortarAmmo";
								buyEquipmentSet = "HeavyAmmoSet";
                        location             = %object.getWorldBoxCenter();
		        position	     = %object.getWorldBoxCenter();
                     };
      MissionCleanup.add(%mortarVPad);
      $ObjectiveQ[%enemyTeam].add(%mortarVPad);

      //for siege game we add it twice - not needed in this mission
       //MissionCleanup.add(%mortarVPad);
      //$ObjectiveQ[%homeTeam].add(%mortarVPad);
   }
}

//---------------------------------------------------------------------------------------------------------
//new function that allows for multiple generators to act as they should if %25 or more of the generators are destroyed there will
// be no power to the simgroup - Thank ZOD for the idea a long time ago. - Lagg... 4/9/09


function powerSimgroup(%simgroup)
{
   %howMany = 0;
   %notWorking = 0;
   %count = %simgroup.getCount();

   for (%i = 0; %i < %count; %i++)
   {
      %obj = %simGroup.getObject(%i);
      if (%obj.getDataBlock().className $= "Generator")
      {

         //how many gen objects in simgroup?
         %howMany ++;

         //how many are disabled
         if (%obj.isDisabled())
            %notWorking ++;

      }
   }

   //the total number of Generators/Solar  Panels

   error("function countGens -    Total # = " @ %howMany);
   error("function countGens - disabled # = " @ %notWorking);

   if (%simgroup $= nameToId("EntGens"))
   {
      if (%notWorking >= 1)
         nameToId("RealEntranceGen").setDamageLevel(2.5);
      else
         nameToId("RealEntranceGen").setDamageLevel(0);
   }
   else if (%simgroup $= nameToId("BaseGens"))
   {
      if (%notWorking >= 1)
         nameToId("RealBaseGen").setDamageLevel(2.5);
      else
         nameToId("RealBaseGen").setDamageLevel(0);
   }
   else if (%simgroup $= nameToId("InnerFFGens"))
   {
      if (%notWorking >= 1)
         nameToId("RealInnerFFGen").setDamageLevel(2.5);
      else
         nameToId("RealInnerFFGen").setDamageLevel(0);
   }
}

//--------------------------------------------------------------------------------------------


// ---------------------------------------------------------------------------- end No_Quarter_Siege package --------------------------------------------
};






