//-----------------------------------//
//        AI SCRIPT FUNCTIONS        //
//-----------------------------------//

//first, exec the supporting scripts
exec("scripts/aiDebug.cs");
exec("scripts/aiDefaultTasks.cs");
exec("scripts/aiObjectives.cs");
exec("scripts/aiInventory.cs");
exec("scripts/aiChat.cs");
exec("scripts/aiHumanTasks.cs");
exec("scripts/aiObjectiveBuilder.cs");
exec("scripts/aiBotProfiles.cs");

$AIModeStop = 0;
$AIModeWalk = 1;
$AIModeGainHeight = 2;
$AIModeExpress = 3;
$AIModeMountVehicle = 4;

$AIClientLOSTimeout = 15000;	//how long a client has to remain out of sight of the bot
										//before the bot "can't see" the client anymore...
$AIClientMinLOSTime = 10000;	//how long a bot will search for a client


//-----------------------------------//
//Objective weights - level 1

$AIWeightCapFlag[1]           = 5000;	//range 5100 to 5320
$AIWeightKillFlagCarrier[1]   = 4800;	//range 4800 to 5120
$AIWeightReturnFlag[1]        = 5001;	//range 5101 to 5321
$AIWeightDefendFlag[1]        = 3900;	//range 4000 to 4220
$AIWeightGrabFlag[1]          = 3850;	//range 3950 to 4170

$AIWeightDefendFlipFlop[1]		= 3900;  //range 4000 to 4220
$AIWeightCaptureFlipFlop[1]	= 3850;  //range 3850 to 4170

$AIWeightAttackGenerator[1]   = 3100;	//range 3200 to 3520 
$AIWeightRepairGenerator[1]   = 3200;	//range 3300 to 3620
$AIWeightDefendGenerator[1]   = 3100;	//range 3200 to 3420

$AIWeightMortarTurret[1]      = 3400;	//range 3500 to 3600
$AIWeightLazeObject[1]        = 3200;  //range 3300 to 3400
$AIWeightRepairTurret[1]      = 3100;  //range 3200 to 3420

$AIWeightAttackInventory[1]   = 2900;	//range 2800 to 2920 
$AIWeightRepairInventory[1]   = 2900;	//range 2800 to 2920

$AIWeightEscortOffense[1]     = 2900;  //range 2800 to 2920 
$AIWeightEscortCapper[1]      = 3250;	//range 3350 to 3470

//used to allow a bot to finish tasks once started.
$AIWeightContinueDeploying		= 4250;
$AIWeightContinueRepairing		= 4250;

//Objective weights from human
$AIWeightHumanIssuedCommand		= 4450;
$AIWeightHumanIssuedEscort			= 4425;

//Objective weights - level 2
$AIWeightCapFlag[2]           =    0;	//only one person can ever cap a flag
$AIWeightKillFlagCarrier[2]   = 4800;	//range 4800 to 5020
$AIWeightReturnFlag[2]        = 4100;	//range 4200 to 4320
$AIWeightDefendFlag[2]        = 2000;	//range 2100 to 2220
$AIWeightGrabFlag[2]          = 2000;	//range 2100 to 2220

$AIWeightDefendFlipFlop[2]		= 2000;  //range 2100 to 2220
$AIWeightDefendFlipFlop[3]		= 1500;  //range 1600 to 1720
$AIWeightDefendFlipFlop[4]		= 1000;  //range 1100 to 1220

$AIWeightAttackGenerator[2]   = 1600;	//range 1700 to 1920 
$AIWeightRepairGenerator[2]   = 1600;	//range 1700 to 1920
$AIWeightDefendGenerator[2]   = 1500;	//range 1600 to 1720

$AIWeightAttackInventory[2]   = 1400;	//range 1500 to 1720 
$AIWeightRepairInventory[2]   = 1400;	//range 1500 to 1720

$AIWeightMortarTurret[2]      = 1000;	//range 1100 to 1320
$AIWeightLazeObject[2]        =    0;  //no need to have more than one targetter
$AIWeightRepairTurret[2]      = 1000;  //range 1100 to 1320

$AIWeightEscortOffense[2]     = 2900;  //range 3300 to 3420 
$AIWeightEscortCapper[2]      = 3000;	//range 3100 to 3220


//------------------------------------------------------------------------------------------------------------------------
// AI Name Generator v1.1
// Takes strings below to piece together a name
// Created by Keen - http://radiantage.com
// Overrides server settings on bots, gives them custom skins, creates male,
// female, bioderm, and actual bot bots.
//WAW
$RandomBotGenName[0] = "Sami-FIN";
$RandomBotGenName[1] = "TheBeeman!!";
$RandomBotGenName[2] = "EnvyAcid";
$RandomBotGenName[3] = "ReD ToRnado";
$RandomBotGenName[4] = "dosanti";
$RandomBotGenName[5] = "Exquisite";
$RandomBotGenName[6] = "Shivan-";
$RandomBotGenName[7] = "The D_e_V_i_L";
$RandomBotGenName[8] = "high5slayer";
$RandomBotGenName[9] = "FallenOne";
$RandomBotGenName[10] = "Krell";
$RandomBotGenName[11] = "-)ShadowKiller(-";
$RandomBotGenName[12] = "codak";
$RandomBotGenName[13] = "Thraque";
$RandomBotGenName[14] = "Halo 2";
$RandomBotGenName[15] = "Thyth";
$RandomBotGenName[16] = "--Big Zorak--";
$RandomBotGenName[17] = "Morgor";
$RandomBotGenName[18] = "Ziphar";
$RandomBotGenName[19] = "AlphaSentinel";
$RandomBotGenName[20] = "7th_Bishop";
$RandomBotGenName[21] = "Donald Trump";
$RandomBotGenName[22] = "Spongebath";
$RandomBotGenName[23] = "Thaen";
$RandomBotGenName[24] = "idjit";
$RandomBotGenName[25] = "Red Fraction";
$RandomBotGenName[26] = "Explicit!";
$RandomBotGenName[27] = "Blakhart";
$RandomBotGenName[28] = "serafine";
$RandomBotGenName[29] = "JesusChrist";
$RandomBotGenName[30] = "Notdos";
$RandomBotGenName[31] = "teratos";
$RandomBotGenName[32] = "Silent Eagle";
$RandomBotGenName[33] = "CoorsLightMan";
$RandomBotGenName[34] = "Biker";
$RandomBotGenName[35] = "Winged Warrior";
$RandomBotGenName[36] = "Cut-N-Shoot";
$RandomBotGenName[37] = "ADiDaSWaRRiOR";
$RandomBotGenName[38] = "[M]omo";
$RandomBotGenName[39] = "2SmOkeD";
$RandomBotGenName[40] = "ZurkinWood497";
$RandomBotGenName[41] = "BoMb_MaRLeY";
$RandomBotGenName[42] = "Moniker";
$RandomBotGenName[43] = "Faeywin";
$RandomBotGenName[44] = "Infernus";
$RandomBotGenName[45] = "monkeyhero";
$RandomBotGenName[46] = "Zergon MA";
$RandomBotGenName[47] = "zelta1";
$RandomBotGenName[48] = "ItchySnatch";
$RandomBotGenName[49] = "-=Hot|Ice=-";
$RandomBotGenName[50] = "Sylock";
$RandomBotGenName[51] = "inflow";
$RandomBotGenName[52] = "DRDigitalSr";
$RandomBotGenName[53] = "Scaled_One";
$RandomBotGenName[53] = "LOLCAPS";
$RandomBotGenName[54] = "Rooster128";
$RandomBotGenName[55] = "NumberOneSon";
$RandomBotGenName[56] = "slush";
$RandomBotGenName[57] = "TurretsSyndrome";
$RandomBotGenName[58] = "HDP|Tetchy";
$RandomBotGenName[59] = "ChocoTaco";
$RandomBotGenName[60] = "au66yrOldFart";
$RandomBotGenName[61] = "Vosk";
$RandomBotGenName[62] = "ElKapitan";
$RandomBotGenName[63] = "Sofaking-|-bakeD";
$RandomBotGenName[64] = "AllCreation";
$RandomBotGenName[65] = "OrieN";
$RandomBotGenName[66] = "rileygarbels";
$RandomBotGenName[67] = "ZuMie";
$RandomBotGenName[68] = "Stormcrow IV";
$RandomBotGenName[69] = "Glarm";
$RandomBotGenName[70] = "Icehawk^13^";
$RandomBotGenName[71] = "(STAR)earth";
$RandomBotGenName[72] = "fASE-2";
$RandomBotGenName[73] = "UDUD";
$RandomBotGenName[74] = "BOSS_DOGG";
$RandomBotGenName[75] = "MastaChief";
$RandomBotGenName[76] = "kizz";
$RandomBotGenName[77] = "NiTeCrawler";
$RandomBotGenName[78] = "^Rayne";
$RandomBotGenName[79] = "0wnj0o";
$RandomBotGenName[80] = "Crusher";
$RandomBotGenName[81] = "NightWear";
$RandomBotGenName[82] = "Dirk";
$RandomBotGenName[83] = "Dream Injection";
$RandomBotGenName[84] = "MrCerumen";
$RandomBotGenName[85] = "Hinton2009";
$RandomBotGenName[86] = "Shemale Warrior";
$RandomBotGenName[87] = "Synaux";
$RandomBotGenName[88] = "TheMediocre";
$RandomBotGenName[89] = "bran";
$RandomBotGenName[90] = "WankBullet";
$RandomBotGenName[91] = "Lagg-Alot";
$RandomBotGenName[92] = "Bleron";
$RandomBotGenName[93] = "Calimoli";
$RandomBotGenName[94] = "Anthem";
$RandomBotGenName[95] = "helvetica";
$RandomBotGenName[96] = "ryanator";
$RandomBotGenName[97] = "FecalMatter";
$RandomBotGenName[98] = "frumS";
$RandomBotGenName[99] = "sniperwolf2";
$RandomBotGenName[100] = "MODAC1";
$RandomBotGenName[101] = "TerryTC";
$RandomBotGenName[102] = "John McClane";
$RandomBotGenName[103] = "HappyPuppy";
$RandomBotGenName[104] = "huntergirl10";
$RandomBotGenName[105] = "wiltedflower";
$RandomBotGenName[106] = "Shazslut";
$RandomBotGenName[107] = "ZProtoss";
$RandomBotGenName[108] = "Haltitall";
$RandomBotGenName[109] = "Sizz-LORR";
$RandomBotGenName[110] = "Hybrid";
$RandomBotGenName[111] = "iPrecision";
$RandomBotGenName[112] = "rJay_R116";  
$RandomBotGenName[113] = "Tarzul";
$RandomBotGenName[114] = "Reverend_Zen";
$RandomBotGenName[115] = "bakerdude";
$RandomBotGenName[116] = "Elvis Maximus";
$RandomBotGenName[117] = "A// EYeZ";
$RandomBotGenName[118] = "-MaLice--";
$RandomBotGenName[119] = "Carpenter";
$RandomBotGenName[120] = "Lube Job";
$RandomBotGenName[121] = "saKe";
$RandomBotGenName[122] = "Lionheart13";
$RandomBotGenName[123] = "sneakygnome";
$RandomBotGenName[124] = "Krash_";
$RandomBotGenName[125] = "SnappleWear";
$RandomBotGenName[126] = "CyClones";
$RandomBotGenName[127] = "oldbanjo";
$RandomBotGenName[128] = "^The-Punisher^";
$RandomBotGenName[129] = "Waldred";
$RandomBotGenName[130] = "blazzingroach";
$RandomBotGenName[131] = "Dys_Combobulated";
$RandomBotGenName[132] = "HappyMeal=)";
$RandomBotGenName[133] = "Penis";
$RandomBotGenName[134] = "general mcflury";
$RandomBotGenName[135] = "OldManRiver";
$RandomBotGenName[136] = "haan";

$RandomBotGenNameCount = 137;

$RandomBotGenPrefix[0] = "";
$RandomBotGenPrefix[1] = "";
$RandomBotGenPrefix[1] = "";

$RandomBotGenPrefixCount = 0;

$RandomBotGenSuffix[0] = "";

$RandomBotGenSuffixCount = 0;

$nameIndex = 0;

//-----------AI CHAT-----------
//The plan is to have the AI chat based on it's name (personality), mood, and it's need to respond to another AI's chat, but for now a simple chat is enough
//--TEXT CHAT--
$AIRandTextChatCount = 206;
$AIRandTextChat[0] = "anyone know where to download cheats from?";
$AIRandTextChat[1] = "Dude, just press ALT + F4 for hacks. Trust me, it works.";
$AIRandTextChat[2] = "All of you are chaingun pussies, get a real man's weapon.";
$AIRandTextChat[3] = "someone should ban slush already, he makes my PC lag :(";
$AIRandTextChat[4] = "The Sami lures an enemy into his disc!";
$AIRandTextChat[5] = "DON'T FUCKING llama grab the flag, you're ruining my caps";
$AIRandTextChat[6] = "how do I download Osiris Voice Pack?";
$AIRandTextChat[7] = "Can't believe there are so many people here, wohoo!";
$AIRandTextChat[8] = "tribes ascend > tribes 2";
$AIRandTextChat[9] = "fucking deadstops...";
$AIRandTextChat[10] = "I will now proceed to wipe my butt with the flag.";
$AIRandTextChat[11] = "For fucks sake, inv killing again?";
$AIRandTextChat[12] = "stupid cheaty fuck needs hack aimbots to win";
$AIRandTextChat[13] = "loser needs to cheat to win a fight";
$AIRandTextChat[14] = "god damn it, is anyone even defending our flag?";
$AIRandTextChat[15] = "I officially lost hope in this team";
$AIRandTextChat[16] = "I'm sleepy zzzZZZz, wake me up when something interesting happens";
$AIRandTextChat[17] = "My tribes 2 keeps getting UEs since last night, I just want to play...";
$AIRandTextChat[18] = "Well, I'm gonna keep voice spamming, you people better get used to it?";
$AIRandTextChat[19] = "tk me again and I'll vote kick you";
$AIRandTextChat[20] = "just because I play a female character does not mean I'm gay";
$AIRandTextChat[21] = "Man, why can't they just remake tribes 2 with better graphics?";
$AIRandTextChat[22] = "nice interpolate cheat";
$AIRandTextChat[23] = "Are you fucking blind? You keep fucking tking me, this is like the third time";
$AIRandTextChat[24] = "Where the hell is Zergon anyway?";
$AIRandTextChat[25] = "Muted";
$AIRandTextChat[26] = "stop voice spamming already, I'm just gonna mute you all";
$AIRandTextChat[27] = "Someone help me destroy the sensor already!";
$AIRandTextChat[28] = "can anyone plz give me admin, I'll make this server great again";
$AIRandTextChat[29] = "No deployable invs still... and you are wondering why we're losing";
$AIRandTextChat[30] = "hahahaha";
$AIRandTextChat[31] = "did you see that?";
$AIRandTextChat[32] = "LOL that was fucking hilarious";
$AIRandTextChat[33] = "I'm recording this and putting it on youtube";
$AIRandTextChat[34] = "man... this map again?";
$AIRandTextChat[35] = "Dunno about you but I like this map";
$AIRandTextChat[36] = "Who keeps stealing our repair pack?";
$AIRandTextChat[37] = "Nice mid airs dude";
$AIRandTextChat[38] = "thanks for the health kit sucker";
$AIRandTextChat[39] = "umm... STOP SPAMMING the flag when I'm trying to grab, thanks";
$AIRandTextChat[40] = "I am... Shazbot!";
$AIRandTextChat[41] = "I'm lagging a bit, is it just me or...?";
$AIRandTextChat[42] = "just hurry up and win...";
$AIRandTextChat[43] = "bombers are sooooo annoying";
$AIRandTextChat[44] = "Shut the fuck up dude, just play the game";
$AIRandTextChat[45] = "I love the terrain in this map";
$AIRandTextChat[46] = "Stop vote kicking people for no reason.";
$AIRandTextChat[47] = "we should play LAK rabbit with 25 people";
$AIRandTextChat[48] = "Focus on the flag and stop screwing around people, I know this is a pub but still...";
$AIRandTextChat[49] = "VEHICLE MAP next! Thanks!";
$AIRandTextChat[50] = "I bet that new guy here is afraid of me, he keeps running away lol";
$AIRandTextChat[51] = "shieldpack and chain, how typical. NO SKILLS";
$AIRandTextChat[52] = "getting real high right now... brb";
$AIRandTextChat[53] = "should I observe someone or keep playing? Hmmmm....";
$AIRandTextChat[54] = "He he he, I believe you just got Zergon'd";
$AIRandTextChat[55] = "someone vote for another map, I played this over 9000 times";
$AIRandTextChat[56] = "We should make tribes 1 players play t2, they don't know what they're missing out";
$AIRandTextChat[57] = "this is gonna sound weird... but does anyone enjoy the smell of their own farts?";
$AIRandTextChat[58] = "Stop eating the repair packs you doofus";
$AIRandTextChat[59] = "scummy cloakers, best you can do is shoot me when I can't see you. Losers!";
$AIRandTextChat[60] = "thanks man!";
$AIRandTextChat[61] = "I'm not sure about that, let me think...";
$AIRandTextChat[62] = "Is the admin here? I need to ask the admin something.";
$AIRandTextChat[63] = "ha ha! how could you miss that?";
$AIRandTextChat[64] = "Can we stop with the inv killing already...? I just wanna play >_<";
$AIRandTextChat[65] = "Raped! lol";
$AIRandTextChat[66] = "BOOM Headshot, BITCH";
$AIRandTextChat[67] = "Guys, which would you rather fight: one horse-sized duck, or 100 duck-sized horses?";
$AIRandTextChat[68] = "getting pretty hungry, I may be afk for a while";
$AIRandTextChat[69] = "Not there, they'll see us and ruin the plan retard";
$AIRandTextChat[70] = "WOW, well thanks for deploying so many invs guys, NOT. Move your asses.";
$AIRandTextChat[71] = "what kind of music do you guys listen to?";
$AIRandTextChat[72] = "j-rock is awesome";
$AIRandTextChat[73] = "I'm not really into country music...";
$AIRandTextChat[74] = "The music that I listen to is your screams as I blast you with a disc in the face.";
$AIRandTextChat[75] = "Mute me if you want, you're the one that will be missing out ";
$AIRandTextChat[76] = "yeah... mine disc me you coward, too afraid I'll hit you back?";
$AIRandTextChat[77] = "My name is Shaz Bot. You destroyed my generator. Prepare to die.";
$AIRandTextChat[78] = "someone should make an HD texture pack for tribes 2";
$AIRandTextChat[79] = "the admin of this server annoys me so much, always kicks me for no reason";
$AIRandTextChat[80] = "I think I played this map 10 times today";
$AIRandTextChat[81] = "stop chasing the heavies and just defend the flag... jesus";
$AIRandTextChat[82] = "If you ELF me I chain you, that's how it works boy";
$AIRandTextChat[83] = "Great skill dude, just spam everything with the mortar. Whatever.";
$AIRandTextChat[84] = "cheap groundshot, get some balls and fight me like a man";
$AIRandTextChat[85] = "this team has only one good player, me";
$AIRandTextChat[86] = "I'm sorry but LAK is only playable with like max 10 players";
$AIRandTextChat[87] = "too bad about Hunters, I really enjoy it but no one plays it :(";
$AIRandTextChat[88] = "playing arena back in the days was a blast, I wish people would play that again";
$AIRandTextChat[89] = "playing arena...? What about siege? Siege is also great!";
$AIRandTextChat[90] = "Ladies, just calm down, stop arguing, and play the game. Thanks.";
$AIRandTextChat[91] = "Tribes 2 ain't tribes without some assholes in the chat, he he he";
$AIRandTextChat[92] = "I don't have cheats, I'm just amazing.";
$AIRandTextChat[93] = "I'm hated by everyone because I'm just too good.";
$AIRandTextChat[94] = "it's 6 in the morning and I can't stop playing...";
$AIRandTextChat[95] = "damn heavy armor, that was always meant for players who can't play!";
$AIRandTextChat[96] = "Ahh, nothing better than being killed by random mines, thanks game";
$AIRandTextChat[97] = "satchel coward, stop beating the bush, face me so I can finish you";
$AIRandTextChat[98] = "has anyone heard about those bots modified to play classic? They are so goood";
$AIRandTextChat[99] = "What's wrong with Katabatic? It gets so much hate, but I like it.";
$AIRandTextChat[100] = "Tribes 2 is the best Counter Strike game!";
$AIRandTextChat[101] = "this fucking beeman guy keeps harrasing me!";
$AIRandTextChat[102] = "You just got STUNGED!";
$AIRandTextChat[103] = "I only used the F1 menu once, why is it even there? lol";
$AIRandTextChat[104] = "don't trust Indoor Turnips...";
$AIRandTextChat[105] = "Zergon will ride eternal, shiny and chrome.";
$AIRandTextChat[106] = "Do not become addicted to water, it will take hold of you and you will resent its absence.";
$AIRandTextChat[107] = "There are two kinds of people in the world, those with flares and those with missiles.";
$AIRandTextChat[108] = "I live. I die. I live again.";
$AIRandTextChat[109] = "shoot me again and I'll midair so hard you'll get an UE";
$AIRandTextChat[110] = "what's beeman's problem? fucking shocklancing faggot keeps stalking me";
$AIRandTextChat[111] = "ah, I need to practice more...";
$AIRandTextChat[112] = "I'm actually a female player. Don't hit on me boys!";
$AIRandTextChat[113] = "LOL, is that Sami taunting others? WTF";
$AIRandTextChat[114] = "why can't I just be paid to play tribes 2? I'd like that as my dayjob";
$AIRandTextChat[115] = "Where are the gens in this map?";
$AIRandTextChat[116] = "Crush your enemies, see them driven before you, and hear the lamentations of their women. That is good!";
$AIRandTextChat[117] = "You broke into my base, stole my tank, murdered by defenders, and THAT is what grieves me the most!";
$AIRandTextChat[118] = "What is a spinfusor compared to the hand that wields it?";
$AIRandTextChat[119] = "A day may come when the courage of this team fails, but it is not THIS day!";
$AIRandTextChat[120] = "One does not simply walk into the enemy base. Its assets are guarded by more than just Heavies.";
$AIRandTextChat[121] = "don't you dare suicide on me again, face me like a fucking man!";
$AIRandTextChat[122] = "They may destroy our generators, but they'll never take out our deployable invs!";
$AIRandTextChat[123] = "What did the leper say to the prostitute? Keep the tip!";
$AIRandTextChat[124] = "God gave women yeast infections so that they would know what it was like living with an irritating cunt for once.";
$AIRandTextChat[125] = "What do you call a black guy who flies a plane? A pilot, you racist asshole!";
$AIRandTextChat[126] = "Studies show that 9 out of 10 people enjoy gang rape.";
$AIRandTextChat[127] = "Gay jokes are never funny. Cum on guys!";
$AIRandTextChat[128] = "I hate people who use big words just to make themselves look perspicacious!";
$AIRandTextChat[129] = "If toast always lands butter-side down and cats always land on their feet, what happens if you strap toast to the back of a cat and drop it?";
$AIRandTextChat[130] = "My therapist says I have a preoccupation with vengeance. We'll see about that.";
$AIRandTextChat[131] = "I went to a karaoke bar last night that didn't play any 70s music. At first I was afraid. Oh, I was petrified.";
$AIRandTextChat[132] = "God gave men a penis and a brain, but unfortunately not enough blood supply to run both at the same time.";
$AIRandTextChat[133] = "I'm not addicted to cocaine. I just like the way it smells.";
$AIRandTextChat[134] = "I went to buy some camouflage trousers the other day, but I couldn't find any.";
$AIRandTextChat[135] = "A man walked into the doctor's. He said, 'I've hurt my arm in several places.' The doctor said, 'Well don't go there any more.'";
$AIRandTextChat[136] = "I've just read a book about Stockholm syndrome. It started off badly, but by the end I really liked it.";
$AIRandTextChat[137] = "Last night I almost had a threesome, I only needed two more people!";
$AIRandTextChat[138] = "How do you make Holy water? Boil the hell out of it.";
$AIRandTextChat[139] = "A blind man walks into a bar... And a table. And a chair.";
$AIRandTextChat[140] = "What is Bruce Lee's favorite drink? Wataaaaah!";
$AIRandTextChat[141] = "I asked God for a bike, but I know God doesn't work that way. So I stole a bike and asked for forgiveness.";
$AIRandTextChat[142] = "The last thing I want to do is hurt you. But it's still on the list.";
$AIRandTextChat[143] = "Men have two emotions: Hungry and Horny. If you see him without an erection, make him a sandwich.";
$AIRandTextChat[144] = "My mother never saw the irony in calling me a son-of-a-bitch.";
$AIRandTextChat[145] = "A bank is a place that will lend you money, if you can prove that you don't need it.";
$AIRandTextChat[146] = "A computer once beat me at chess, but it was no match for me at kick boxing.";
$AIRandTextChat[147] = "You do not need a parachute to skydive. You only need a parachute to skydive twice.";
$AIRandTextChat[148] = "The main reason Santa is so jolly is because he knows where all the bad girls live.";
$AIRandTextChat[149] = "Laugh at your problems, everybody else does!";
$AIRandTextChat[150] = "When people go underwater in scary movies, I like to hold my breath and see if I would have survived that situation.";
$AIRandTextChat[151] = "20 years ago we had Johnny Cash, Bob Hope and Steve Jobs. Now we have no Cash, no Hope and no Jobs!";
$AIRandTextChat[152] = "Chuck Norris once fought Superman. The loser had to wear his underwear over his pants.";
$AIRandTextChat[153] = "Chuck Norris threw a grenade and killed 50 people, then it exploded.";
$AIRandTextChat[154] = "Chuck Norris can kill two stones with one bird.";
$AIRandTextChat[155] = "Chuck Norris has a diary. It's called the Guinness Book of World Records.";
$AIRandTextChat[156] = "While other children were playing in sand, Chuck Norris was playing in concrete.";
$AIRandTextChat[157] = "Chuck Norris' calendar goes straight from March 31st to April 2nd. No one fools Chuck Norris.";
$AIRandTextChat[158] = "Chuck Norris' tears cure cancer. Too bad he has never cried.";
$AIRandTextChat[159] = "Chuck Norris doesn't have good aim. His bullets just know better than to miss.";
$AIRandTextChat[160] = "If it looks like chicken, tastes like chicken, and feels like chicken but Chuck Norris says its beef, then it's beef.";
$AIRandTextChat[161] = "I wondered why the spinfusor disc was getting bigger. Then it hit me.";
$AIRandTextChat[162] = "Why don't some couples go to the gym? Because some relationships don't work out.";
$AIRandTextChat[163] = "I wasn't originally going to get a brain transplant, but then I changed my mind.";
$AIRandTextChat[164] = "Have you ever tried to eat a clock? It's very time consuming.";
$AIRandTextChat[165] = "Why don't programmers like nature? It has too many bugs.";
$AIRandTextChat[166] = "So what if I don't know what apocalypse means!? It's not the end of the world!";
$AIRandTextChat[167] = "You're going for a smoke again? wtf man... have some self control.";
$AIRandTextChat[168] = "ghdkjbddfghfijfrfjfdmndfmndfdffngjk ...my cat just walked over the keyboard again, lol";
$AIRandTextChat[169] = "Anyone here tried eating dog treats? Uh... what do you guys mean about me being very weird today?";
$AIRandTextChat[170] = "Every time I midair someone I have to drink a bit of poison, which explains why I'm a terrible player";
$AIRandTextChat[171] = "how many legs does a spider have, three?";
$AIRandTextChat[172] = "I think I saw some yellow snow in Katabatic near the tower. What were the developers thinking, lol";
$AIRandTextChat[173] = "hmm... I need someone to stalk in this map. If you're reading this, it's you.";
$AIRandTextChat[174] = "I'm known as the #1 havoc driver in tribes 2, too bad nobody pays for that :(";
$AIRandTextChat[175] = "these LAK bots are kicking my fucking ass, I need to step it up lol";
$AIRandTextChat[176] = "man, I wish tribes 2 had more songs because they're all awesome";
$AIRandTextChat[177] = "why the hell are songs so high pitched or low pitched on some maps anyway? it's weird";
$AIRandTextChat[178] = "can you guys believe that even now this game may lag for some people? heh";
$AIRandTextChat[179] = "is it true that the Osiris voicepack has 5,000,000 gorrilion sounds?";
$AIRandTextChat[180] = "sooooo.... UT2k or Tribes 2? I prefer t2 but they're pretty close!";
$AIRandTextChat[181] = "I tried RPG Mode once and everything fucking killed me! It's pretty hard.";
$AIRandTextChat[182] = "RPG Mode? You can activate that??? Jesus, I didn't even knew it existed.";
$AIRandTextChat[183] = "dunno what's more fun between hunters and team hunters, but I know it's hard working as a team";
$AIRandTextChat[184] = "You got that right. Working as a team even in a 7vs7 match is just incredibly hard";
$AIRandTextChat[185] = "I remember playing Arena... wish I could play it again";
$AIRandTextChat[186] = "there are so many clientside maps for this game, too bad people don't wanna download them...";
$AIRandTextChat[187] = "My favorite map is Inside... your mother. What? No, I'm not 12. Fuck you!";
$AIRandTextChat[188] = "tone down the swearing people, 5 year old kids could be playing this game!";
$AIRandTextChat[189] = "I once shot a 680m mortar midair! I never saw that guy again since then...";
$AIRandTextChat[190] = "I once looked out the window and was amazed by the realistic graphics";
$AIRandTextChat[191] = "omg, why are there no female derm skins? that's soooo sexist and bigoted!";
$AIRandTextChat[192] = "I remember my MPB falling through the ground somehow, and then exploding. This game...";
$AIRandTextChat[193] = "Why is it called a deadstop? 'cause if you stop in tribes, you're dead! Haha! Come on, it's funny...";
$AIRandTextChat[194] = "The best defense is a good offense, that's what my grandma told me.";
$AIRandTextChat[195] = "God, I'm fucking pissed at cowardly snipers. Next time you see those guys, just ram them with the shrike.";
$AIRandTextChat[196] = "vehicle kills are just lame, takes no skill lol, I bet you're ramming people because you can't hit anyone";
$AIRandTextChat[197] = "How the hell do vehicle kills take no skills, idiots? YOU're the ones controlling the vehicle, fuck!";
$AIRandTextChat[198] = "Ah, the elf gun... so useless but then so useful when it comes to annoying the hell out of someone :)";
$AIRandTextChat[199] = "did you see that? I just shocklanced someone in the ankle";
$AIRandTextChat[200] = "is that a pigeon in the sky or is it a bomber?";
$AIRandTextChat[201] = "heavies in havocs should pay x2 more for being so fat and occupying the whole seat";
$AIRandTextChat[202] = "what the hell's wrong with heavies in lak? I enjoy good mortar shots";
$AIRandTextChat[203] = "Dude, like, my default aim is a midair, so all I have to do is miss so you don't think I have an aimbot";
$AIRandTextChat[204] = "I wonder how long I can survive camping the enemy gens, I gotta try it";
$AIRandTextChat[205] = "what if.... you had shrikes in LAK rabbit?";
$AIRandTextChat[206] = "the fuck's with all these people making Chuck Norris jokes? It's not 2005 anymore";



//--TEXT + VOICE--
$AIRandVoiceCount = 60;
$AIRandVoiceChat[0] = "*two thousand year old fart* ~wfx/vehicles/htransport_boost.wav";
$AIRandVoiceChat[1] = "NiggAaaaaAAaaaa! (OSiRiS Voice Pack) ~wvoice/custom/nigga.wav";
$AIRandVoiceChat[2] = "*horny dog* ~wfx/Bonuses/Nouns/zebra.wav";
$AIRandVoiceChat[3] = "Revenge of the Beeman, part 2 ~wfx/Bonuses/Nouns/hornet.wav";
$AIRandVoiceChat[4] = "Meow! ~wfx/Bonuses/Nouns/cat.wav";
$AIRandVoiceChat[5] = "You stink :) ~wfx/Bonuses/Nouns/fly.wav";
$AIRandVoiceChat[6] = "Donkey got AIDS ~wfx/Bonuses/Nouns/donkey.wav";
$AIRandVoiceChat[7] = "The Grape Wolf! ~wfx/Bonuses/Nouns/wolf.wav";
$AIRandVoiceChat[8] = "-Tribe 2 Training Room- ~wfx/Bonuses/Nouns/general.wav";
$AIRandVoiceChat[9] = "Woof! ~wfx/Bonuses/Nouns/dog.wav";
$AIRandVoiceChat[10] = "has initiated a vote to turn all humans into bots. ~wfx/misc/vote_initiated.wav";
$AIRandVoiceChat[11] = "60 seconds until I'll kick your asses. ~wfx/misc/hunters_60.wav";
$AIRandVoiceChat[12] = "Snootchie Bootchies (OSiRiS Voice Pack) ~wvoice/custom/snootchies.wav";
$AIRandVoiceChat[13] = "Faggot alert! ~wfx/misc/whistle.wav";
$AIRandVoiceChat[14] = "Mwahahahah! ~wfx/Bonuses/evillaugh.wav";
$AIRandVoiceChat[15] = "woooooooo! ~wfx/misc/Flair.wav";
$AIRandVoiceChat[16] = "*old school* ~wfx/misc/flagreturn.wav";
$AIRandVoiceChat[17] = "Retard team does it again... ~wfx/misc/crowd-clap.wav";
$AIRandVoiceChat[18] = "lol ~wfx/Bonuses/mario-6notes.wav";
$AIRandVoiceChat[19] = "Dance baby, dance! ~wfx/Bonuses/gadget3.wav";
$AIRandVoiceChat[20] = "o_0 ~wfx/Bonuses/qseq2.wav";
$AIRandVoiceChat[21] = "0_o ~wfx/Bonuses/qseq3.wav";
$AIRandVoiceChat[22] = "0_o ~wfx/Bonuses/qseq3.wav";
$AIRandVoiceChat[23] = ":D ~wfx/Bonuses/qseq1.wav";
$AIRandVoiceChat[24] = "All hail Zoidberg ~wvoice/custom/_z_allhail.wav";
$AIRandVoiceChat[25] = "Rock over london, rock on chicago. l33ties, breakfast of champions. (OSiRiS Voice Pack) ~wvoice/custom/rockon1.wav";
$AIRandVoiceChat[26] = "If no go to school, no get a job... (OSiRiS Voice Pack) ~wvoice/custom/nigganowork.wav";
$AIRandVoiceChat[27] = "Oh man, that is nasty. (OSiRiS Voice Pack) ~wvoice/custom/ned_thatsnasty.wav";
$AIRandVoiceChat[28] = "-This is how we do it!- (OSiRiS Voice Pack) ~wvoice/custom/music_thisishowwedoit.wav";
$AIRandVoiceChat[29] = "-w00t!- (OSiRiS Voice Pack) ~wvoice/custom/music_rocky.wav";
$AIRandVoiceChat[30] = ".-*flying theme*-. (OSiRiS Voice Pack) ~wvoice/custom/music_ride.wav";
$AIRandVoiceChat[31] = "-*Mortal Kombat Theme*- (OSiRiS Voice Pack) ~wvoice/custom/music_mk.wav";
$AIRandVoiceChat[32] = "Yeah baby, yeah! (OSiRiS Voice Pack) ~wvoice/custom/music_ap_catchy_groove.wav";
$AIRandVoiceChat[33] = "S'cuse me... your balls are showing. (OSiRiS Voice Pack) ~wvoice/custom/misc_ballsshowing.wav";
$AIRandVoiceChat[34] = "Who wants some, huh? Who's next? (OSiRiS Voice Pack) ~wvoice/custom/CGSP.wb203.wav";
$AIRandVoiceChat[35] = "You said it man... nobody fucks with the Jesus. (OSiRiS Voice Pack) ~wvoice/custom/jesus.wav";
$AIRandVoiceChat[36] = "[funky music] (OSiRiS Voice Pack) ~wvoice/custom/funk.wav";
$AIRandVoiceChat[37] = "I'm en route to the flag carrier. (OSiRiS Voice Pack) ~wvoice/custom/ESCORT-im-enroute-to-the-flag-carrier.wav";
$AIRandVoiceChat[38] = "Take this job and shove it. I'm not working for you anymore. (OSiRiS Voice Pack) ~wvoice/custom/fuckyouvs2.wav";
$AIRandVoiceChat[39] = "All your base are belong to us. (OSiRiS Voice Pack) ~wvoice/custom/allyourbase2.wav";
$AIRandVoiceChat[40] = "I'm starting my bombing run now. (OSiRiS Voice Pack) ~wvoice/custom/ATTACK-starting-bombing-run-now.wav";
$AIRandVoiceChat[41] = "Woooo! (OSiRiS Voice Pack) ~wvoice/custom/woo1.wav";
$AIRandVoiceChat[42] = "Kiss my ass! (OSiRiS Voice Pack) ~wvoice/custom/SSA.kissmyass.wav";
$AIRandVoiceChat[43] = "I'm not a computer, I'm a human. (OSiRiS Voice Pack) ~wvoice/custom/CGSP.mgs22.wav";
$AIRandVoiceChat[44] = "free! ~wfx/misc/hunters_3.wav";
$AIRandVoiceChat[45] = "You got mail. ~wfx/misc/warning_beep.wav";
$AIRandVoiceChat[46] = "*slap* ~wfx/misc/slapshot.wav";
$AIRandVoiceChat[47] = "RIP Tribes Ascend... ~wfx/misc/gamestart.wav";
$AIRandVoiceChat[48] = "PLEASE INSERT FLOPPY DISK TO CONTINUE ~wfx/misc/cannonstart.wav";
$AIRandVoiceChat[49] = "*wE aRe ViCtOrIoUs* *aNd YoU sUcK* ~wfx/misc/flagcapture.wav";
$AIRandVoiceChat[50] = "Houston, we have a problem. (OSiRiS Voice Pack) ~wvoice/custom/D6etak.houston.wav";
$AIRandVoiceChat[51] = "*Bling Bling* ~wfx/Bonuses/horz_straipass2_heist.wav";
$AIRandVoiceChat[52] = "Llama! ~wfx/Bonuses/Nouns/llama.wav";
$AIRandVoiceChat[53] = "-There's no escape from the hive- ~wfx/Bonuses/Nouns/wasp.wav";
$AIRandVoiceChat[54] = "Alpha 6, you can now drop the Chicken bomb. ~wfx/Bonuses/Nouns/astronaut.wav";
$AIRandVoiceChat[55] = "[Eagle of freedom] ~wfx/Bonuses/Nouns/birdofprey.wav";
$AIRandVoiceChat[56] = "Who the fuck was that? (OSiRiS Voice Pack) ~wvoice/custom/fuck10.wav";
$AIRandVoiceChat[57] = "I'm surprised that your Kung Fu is so expert. (OSiRiS Voice Pack) ~wvoice/custom/KungFu_06.wav";
$AIRandVoiceChat[58] = "My uncle says that smoking crack is kind of cool. (OSiRiS Voice Pack) ~wvoice/custom/sp106_cartman.wav";
$AIRandVoiceChat[59] = "Best... death... ever! (OSiRiS Voice Pack) ~wvoice/custom/TheSimpsons_best_death_ever.wav";
$AIRandVoiceChat[60] = "What the shit is this? (OSiRiS Voice Pack - Music) ~wvoice/custom/whattheshit.wav";
//-----------AI CHAT-----------

// Generate name
function AIGenerateRandomName()
{
     %prefix = getRandom(1);
     %suffix = getRandom(1);
     %name = "";
     %tries = 0;
     $nameIndex = getRandom($RandomBotGenNameCount);
          
     if(%prefix)
          %name = $RandomBotGenPrefix[getRandom($RandomBotGenPrefixCount)];

     %rnd = getRandom($RandomBotGenNameCount);
     
     // Make sure we don't have any duplicates
     if($RandomBotNameAllocated[%rnd])
     {
          // Choose another unused bot name until we've found a free one...
          // If this fails (runs out of tries) it will be inevitable and use the
          // last generated one
          while($RandomBotNameAllocated[%rnd] && (%tries < $RandomBotGenNameCount))
          {
               %rnd = getRandom($RandomBotGenNameCount);
               %tries++;
          }

          // If we do overflow, just start over          
          if(%tries == $RandomBotGenNameCount)
               AIClearUsedNamePool();
     }

     // Mark this name as taken
     $RandomBotNameAllocated[%rnd] = true;
     $nameIndex = %rnd;
          
     %mainName = $RandomBotGenName[%rnd];
     
     // Sanity check - somehow name is blank, this solves the problem although 
     // potentially counter-productive...
     if(%mainName $= "")
          %mainName = $RandomBotGenName[getRandom($RandomBotGenNameCount)];
     
     %name = %name $= "" ? %mainName : %name SPC %mainName;

     if(%suffix)
          %name = %name SPC $RandomBotGenSuffix[getRandom($RandomBotGenSuffixCount)];
     
     return %name;
}

function AIClearUsedNamePool()
{
     %count = 0;
     
     while(%count < $RandomBotGenNameCount)
     {
		//a bit taxing but we should check what names are actually used - roberto
		for (%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%cl = ClientGroup.getObject(%i);

			if (%cl.isAIControlled())
			{
				//if the bot's name is the same as the current name, it's taken
				if ($RandomBotGenName[%client.randomNameIndex] $= $RandomBotGenName[%count])
				{
					$RandomBotNameAllocated[%count] = true;
					break;
				}
				else
				{
					$RandomBotNameAllocated[%count] = false;
				}
			}
			else
			{
				$RandomBotNameAllocated[%count] = false;
			}
		}
          
        %count++;
     }
}

function RndAIAssignClientTeam(%game, %client, %respawn)
{
//error("DefaultGame::assignClientTeam");
   // this function is overwritten in non-team mission types (e.g. DM)
   // so these lines won't do anything
   //if(!%game.numTeams)
   //{
   //   setTargetSkin(%client.target, %client.skin);
   //   return;
   //}

   //  camera is responsible for creating a player
   //  - counts the number of players per team
   //  - puts this player on the least player count team
   //  - sets the client's skin to the servers default

   %numPlayers = ClientGroup.getCount();
   for(%i = 0; %i <= %game.numTeams; %i++)
      %numTeamPlayers[%i] = 0;

   for(%i = 0; %i < %numPlayers; %i = %i + 1)
   {
      %cl = ClientGroup.getObject(%i);
      if(%cl != %client)
         %numTeamPlayers[%cl.team]++;
   }
   %leastPlayers = %numTeamPlayers[1];
   %leastTeam = 1;
   for(%i = 2; %i <= %game.numTeams; %i++)
   {
      if( (%numTeamPlayers[%i] < %leastPlayers) ||
         ( (%numTeamPlayers[%i] == %leastPlayers) &&
         ($teamScore[%i] < $teamScore[%leastTeam] ) ))
      {
         %leastTeam = %i;
         %leastPlayers = %numTeamPlayers[%i];
      }
   }

   %client.team = %leastTeam;
   %client.lastTeam = %team;

   // Assign the team skin: - disabled here so bots don't get weird skins on mission change - keen
//   if ( %client.isAIControlled() )
//   {
//      if ( %leastTeam & 1 )
//      {
//         %client.skin = addTaggedString( "basebot" );
//         setTargetSkin( %client.target, 'basebot' );
//      }
//      else
//      {
//         %client.skin = addTaggedString( "basebbot" );
//         setTargetSkin( %client.target, 'basebbot' );
//      }
//   }
//   else
      setTargetSkin( %client.target, %game.getTeamSkin(%client.team) );
      //setTargetSkin( %client.target, %client.skin );

   // might as well standardize the messages
   //messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 joined %2.', %client.name, $teamName[%leastTeam], %client, %leastTeam );
   //messageClient( %client, 'MsgClientJoinTeam', '\c1You joined the %2 team.', $client.name, $teamName[%client.team], %client, %client.team );
   messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 joined %2.', %client.name, %game.getTeamName(%client.team), %client, %client.team );
   messageClient( %client, 'MsgClientJoinTeam', '\c1You joined the %2 team.', %client.name, %game.getTeamName(%client.team), %client, %client.team );

   updateCanListenState( %client );

   logEcho(%client.nameBase@" (cl "@%client@") joined team "@%client.team);
}

// package RndAINameGen {

// function DefaultGame::assignClientTeam(%game, %client, %respawn)
// {
//      if(%client.isAIControlled())
//      {
//           RndAIAssignClientTeam(%game, %client, %respawn);
//           return;
//      }
     
//      Parent::assignClientTeam(%game, %client, %respawn);
// }

// };
//---------------------------------------------------------------------------------------------------------------


function AIInit()
{
   AISlicerInit();
   installNavThreats();
   NavDetectForceFields();
//   ShowFPS();

	//enable the use of grenades
	$AIDisableGrenades = false;
	$AIDisableChat = false;
										
	//create the "objective delete set"
	if(nameToId("AIBombLocationSet") <= 0)
	{
		$AIBombLocationSet = new SimSet("AIBombLocationSet");
      MissionCleanup.add($AIBombLocationSet);
	}

	//create the Inventory group
	if(nameToId("AIStationInventorySet") <= 0)
	{
		$AIInvStationSet = new SimSet("AIStationInventorySet");
      MissionCleanup.add($AIInvStationSet);
	}

	//create the Item group
	if (nameToId("AIItemSet") <= 0)
	{
		$AIItemSet = new SimSet("AIItemSet");
      MissionCleanup.add($AIItemSet);
	}

	//create the Item group
	if (nameToId("AIGrenadeSet") <= 0)
	{
		$AIGrenadeSet = new SimSet("AIGrenadeSet");
      MissionCleanup.add($AIGrenadeSet);
	}

	//create the weapon group
	if (nameToId("AIWeaponSet") <= 0)
	{
		$AIWeaponSet = new SimSet("AIWeaponSet");
      MissionCleanup.add($AIWeaponSet);
	}

	//create the deployed turret group
	if (nameToID("AIRemoteTurretSet") <= 0)
	{
		$AIRemoteTurretSet = new SimSet("AIRemoteTurretSet");
      MissionCleanup.add($AIRemoteTurretSet);
	}

	//create the deployed turret group
	if (nameToID("AIDeployedMineSet") <= 0)
	{
		$AIDeployedMineSet = new SimSet("AIDeployedMineSet");
      MissionCleanup.add($AIDeployedMineSet);
	}

	//create the deployed turret group
	if (nameToID("AIVehicleSet") <= 0)
	{
		$AIVehicleSet = new SimSet("AIVehicleSet");
      MissionCleanup.add($AIVehicleSet);
	}

   %missionGroupFolder = nameToID("MissionGroup");
   %missionGroupFolder.AIMissionInit();
}

// this is called at mission load by the specific game type
function AIInitObjectives(%team, %game)
{
   %group = nameToID("MissionGroup/Teams/team" @ %team @ "/AIObjectives");
   if(%group < 0)
      return; // opps, there is no Objectives set for this team.
   
   // add the grouped objectives to the teams Q
   %count = %group.getCount();
	for (%i = 0; %i < %count; %i++)
	{
      %objective = %group.getObject(%i);
		if (%objective.getClassName() !$= "AIObjective")
		{
			%grpCount = %objective.getCount();
			for (%j = 0; %j < %grpCount; %j++)
			{
				%grpObj = %objective.getObject(%j);
		      if (%objective.gameType $= "" || %objective.gameType $= "all")
		         %objType = "";
		      else
		         %objType = %objective.gameType @ "Game";
		      
		      if (%objType $= "" || %objType $= %game.class)
				{
					%grpObj.group = %objective;
			      $ObjectiveQ[%team].add(%grpObj);
				}
			}
		}
	}

   
   // add the non-grouped objectives to the teams Q
   %count = %group.getCount();
   for(%i = 0; %i < %count; %i++)
   {
      %objective = %group.getObject(%i);

		//if the objective is not an "AIObjective", assume it's a group and continue
		if (%objective.getClassName() !$= "AIObjective")
			continue;

      if (%objective.gameType $= "" || %objective.gameType $= "all")
         %objType = "";
      else
         %objType = %objective.gameType @ "Game";
      
      if (%objType $= "" || %objType $= %game.class)
		{
			%objective.group = "";
	      $ObjectiveQ[%team].add(%objective);
		}
	}

	// initialize the objectives
   %count = $ObjectiveQ[%team].getCount();
   for(%i = 0; %i < %count; %i++)
   {
      %objective = $ObjectiveQ[%team].getObject(%i);

		//clear out any dynamic fields
		%objective.clientLevel1 = "";
		%objective.clientLevel2 = "";
		%objective.clientLevel3 = "";
		%objective.isInvalid = false;
		%objective.repairObjective = "";

      //set the location, if required
	   if (%objective.position !$= "0 0 0")
		   %objective.location = %objective.position;

      // find targeted object ID's
      if(%objective.targetObject !$= "")
         %objective.targetObjectId = NameToId(%objective.targetObject);
      else
	      %objective.targetObjectId = -1;
   
      if(%objective.targetClientObject !$= "")
         %objective.targetClientId = NameToId(%objective.targetClient);
      else
	      %objective.targetClientId = -1;

	   if (%objective.position $= "0 0 0")
	   {
		   if (%objective.location $= "0 0 0")
		   {
			   if (%objective.targetObjectId > 0)
				   %objective.position = %objective.targetObjectId.position;
		   }
		   else
			   %objective.position = %objective.location;
	   }
   }

	//finally, sort the objectiveQ
	$ObjectiveQ[%team].sortByWeight();
}

//This function is designed to clear out the objective Q's, and clear the task lists from all the AIs
function AIMissionEnd()
{
	//disable the AI system
	AISystemEnabled(false);

   $AIGenDisabledCount[0] = 0; //team 1
   $AIGenDisabledCount[1] = 0; //team 2
   $AIGenTotalDestroyed[1] = 0;
   $AIGenTotalDestroyed[2] = 0;
   $AIHumansInTeam[1] = 0; 
   $AIHumansInTeam[2] = 0; 
   $AIDefenderWeightModifier[1] = -200; //team 1
   $AIDefenderWeightModifier[2] = -200; //team 2
   $AITeamLosing[1] = true; //AITeamLosing must be true to deploy cameras. A losing team will start deploying Cameras if they're not a GenDefend objective.
   $AITeamLosing[2] = true; 

	//loop through the client list, and clear the tasks of each bot
	%count = ClientGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%client = ClientGroup.getObject(%i);
		if (%client.isAIControlled())
		{
			//cancel the respawn thread and the objective thread...
			cancel(%client.respawnThread);
			cancel(%client.objectiveThread);

         //reset the clients tasks, variables, etc...
	      AIUnassignClient(%client);
         %client.stop();
			%client.clearTasks();
         %client.clearStep();
         %client.lastDamageClient = -1;
         %client.lastDamageTurret = -1;
         %client.shouldEngage = -1;
         %client.setEngageTarget(-1);
         %client.setTargetObject(-1);
	      %client.pilotVehicle = false;
         %client.defaultTasksAdded = false;
         
         %client.waitSpot = "";
		%client.chaseSpeedFar = 4.9;
		%client.chaseSpeedVeryFar = 6.7;
		%client.chaseSpeedMegaUltraFar = 7.2;
		%client.chaseSpeedMarker = 7.35;
		%client.runToBaseSpeed = 3.4;
		//when bots switch objectives and they were following a path, make them remember what path and spot they were at when they get back, -1 is no path/spot 
		%client.lastIndexPathToFlag = -1;
		%client.lastPathToFlag = -1;
		%client.lastIndexAttackPath = -1;
		%client.lastAttackPath = -1;
		%client.capperGrabbingFlag = false; //when this is true we ignore detecting turrets, mines, invs, or enemies and we just grab the flag 
		%client.waitTimeWasReset = false; //this will make the bot correctly wait at the marker with the waitTime datafield, shouldWaitTime will be reset when this is false 
		%client.lastRecordedPos = "";
		%client.stuckCount = 0;
		%client.stuckCheckSchedule1 = -1;
		%client.stuckCheckSchedule2 = -1;
		%client.stuckCheckSchedule3 = -1;

      //reset map record vars
      %client.diskMidairs = 0;
      %client.plasmaMidairs = 0;
      %client.blasterMidairs = 0;
      %client.sniperHeadshots = 0;
      %client.killingSpree = 0;
      %client.rabbitKills = 0;

	      //do the nav graph cleanup
	      %client.missionCycleCleanup();
		}
	}

	//clear the objective Q's
	for (%i = 0; %i <= Game.numTeams; %i++)
	{
		if (isObject($ObjectiveQ[%i]))
		{
			$ObjectiveQ[%i].clear();
			$ObjectiveQ[%i].delete();
		}
		$ObjectiveQ[%i] = "";
	}

	//now delete all the sets used by the AI system...
	if (isObject($AIBombLocationSet))
   	$AIBombLocationSet.delete();
	$AIBombLocationSet = "";

	if (isObject($AIInvStationSet))
   	$AIInvStationSet.delete();
	$AIInvStationSet = "";

	if (isObject($AIItemSet))
   	$AIItemSet.delete();
	$AIItemSet = "";

	if (isObject($AIGrenadeSet))
   	$AIGrenadeSet.delete();
	$AIGrenadeSet = "";

	if (isObject($AIWeaponSet))
   	$AIWeaponSet.delete();
	$AIWeaponSet = "";

	if (isObject($AIRemoteTurretSet))
   	$AIRemoteTurretSet.delete();
	$AIRemoteTurretSet = "";

	if (isObject($AIDeployedMineSet))
   	$AIDeployedMineSet.delete();
	$AIDeployedMineSet = "";

	if (isObject($AIVehicleSet))
   	$AIVehicleSet.delete();
	$AIVehicleSet = "";
}

//FUNCTIONS ON EACH OBJECT EXECUTED AT MISSION LOAD TIME
function SimGroup::AIMissionInit(%this)
{
   for(%i = 0; %i < %this.getCount(); %i++)
      %this.getObject(%i).AIMissionInit(%this);   
}

function GameBase::AIMissionInit(%this)
{
   %this.getDataBlock().AIMissionInit(%this);
}

function StationInventory::AIMissionInit(%data, %object)
{
   $AIInvStationSet.add(%object);
}

function Flag::AIMissionInit(%data, %object)
{
	if (%object.team >= 0)
		$AITeamFlag[%object.team] = %object;
}

function SimObject::AIMissionInit(%this)
{
	//this function is declared to prevent console error msg spam...
}

function ItemData::AIMissionInit(%data, %object)
{
	$AIItemSet.add(%object);
}

function AIThrowObject(%object)
{
	$AIItemSet.add(%object);
}

function AIGrenadeThrown(%object)
{
	$AIGrenadeSet.add(%object);
}

function AIDeployObject(%client, %object)
{
	//first, set the object id on the client
	%client.lastDeployedObject = %object;

	//now see if it was a turret...
	%type = %object.getDataBlock().getName();
	if (%type $= "TurretDeployedFloorIndoor" || %type $= "TurretDeployedWallIndoor" ||
				%type $= "TurretDeployedCeilingIndoor" || %type $= "TurretDeployedOutdoor")
	{
		$AIRemoteTurretSet.add(%object);
	}
}

function AIDeployMine(%object)
{
	$AIDeployedMineSet.add(%object);
}

function AIVehicleMounted(%vehicle)
{
	$AIVehicleSet.add(%vehicle);
}

function AICorpseAdded(%corpse)
{
   if (isObject(%corpse))
   {
      %corpse.isCorpse = true;
	   $AIItemSet.add(%corpse);
   }
}

//OTHER UTILITY FUNCTIONS

function AIConnection::onAIDrop(%client)
{
	//make sure we're trying to drop an AI
	if (!isObject(%client) || !%client.isAIControlled())
   {
		return;
   }

   if ($Host::MapRecords) { SaveMapRecords(); }

   if(isObject(Game))
   {
      Game.onClientLeaveGame(%client);
   }

   // make sure that tagged string of player name is not used
   if ( $CurrentMissionType $= "SinglePlayer" ) 
   {
      messageAllExcept(%client, -1, 'MsgClientDrop', "", getTaggedString(%client.name), %client);
   }
   else
   {
      messageAllExcept(%client, -1, 'MsgClientDrop', '\c1%1 has left the game.', getTaggedString(%client.name), %client);
   }

   if ( isObject( %client.camera ) )
   {
      %client.camera.delete();
   }

   // z0dd - ZOD, 6/19/02. Strip the hit sound tags
   removeTaggedString(%client.playerHitWav);
   removeTaggedString(%client.vehicleHitWav);

   removeTaggedString(%client.name);
   removeTaggedString(%client.voiceTag);
   removeTaggedString(%client.skin);
   freeClientTarget(%client);

	//clear the ai from any objectives, etc...
	AIUnassignClient(%client);
	%client.clearTasks();
	%client.clearStep();
	%client.defaultTasksAdded = false;

	//kill the player, which should cause the Game object to perform whatever cleanup is required.
   if (isObject(%client.player))
   {
      %client.player.scriptKill(0);
   }

   $HostGamePlayerCount = ClientGroup.getCount() - 1;


    //determine bot count:
   $GameBotCount = 0;
   %humanCount = 0;

   for (%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %cl = ClientGroup.getObject(%i);

      if (%cl.isAiControlled())
      {
         $GameBotCount++;
      }
      else
      {
         %humanCount++;
      }
   }

   //the  bot didn't actually decrease the size of the clientgroup yet, so we need to remove a looped client - roberto
   if ($GameBotCount > 0)
   {
      $GameBotCount--;
      $HostGameBotCount--;
   }

   if ($Host::RebalanceTeamBots)
   {
         AIRebalanceTeamBots(Game, %client);
   }

	//do the nav graph cleanup
	%client.missionCycleCleanup();
}

function AIConnection::endMission(%client)
{
	//cancel the respawn thread, and spawn them manually
	cancel(%client.respawnThread);
   cancel(%client.objectiveThread);
}

function AIConnection::startMission(%client)
{
	//assign the team
	if (%client.team <= 0)
	   Game.assignClientTeam(%client);

	//set the client's sensor group...
   setTargetSensorGroup( %client.target, %client.team );
   %client.setSensorGroup( %client.team );

	//sends a message so everyone know the bot is in the game...
	Game.AIHasJoined(%client);
   %client.matchStartReady = true;

	//spawn the bot...
	onAIRespawn(%client);
}

function AIConnection::onAIConnect(%client, %name, %team, %skill, %offense, %voice, %voicePitch)
{
	%skill = %client.getSkillLevel();
	%name = AIGenerateRandomName();
  %client.randomNameIndex = $nameIndex; //we use this so we easily know this AI's name outside this script

  %client.lastRecordedPos = "";
  %client.stuckCount = 0;
  %client.stuckCheckSchedule1 = -1;
  %client.stuckCheckSchedule2 = -1;
  %client.stuckCheckSchedule3 = -1;
  //reset map record vars
  %client.diskMidairs = 0;
  %client.plasmaMidairs = 0;
  %client.blasterMidairs = 0;
  %client.sniperHeadshots = 0;
  %client.killingSpree = 0;
  %client.rabbitKills = 0;

   // Sex/Race defaults
   %client.race = getRandom(1) ? "Human" : "Bioderm";

   if(%client.race $= "Human")
        %client.sex = getRandom(1) ? "Male" : "Female";
   else
        %client.sex = "Male";
        
   %client.armor = getRandom(1) ? "Light" : "Medium";

   //setup the voice and voicePitch
   if(%client.race $= "Human" && %client.sex $= "Male")
        %voice = getRandom(1) ? "Bot1" : "Male"@getRandom(1,5);
   else if(%client.race $= "Human" && %client.sex $= "Female")
        %voice = "Fem"@getRandom(1,5);
   else
        %voice = "Derm"@getRandom(1,3);

   %voicePitch = 1 - ((getRandom(20) - 10)/100);

  %client.name = addTaggedString("\cp\c9" @ %name @ "\co");
  %client.nameBase = %name;

  //Make players use their real voice, race, gender
  switch$ ($RandomBotGenName[$nameIndex])
  {
    case "Sami-FIN":
    %voice = "Male2";
    %voicePitch = 1.0;
    %client.sex = "Male";
    %client.race = "Human";
    case "high5slayer":
    %voice = "Male1";
    %voicePitch = 1.0;
    %client.sex = "Male";
    %client.race = "Human";
    case "Halo 2":
    %voice = "Fem1";
    %voicePitch = 1.15;
    %client.sex = "Female";
    %client.race = "Human";
    case "Silent Eagle":
    %voice = "Bot1";
    %voicePitch = 1.0;
    %client.sex = "Male";
    %client.race = "Human";
    case "Donald Trump":
    %voice = "Male2";
    %voicePitch = 0.85;
    %client.sex = "Male";
    %client.race = "Human";
    case "JesusChrist":
    %voice = "Bot1";
    %voicePitch = 0.85;
    %client.sex = "Male";
    %client.race = "Human";
    case "CoorsLightMan":
    %voice = "Male1";
    %voicePitch = 1.0;
    %client.sex = "Male";
    %client.race = "Human";
    case "2SmOkeD":
    %voice = "Male5";
    %voicePitch = 0.85;
    %client.sex = "Male";
    %client.race = "Bioderm"; 
    case "rJay_R116":
    %voice = "Bot1";
    %voicePitch = 0.85;
    %client.sex = "Male";
    %client.race = "Human";
    case "Faeywin":
    %voice = "Fem1";
    %voicePitch = 1.0;
    %client.sex = "Female";
    %client.race = "Human";
    case "Infernus":
    %voice = "Derm3";
    %voicePitch = 1.15;
    %client.sex = "Male";
    %client.race = "Bioderm";
    case "-=Hot|Ice=-": 
    %voice = "Fem1";
    %voicePitch = 1.15;
    %client.sex = "Female";
    %client.race = "Human";
    case "huntergirl10":  
    %voice = "Fem1";
    %voicePitch = 1.15;
    %client.sex = "Female";
    %client.race = "Human";
    case "au66yrOldFart":
    %voice = "Derm1";
    %voicePitch = 1.0;
    %client.sex = "Male";
    %client.race = "Bioderm";
    case "ElKapitan":
    %voice = "Fem1";
    %voicePitch = 1.15;
    %client.sex = "Female";
    %client.race = "Human";
    case "DRDigitalSr":
    %voice = "Male5";
    %voicePitch = 0.85;
    %client.sex = "Male";
    %client.race = "Human";
    case "Zergon MA":
    %voice = "Male5";
    %voicePitch = 1.0;
    %client.sex = "Male";
    %client.race = "Human";
    case "ChocoTaco":
    %voice = "Male1";
    %voicePitch = 1.0;
    %client.sex = "Male";
    %client.race = "Human";
    case "Sylock":
    %voice = "Fem1";
    %voicePitch = 1.0;
    %client.sex = "Female";
    %client.race = "Human";
    case "ADiDaSWaRRiOR":
    %voice = "Derm2";
    %voicePitch = 1.15;
    %client.sex = "Male";
    %client.race = "Bioderm";
    case "Blakhart":
    %voice = "Male1";
    %voicePitch = 1.0;
    %client.sex = "Male";
    %client.race = "Human";
  }

  	//.... don't know everyone's voices, add them if you do

	%client.voicePitch = %voicePitch;
	%client.voice = %voice;
	%client.voiceTag = addTaggedString(%voice);

	if(%voice $= "Bot1")
	{
		%skin = %client.team == 1 ? "basebot" : "basebbot";
	}
	else if(%client.race $= "Human")
	{
		%skin = %client.team == 1 ? "beagle" : "swolf";
	}
	else
	{
		%skin = %client.team == 1 ? "base" : "baseb";
	}

  //assign the skill
  %client.setSkillLevel(%skill);

   echo(%client.name);
   echo("CADD: " @ %client @ " " @ %client.getAddress());
   $HostGamePlayerCount++;
   
   //set the initial team - Game.assignClientTeam() should be called later on...
   %client.team = %team;

	//setup the target for use with the sensor net, etc...
   %client.target = allocClientTarget(%client, %client.name, %client.skin, %client.voiceTag, '_ClientConnection', 0, 0, %client.voicePitch);
   
   //i need to send a "silent" version of this for single player but still use the callback  -jr`
   if($currentMissionType $= "SinglePlayer")
   {
		messageAllExcept(%client, -1, 'MsgClientJoin', "", %name, %client, %client.target, true);
   }
   else
   {
	   messageAllExcept(%client, -1, 'MsgClientJoin', '\c1%1 joined the game.', %name, %client, %client.target, true);
   }
	
	//assign the affinity
   %client.offense = getRandom(1) == 1 ? true : false;
    
   //clear any flags
   %client.stop(); // this will clear the players move state
   %client.clearStep();
   %client.lastDamageClient = -1;
   %client.lastDamageTurret = -1;
   %client.setEngageTarget(-1);
   %client.setTargetObject(-1);
   %client.engageRemeq = -1;//added - Lagg...
   %client.pickUpItem = -1;//added - Lagg...
   %client.engageVehicle = -1;//added - Lagg...
   %client.justBought = false;//added vehicleStation tag - Lagg...
   %client.inWater = false;//--------- added the inWater tag - Lagg... 5-14-2005
   %client.mountVehicle = -1;//added mount vehicle tag - Lagg... 5-19-2005
   %client.pilotVehicle = false;
   %client.objective = "";
   %client.waitSpot = "";
   %client.isCloakerOrHeavy = false;
   %client.grabFlagDamagePercent = 0.35;
   %client.clearedFlag = false;

   //reset the client zone taggs 
   %client.inBase = false;
   %client.inRoom = false;
   %client.inDanger = false;
   %client.inTower = false;

   %client.divertposition = ""; //if equal to something we are doing a Missile/Mortar/MortarSpam objective and we move to a DivertLocations marker - roberto
    %client.discJumpTimer = 100; //the reseted value, it will decrease when activated
    %client.discJumpTimerStarted = false; //we don't decrease the value now, reset
  	//when bots switch objectives and they were following a path, make them remember what path and spot they were at when they get back, -1 is no path/spot - roberto
	%client.lastIndexPathToFlag = -1;
	%client.lastPathToFlag = -1;
	%client.lastIndexAttackPath = -1;
	%client.lastAttackPath = -1;
	%client.capperGrabbingFlag = false; //when this is true we ignore detecting turrets, mines, invs, or enemies and we just grab the flag - roberto

	//clear the defaulttasks flag
	%client.defaultTasksAdded = false;

   //RPG mode stuff
   if ($Host::RPG_Active)
   {
		//RPG stats 
   		%minBotLvl = $Host::RPG_Min_Bot_Lvl;
   		%maxBotLvl = $Host::RPG_Max_Bot_Lvl;
   		%noEquipChance = 50; //the higher this is, the lower the chance the bot has a certain equip on him

   		if ($RPG_Event_Active_Perm_Drop_rate)
   		{
			%maxBotLvl = $Host::RPG_Max_Bot_Lvl + $Host::RPG_Event_More_Bot_lvls;
   		}


   		//---randomize the levels---
   		if ( getRandom(1, 100) <= 75 ) 	//75% the bots will have high levels
   		{
	   		%newBotMinLvl = mFloor(0.85 * %maxBotLvl);
	   		if (%newBotMinLvl >= %minBotLvl)
	   		{
	   			%minBotLvl = %newBotMinLvl;
	   		}
   		}
   		else //25% will have low levels
   		{
   			%maxLvlMultiplier = 0.84;

   			//about 75% of these bots will be even weaker 
   			if ( getRandom(1, 100) <= 75 )
   			{
   				%maxLvlMultiplier = 0.20;
   			}

   			%newBotMaxLvl = mFloor(%maxBotLvl * %maxLvlMultiplier);
   			if (%newBotMaxLvl >= %minBotLvl)
   			{
   				%maxBotLvl = %newBotMaxLvl;
   			}
   		}

   		// just in case...
   		if (%minBotLvl < 1 || %minBotLvl >= 40)
   		{
   			%minBotLvl = 1;
   		}
   		if (%maxBotLvl < 1 || %maxBotLvl >= 40)
   		{
   			%maxBotLvl = 1;
   		}

		%client.RPG_AI_lvl = getRandom(%minBotLvl, %maxBotLvl);

		//the bots with higher levels have a higher chance to have more equips
		if (%client.RPG_AI_lvl >= 15)
		{
			%noEquipChance = 15;
		}
		else if (%client.RPG_AI_lvl >= 10)
		{
			%noEquipChance = 40;
		}
		else if (%client.RPG_AI_lvl >= 4)
		{
			%noEquipChance = 70;
		}
		else 
		{
			%noEquipChance = 80;
		}
   		//------


		//---other stats---
		%client.RPG_AI_equip = 0; //number of equipped items
		%client.RPG_AI_hp_multiplier_from_lvl =  %client.RPG_AI_lvl * 0.02;
		%client.RPG_AI_hp_multiplier_from_equip = 0;
		%client.RPG_AI_dmg_multiplier_from_lvl = %client.RPG_AI_lvl * 0.02;
		%client.RPG_AI_dmg_multiplier_from_equip = 0;
		//misc
		%client.RPG_AI_weapon_ammo_from_equip = 0;
		//vehicles
		%client.RPG_AI_veh_hp_from_equip = 0;
		%client.RPG_AI_veh_dmg_from_equip = 0;
		%client.RPG_AI_veh_engr_recovery_from_equip = 0;
		//deployables
		%client.RPG_AI_depl_hp_from_equip = 0;
		%client.RPG_AI_depl_dmg_from_equip = 0;
		//resistances
		%client.RPG_AI_dmg_vs_light = 0;
		%client.RPG_AI_dmg_vs_medium = 0;
		%client.RPG_AI_dmg_vs_heavy = 0;
      
      	//80% the bot has equipment parts, this is their advantage because bots can't use consumables

		//Test if the bot has items equipped
		if (getRandom(1, 100) >= %noEquipChance) //Health test
		{
			%client.RPG_AI_hp_multiplier_from_equip += 0.05; 
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Damage test
		{
			%client.RPG_AI_dmg_multiplier_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}

		if (getRandom(1, 100) >= %noEquipChance) //Damage vs Light test
		{
			%client.RPG_AI_dmg_vs_light += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Damage vs Medium test
		{
			%client.RPG_AI_dmg_vs_medium += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Damage vs Heavy test
		{
			%client.RPG_AI_dmg_vs_heavy += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Damage vs all armors test
		{
			%client.RPG_AI_dmg_vs_light += 0.05;
			%client.RPG_AI_dmg_vs_medium += 0.05;
			%client.RPG_AI_dmg_vs_heavy += 0.05;
			%client.RPG_AI_equip += 1;
		}

		if (getRandom(1, 100) >= %noEquipChance) //5% Damage for weapon/vehicle/turret test
		{
			%client.RPG_AI_dmg_multiplier_from_equip += 0.05;
			%client.RPG_AI_depl_dmg_from_equip += 0.05;
			%client.RPG_AI_veh_dmg_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //5% Health for player/vehicle/turret test
		{
			%client.RPG_AI_hp_multiplier_from_equip += 0.05;
			%client.RPG_AI_depl_hp_from_equip += 0.05;
			%client.RPG_AI_veh_hp_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Deployable health upgrade test
		{
			%client.RPG_AI_depl_hp_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Deployable damage upgrade test
		{
			%client.RPG_AI_depl_dmg_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Deployable damage + health upgrade test
		{
			%client.RPG_AI_depl_hp_from_equip += 0.05;
			%client.RPG_AI_depl_dmg_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //vehicle damage + health upgrade test
		{
			%client.RPG_AI_veh_hp_from_equip += 0.05;
			%client.RPG_AI_veh_dmg_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //weapon damage + health upgrade test
		{
			%client.RPG_AI_hp_multiplier_from_equip += 0.05;
			%client.RPG_AI_dmg_multiplier_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Vehicle health upgrade test
		{
			%client.RPG_AI_veh_hp_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Vehicle damage upgrade test
		{
			%client.RPG_AI_veh_dmg_from_equip += 0.05;
			%client.RPG_AI_equip += 1;
		}
		if (getRandom(1, 100) >= %noEquipChance) //Vehicle energy recovery test
		{
			%client.RPG_AI_veh_engr_recovery_from_equip = 0.1;
			%client.RPG_AI_equip += 1;
		}

		//Final stats
		%client.RPG_AI_total_hp_multiplier = %client.RPG_AI_hp_multiplier_from_lvl + %client.RPG_AI_hp_multiplier_from_equip;
		%client.RPG_AI_total_dmg_multiplier = %client.RPG_AI_dmg_multiplier_from_lvl + %client.RPG_AI_dmg_multiplier_from_equip;

		//modify name to show rpg level
		rpgUpdateName(%client);
	}


	//if the mission is already running, spawn the bot
   if ($missionRunning)
   {
      %client.startMission();
   }
}

// This routes through C++ code so profiler can register it.  Also, the console function
// ProfilePatch1() tracks time spent (at MS resolution), # calls, average time per call.
// See console variables $patch1Total (MS so far in routine), $patch1Avg (average MS
// per call), and $patch1Calls (# of calls).  
function patchForTimeTest(%client)
{
	if( isObject( Game ) )
      Game.AIChooseGameObjective(%client);
}

function AIReassessObjective(%client)
{
   ProfilePatch1(patchForTimeTest, %client);
   // Game.AIChooseGameObjective(%client);
   %client.objectiveThread = schedule(5000, %client, "AIReassessObjective", %client);
}

function onAIRespawn(%client)
{
   %markerObj = Game.pickPlayerSpawn(%client, true);
   Game.createPlayer(%client, %markerObj);	

	//make sure the player object is the AI's control object - even during the mission warmup time
	//the function AISystemEnabled(true/false) will control whether they actually move...
	%client.setControlObject(%client.player);
   
   if (%client.objective)
      error("ERROR!!! " @ %client @ " is still assigned to objective: " @ %client.objective);
      
   //clear the objective and choose a new one
	AIUnassignClient(%client);
   %client.stop();
   %client.clearStep();
   %client.lastDamageClient = -1;
   %client.lastDamageTurret = -1;
   %client.shouldEngage = -1;
   %client.setEngageTarget(-1);
   %client.setTargetObject(-1);
	%client.pilotVehicle = false;
      %client.chaseSpeedFar = 4.9;
      %client.chaseSpeedVeryFar = 6.7;
      %client.chaseSpeedMegaUltraFar = 7.2;
      %client.chaseSpeedMarker = 7.35;

      %client.runToBaseSpeed = 3.4;

	//set the spawn time
	%client.spawnTime = getSimTime();
	%client.respawnThread = "";

	//timeslice the objective reassessment for the bots
	if (!isEventPending(%client.objectiveThread))
	{
		%curTime = getSimTime();
		%remainder = %curTime % 5000;
		%schedTime = $AITimeSliceReassess - %remainder;
		if (%schedTime <= 0)
			%schedTime += 5000;
		%client.objectiveThread = schedule(%schedTime, %client, "AIReassessObjective", %client);

		//set the next time slice "slot"
		$AITimeSliceReassess += 300;
		if ($AITimeSliceReassess > 5000)
			$AITimeSliceReassess -= 5000;
	}

  %client.lastRecordedPos = "";
  %client.stuckCount = 0;
  %client.stuckCheckSchedule1 = -1;
  %client.stuckCheckSchedule2 = -1;
  %client.stuckCheckSchedule3 = -1;

	//call the game specific spawn function
	Game.onAIRespawn(%client);
}

function AIClientIsAlive(%client, %duration)
{
   if(%client < 0 || %client.player <= 0)
      return false;
   if (isObject(%client.player))
	{
		%state = %client.player.getState();
		if (%state !$= "Dead" && %state !$= "" && (%duration $= "" || getSimTime() - %client.spawnTime >= %duration))
			return true;
		else
			return false;
	}
	else
		return false;
}

//------------------------------
function AIFindClosestEnemy(%srcClient, %radius, %losTimeout)
{
   //see if there's an enemy near our defense location...
	if (isObject(%srcClient.player))
		%srcLocation = %srcClient.player.getWorldBoxCenter();
	else
		%srcLocation = "0 0 0";
   return AIFindClosestEnemyToLoc(%srcClient, %srcLocation, %radius, %losTimeout, false, true);
}

function AIFindClosestEnemyToLoc(%srcClient, %srcLocation, %radius, %losTimeout, %ignoreLOS, %distFromClient)
{
	if (%ignoreLOS $= "")
		%ignoreLOS = false;
	if (%distFromClient $= "")
		%distFromClient = false;

   %count = ClientGroup.getCount();
   %closestClient = -1;
   %closestDistance = 32767;
   for(%i = 0; %i < %count; %i++)
   {
		%cl = ClientGroup.getObject(%i);

		//make sure we find someone who's alive
		if (AIClientIsAlive(%cl) && %cl.team != %srcClient.team)
		{
			%clIsCloaked = !isTargetVisible(%cl.target, %srcClient.getSensorGroup());

			//make sure the client can see the enemy
			%hasLOS = %srcClient.hasLOSToClient(%cl);
			%losTime = %srcClient.getClientLOSTime(%cl);
			if (%ignoreLOS || %hasLOS || (%losTime < %losTimeout && AIClientIsAlive(%cl, %losTime + 1000)))
			{
	         %testPos = %cl.player.getWorldBoxCenter();
				if (%distFromClient)
					%distance = %srcClient.getPathDistance(%testPos);
				else
		         %distance = AIGetPathDistance(%srcLocation, %testPos);
	         if (%distance > 0 && (%radius < 0 || %distance < %radius) && %distance < %closestDistance && (!%clIsCloaked || %distance < 8))
	         {
	            %closestClient = %cl;
	            %closestDistance = %distance;
	         }
			}
      }
   }
   
   return %closestClient SPC %closestDistance;
}

function AIFindClosestEnemyPilot(%client, %radius, %losTimeout)
{
	//loop through the vehicle set, looking for pilotted vehicles...
	%closestPilot = -1;
	%closestDist = %radius;
	%count = $AIVehicleSet.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		//first, make sure the vehicle is mounted by pilotted
		%vehicle = $AIVehicleSet.getObject(%i);
      %pilot = %vehicle.getMountNodeObject(0);
      if (%pilot <= 0 || !AIClientIsAlive(%pilot.client))
			continue;

		//make sure the pilot is an enemy
		if (%pilot.client.team == %client.team)
			continue;

		//see if the pilot has been seen by the client
		%hasLOS = %client.hasLOSToClient(%pilot.client);
		%losTime = %client.getClientLOSTime(%pilot.client);
		if (%hasLOS || (%losTime < %losTimeout && AIClientIsAlive(%pilot.client, %losTime + 1000)))
		{
			//see if it's the closest
			%clientPos = %client.player.getWorldBoxCenter();
			%pilotPos = %pilot.getWorldBoxCenter();
			%dist = VectorDist(%clientPos, %pilotPos);
			if (%dist < %closestDist)
			{
				%closestPilot = %pilot.client;
				%closestDist = %dist;
			}
		}
	}

	return %closestPilot SPC %closestDist;
}

function AIFindAIClientInView(%srcClient, %team, %radius)
{
	//make sure the player is alive
	if (! AIClientIsAlive(%srcClient))
		return -1;

	//get various info about the player's eye
	%srcEyeTransform = %srcClient.player.getEyeTransform();
	%srcEyePoint = firstWord(%srcEyeTransform) @ " " @ getWord(%srcEyeTransform, 1) @ " " @ getWord(%srcEyeTransform, 2);
	%srcEyeVector = VectorNormalize(%srcClient.player.getEyeVector());

   //see if there's an enemy near our defense location...
   %count = ClientGroup.getCount();
   %viewedClient = -1;
   %clientDot = -1;
   for(%i = 0; %i < %count; %i++)
   {
		%cl = ClientGroup.getObject(%i);

		//make sure we find an AI who's alive and not the srcClient
		if (%cl != %srcClient && AIClientIsAlive(%cl) && %cl.isAIControlled() && (%team < 0 || %cl.team == %team))
		{
			//make sure the player is within range
		   %clPos = %cl.player.getWorldBoxCenter();
		   %distance = VectorDist(%clPos, %srcEyePoint);
			if (%radius <= 0 || %distance <= %radius)
			{
				//create the vector from the srcClient to the client
				%clVector = VectorNormalize(VectorSub(%clPos, %srcEyePoint));

				//see if the dot product is greater than our current, and greater than 0.6
				%dot = VectorDot(%clVector, %srcEyeVector);

				if (%dot > 0.6 && %dot > %clientDot)
				{
					%viewedClient = %cl;
					%clientDot = %dot;
				}
			}
		}
   }
   
   return %viewedClient;
}

//-----------------------------------------------------------------------------
//AI VEHICLE FUNCTIONS

function Armor::AIonMount(%this, %obj, %vehicle, %node)
{
	//set the client var...
	%client = %obj.client;
	%client.turretMounted = -1;

	//make sure the AI was *supposed* to mount the vehicle
	if (!%client.isMountingVehicle())
	{
		AIDisembarkVehicle(%client);
		return;
	}

	//get the vehicle's pilot
   %pilot = %vehicle.getMountNodeObject(0);

	//make sure the bot is in node 0 if'f the bot is piloting the vehicle
	if ((%node == 0 && !%client.pilotVehicle) || (%node > 0 && %client.pilotVehicle))
	{
		AIDisembarkVehicle(%client);
		return;
	}

	//make sure the bot didn't is on the same team as the pilot
	if (%pilot > 0 && isObject(%pilot) && %pilot.client.team != %client.team)
	{
		AIDisembarkVehicle(%client);
		return;
	}

	//if we're supposed to pilot the vehicle, set the control object
	if (%client.pilotVehicle)
		%client.setControlObject(%vehicle);

	//each vehicle may be built differently...
   if (%vehicle.getDataBlock().getName() $= "AssaultVehicle")
   {
      //node 1 is this vehicle's turret seat
      if (%node == 1)
      {
         %turret = %vehicle.getMountNodeObject(10);
         %skill = %client.getSkillLevel();
         %turret.setSkill(%skill);
			%client.turretMounted = %turret;
			%turret.setAutoFire(true);
      }
	}

   else if (%vehicle.getDataBlock().getName() $= "BomberFlyer")
   {
      //node 1 is this vehicle's turret seat
      if (%node == 1)
      {
         %turret = %vehicle.getMountNodeObject(10);
         %skill = %client.getSkillLevel();
         %turret.setSkill(%skill);
			%client.turretMounted = %turret;
			%client.setTurretMounted(%turret);
			%turret.setAutoFire(true);
      }
	}
}

function Armor::AIonUnMount(%this, %obj, %vehicle, %node)
{
	//get the client var
	%client = %obj.client;

	//reset the control object
	if (%client.pilotVehicle)
		%client.setControlObject(%client.player);
	%client.pilotVehicle = false;

	//if the client had mounted a turret, turn the turret back off
	if (%client.turretMounted > 0)
		%client.turretMounted.setAutoFire(false);
	%client.turretMounted = -1;
	%client.setTurretMounted(-1);

   // reset the turret skill level
   if(%vehicle.getDataBlock().getName() $= "AssaultVehicle")
		if (%node == 1)
	      %vehicle.getMountNodeObject(10).setSkill(1.0);
   
   if(%vehicle.getDataBlock().getName() $= "BomberFlyer")
      if(%node == 1)
         %vehicle.getMountNodeObject(10).setSkill(1.0);
}

function AIDisembarkVehicle(%client)
{
	if (%client.player.isMounted())
	{
		if (%client.pilotVehicle)
			%client.setControlObject(%client.player);
	   %client.pressJump();
	}
}

function AIProcessVehicle(%client)
{
	//see if we're mounted on a turret, and if that turret has a target
	if (%client.turretMounted > 0)
	{
		%turretDB = %client.turretMounted.getDataBlock();

		//see if we're in a bomber close to a bomb site...
		if (%turretDB.getName() $= "BomberTurret")
		{
			%clientPos = getWords(%client.player.position, 0, 1) @ " 0";
			%found = false;
			%count = $AIBombLocationSet.getCount();
			for (%i = 0; %i < %count; %i++)
			{
				%bombObj = $AIBombLocationSet.getObject(%i);
				%bombLocation = %bombObj.location;

				//make sure the objective was issued by someone in the vehicle
				if (%bombObj.issuedByClientId.vehicleMounted == %client.vehicleMounted)
				{
					//find out where the bomb is going to drop... first, how high up are we...
					%bombLocation2D = getWord(%bombLocation, 0) SPC getWord(%bombLocation, 1) SPC "0";
					%height = getWord(%client.vehicleMounted.position, 2) - getWord(%bombLocation, 2);

					//find out how long it'll take the bomb to fall that far...
					//assume no initial velocity in the Z axis...
					%timeToFall = mSqrt((2.0 * %height) / 9.81);

					//how fast is the vehicle moving in the XY plane...
					%myLocation = %client.vehicleMounted.position;
					%myLocation2D = getWord(%myLocation, 0) SPC getWord(%myLocation, 1) SPC "0";
					%vel = %client.vehicleMounted.getVelocity();
					%vel2D = getWord(%vel, 0) SPC getWord(%vel, 1) SPC "0";

					%bombImpact2D = VectorAdd(%myLocation2D, VectorScale(%vel2D, %timeToFall));

					//see if the bomb inpact position is within 20m of the desired bomb site...
					%distToBombsite2D = VectorDist(%bombImpact2D, %bombLocation2D);
					if (%height > 20 && %distToBombsite2D < 25)
					{
						%found = true;
						break;
					}
				}
			}

			//see if we found a bomb site
			if (%found)
			{
				%client.turretMounted.selectedWeapon = 2;
				%turretDB.onTrigger(%client.turretMounted, 0, true);
				return;
			}
		}

		//we're not bombing, make sure we have the regular weapon selected
		%client.turretMounted.selectedWeapon = 1;
		if (isObject(%client.turretMounted.getTargetObject()))
			%turretDB.onTrigger(%client.turretMounted, 0, true);
		else
			%turretDB.onTrigger(%client.turretMounted, 0, false);
	}
}

function AIPilotVehicle(%client)
{
	//this is not very well supported, but someone will find a use for this function...
}

// activatePackage("RndAINameGen");