//The scripts in this file are for use only with No Quarter Mission. Feel free to use these lines
//as a referrance to study how to give AI more personality and intelligence for any other specific mission.
//                                                                                Lagg... 9/19/2009

function SiegeGame::onAIRespawn(%game, %client)
{
   //add the default tasks
	if (! %client.defaultTasksAdded)
	{
		%client.defaultTasksAdded = true;
	   %client.addTask(AIEngageTask);
	   %client.addTask(AIPickupItemTask);
           
           if (%client.team == Game.defenseTeam)
	      %client.addTask(AITauntCorpseTask);
           else
              %client.addTask(AISpamLocationTask);//- Lagg... 11-16-2003

	   %client.addTask(AIEngageTurretTask);
	   %client.addtask(AIDetectMineTask);
           %client.addtask(AIDetectRemeqTask);//- Lagg... 3-20-2003
           //%client.addtask(AIDetectVehicleTask);//- Lagg... 11-6-2003
           %client.addTask(AICouldUseInventoryTask);//- Lagg... 9-6-2003
           

           //%client.addTask(AISiegePatrolTask);//new task for the hell of it - Lagg... 3/28/2009

           //%client.addTask(AIDebugTask);// - for debugging purposes - Lagg...
	}
}

//------------------------------------------------
//TASKS AND OBJECTIVES

//AIO Attack Location
//AIO Attack Object - inBase, inRoom zone checks
//AIO Attack Player
//AIO Defend Location - inBase, inRoom zone checks
//AIO Defense Patrol
//AIO Deploy Equipment - inBase, inRoom zone checks
//AIO Deploy Vehicle
//AIO Destroy Object - inBase, inRoom zone checks
//AIO Laze Object - inBase zone checks
//AIO Missile Object - inBase zone checks
//AIO Mortar Object - inBase zone checks
//AIO Repair Object - inBase, inRoom zone checks
//AIO Touch Object -  inBase, inRoom zone checks

//------------------------------------------------------------------------------------------------------ AIO Attack Object ---
//totally rewritten so but will RAPE the object. used only for generators in siege - Lagg... 11-1-2003

function AIOAttackObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;      
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //if we are playing siege, check the entrance ff group
   if (%this.targetObjectId.inBase && nameToId("EntranceFFGroup").powerCount > 0  && !%client.inBase)
   {
      error("AIOAttackObject::weight - Target in Base, we are not, ent FF are Up");
      return 0;
   }

   InitContainerRadiusSearch(%client.player.getWorldBoxCenter(), 8, $TypeMasks::ForceFieldObjectType);
   %objSearch = containerSearchNext();
   if (%objSearch > 0)
   {
      %ffDis = %client.getPathDistance(%objSearch.getWorldBoxCenter());
      %myDis = %client.getPathDistance(%this.position);
      if (%ffDis < %myDis )
      {  
         if (%objSearch.isPowered() && %objSearch.team != %client.team)
            return 0;
      }
   }               
                 
   //no need to attack if the object is already destroyed
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;
   else
   {
      //if this bot is linked to a human who has issued this command, up the weight
      if (%this.issuedByClientId == %client.controlByHuman)
      {
         //make sure we have the potential to reach the minWeight
	 if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
	 {
	    if ($AIWeightHumanIssuedCommand < %minWeight)
	       return 0;
	    else
	       %weight = $AIWeightHumanIssuedCommand;
         }
	 else
	 {
	    // calculate the default...
	    %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
	    if (%weight < $AIWeightHumanIssuedCommand)
	       %weight = $AIWeightHumanIssuedCommand;
	 }
      }
      else
      {
         //make sure we have the potential to reach the minWeight
	 if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
	    return 0;

         // calculate the default...
	 %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);

         // ----------------------------------------------------------------------------------------- ZONE CHECKS ---

         //------------------------------------------------------- if target = SwitchGenerator ---
         if (%this.targetObjectId == nameToId("SwitchGenerator"))
         {
            if (!%client.inBase && (nameToId("EntranceFFGenS").isEnabled() || nameToId("EntranceFFGenN").isEnabled()))
               return 0;
            else if (!%client.inRoom && (nameToId("InnerFFGenerator1").isEnabled() || nameToId("InnerFFGenerator2").isEnabled()))
               return 0;
            else if (%client.inRoom)
               %weight += 200;            
         }

         //------------------------------------------------------- if target = InnerFFGenerator1/2 ---
         else if (%this.targetObjectId == (nameToId("InnerFFGenerator1") || nameToId("InnerFFGenerator2")))
         {
            if (%client.inRoom)
               return 0;
            else if (!%client.inBase && (nameToId("EntranceFFGenN").isEnabled() || nameToId("EntranceFFGenS").isEnabled()))
               return 0;
            else if (%client.inBase)
               %weight += 100;
            else   
               return 0;   
         }

         //------------------------------------------------------- if target = EntranceFFGenN/S ---
         else if (%this.targetObjectId == (nameToId("EntranceFFGenN") || nameToId("EntranceFFGenS")))
         {
            if (%client.inBase)
               return 0;
            else if (nameToId("EastTurret").isDisabled() && nameToId("WestTurret").isDisabled())
            {
               //this should break any defense around the Entrance FF gens
               %this.weightLevel1 = "3600";
               %this.weightLevel2 = "3400";
               %this.weightLevel3 = "0";
               %this.weightLevel4 = "0";
            }
            else
            {
               //set weight normal
               %this.weightLevel1 = "3200";
	       %this.weightLevel2 = "1600";
	       %this.weightLevel3 = "0";
	       %this.weightLevel4 = "0";
            }
         }

         //------------------------------------------------------- if target = BaseGenerator1/2 --- add to A above
         else if (%this.targetObjectId == (nameToId("BaseGenerator1") || nameToId("BaseGenerator2")))
         {
            if (%client.inRoom)
               return 0;
            else if (!%client.inBase && (nameToId("EntranceFFGenN").isEnabled() || nameToId("EntranceFFGenS").isEnabled()))
               return 0;
            else if (%client.inBase)
               %weight += 100; 
         }

         //------------------------------------------------------- else attack as normal ----------------
      }

      //lets give him some personallity on this one :) - Lagg...
      if ((findTargetInView(%client, 250)) == %this.targetObjectId)
         %weight += 100;

      return %weight;
   }
}

function AIAttackObject::monitor(%task, %client)
{
   InitContainerRadiusSearch(%client.player.getWorldBoxCenter(), 4, $TypeMasks::ForceFieldObjectType);
   %objSearch = containerSearchNext();
   if (%objSearch > 0)
   {
      %ffDis = %client.getPathDistance(%objSearch.getWorldBoxCenter());
      %myDis = %client.getPathDistance(%task.position);
      if (%ffDis < %myDis )
      {  
         if (%objSearch.isPowered() && %objSearch.team != %client.team)
         {
            //if this task is the objective task, choose a new objective
	    if (%task == %client.objectiveTask)
	    {
               %client.setDangerLocation(%objSearch.getWorldBoxCenter(), 20);
	       AIUnassignClient(%client);
	       Game.AIChooseGameObjective(%client);
	    }
            return;
         }
      }
   }
   //--------------------------------------------------- monitor telporter - start -
   //are we using teleporter
   if (%task.useTeleport)
   {
      %result = AIFindDeployedMPB(%client);
      %closestMPB = getWord(%result, 0);
      %closestMPBDist = getWord(%result, 1);
      %result = SweepForTeleporters(%client);
      %closestTel = getWord(%result, 0);
      %closestTelDist = getWord(%result, 1);
      if (%closestMPB > 0 && %closestTel > 0)
      {
         //we are done teleporting
         if (%closestMPBDist < %closestTelDist)
         {
            //reset the clients inventory status
            if (%client.needEquipment)
            {
               %result = AIFindClosestInventory(%client, 0);
	       %closestInv = getWord(%result, 0);
               %client.invToUse = %closestInv;
            }
            %task.useTeleport = false;
            return;
         }

         if (%closestTelDist < 2)
            %client.pressJump();
         else
         {
            %client.stepMove(%closestTel.getWorldBoxCenter(), 0.25, $AIModeWalk);
            return;
         }
      }
      else
         %task.useTeleport = false;
   }
   //--------------------------------------------------- monitor telporter - end -

   //first, buy the equipment - if we really really need some :) - Lagg... - 4-6-2003
   %hasMortar = (%client.player.getInventory("Mortar") > 0) && (%client.player.getInventory("MortarAmmo") > 0);
   %hasPlasma = (%client.player.getInventory("Plasma") > 0) && (%client.player.getInventory("PlasmaAmmo") > 0);
   %hasDisc = (%client.player.getInventory("Disc") > 0) && (%client.player.getInventory("DiscAmmo") > 0) && (%client.player.getInventory("Blaster") <= 0);
   if (%hasMortar || %hasPlasma || %hasDisc)
      %client.needEquipment = false;
   if (%client.needEquipment)
   {
      %task.setMonitorFreq(5);
      if (%task.equipment !$= "")
         %equipmentList = %task.equipment;
      else
         %equipmentList = %task.desiredEquipment;
      %result = AIBuyInventory(%client, %equipmentList, %task.buyEquipmentSet, %task.buyInvTime);
      if (%result $= "InProgress")
      {
         //force a nervous reaction every 10 sec - Lagg...
         if (getSimTime() - %task.buyInvTime > 10000)
         {
            %client.setDangerLocation(%client.player.getWorldBoxCenter(), 20);
            %task.buyInvTime = getSimTime();
            %client.buyInvTime = %task.buyInvTime;
         }
         return;
      }
      else if (%result $= "Finished")
      {
         %task.setMonitorFreq(15);
	 %client.needEquipment = false;
      }
      else if (%result $= "Failed")
      {
         //if this task is the objective task, choose a new objective
	 if (%task == %client.objectiveTask)
	 {
	    AIUnassignClient(%client);
	    Game.AIChooseGameObjective(%client);
	 }
         return;
      }
   }

   //if we made it past the inventory buying, reset the inv time
   %task.buyInvTime = getSimTime();
   
   //chat
   if (%task.sendMsg)
   {
      if (%task.sendMsgTime == 0)
         %task.sendMsgTime = getSimTime();
      else if (getSimTime() - %task.sendMsgTime > 7000)
      {
         %task.sendMsg = false;
         if (%client.isAIControlled())
         {
	    if (%task.chat !$= "")
	    {
	       %chatMsg = getWord(%task.chat, 0);
	       %chatTemplate = getWord(%task.chat, 1);
	       if (%chatTemplate !$= "")
	          AIMessageThreadTemplate(%chatTemplate, %chatMsg, %client, -1);
	       else
		  AIMessageThread(%task.chat, %client, -1);
            }
	    else if (%task.targetObject > 0)
	    {
	       %type = %task.targetObject.getDataBlock().getName();
	       if (%type $= "GeneratorLarge")
	          AIMessageThreadTemplate("AttackBase", "ChatSelfAttackGenerator", %client, -1);
	       else if (%type $= "SensorLargePulse")
		  AIMessageThreadTemplate("AttackBase", "ChatSelfAttackSensors", %client, -1);
	       else if (%type $= "SensorMediumPulse")
		  AIMessageThreadTemplate("AttackBase", "ChatSelfAttackSensors", %client, -1);
	       else if (%type $= "TurretBaseLarge")
		  AIMessageThreadTemplate("AttackBase", "ChatSelfAttackTurrets", %client, -1);
	       else if (%type $= "StationVehicle")
		  AIMessageThreadTemplate("AttackBase", "ChatSelfAttackVehicle", %client, -1);
            }
         }
      }
   }

   //set the target object if targetObject not destroyed
   %outOfStuff = (AIAttackOutofAmmo(%client));
   if (isObject(%task.targetObject) && %task.targetObject.getDamageState() !$= "Destroyed" && !%outOfStuff)
   {
      %client.stepMove(%task.location, 0.25, $AIModeExpress);//move to target no matter what
      %targetLOS = "false";
      %mask = $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType;
      %targetLOS = !containerRayCast(%client.player.getMuzzlePoint($WeaponSlot), %task.targetObject.getWorldBoxCenter(), %mask, 0);
      
      //fire at target object if in sight
      if (%targetLOS)
      {
         %task.setWeight($AIWeightReturnFire);
         %client.setEngageTarget(-1);
         %client.setTargetObject(%task.targetObject, 80, "Mortar");
      }
      else
      {
         %client.setTargetObject(-1);
         %task.setWeight(%task.baseWeight);

         //see if we need to engage a new target
         %engageTarget = %client.getEngageTarget();
         if (!AIClientIsAlive(%engageTarget) && %task.engageTarget > 0)
            %client.setEngageTarget(%task.engageTarget);

         //else see if we should abandon the engagement
         else if (AIClientIsAlive(%engageTarget))
         {
            %myPos = %client.player.getWorldBoxCenter();
            %testPos = %engageTarget.player.getWorldBoxCenter();
            %distance = %client.getPathDistance(%testPos);
            if (%distance < 0 || %distance > 20)
               %client.setEngageTarget(-1);

            //see if we're supposed to be engaging anyone...
            if (!AIClientIsAlive(%client.getEngageTarget()) && AIClientIsAlive(%client.shouldEngage))
               %client.setEngageTarget(%client.shouldEngage);
         }
      } 
   }
   else
   {
      %client.setTargetObject(-1);      
            
      //if this task is the objective task, choose a new objective
      if (%task == %client.objectiveTask)
      {
         //aim at the floor if we have to repair ourself
         if (%client.player.getDamagePercent() > 0 && %client.player.getInventory(RepairPack) > 0)
         {
            %pos = %client.player.getWorldBoxCenter();
            %posX = getWord(%pos, 0);
            %posY = getWord(%pos, 1);
            %posZ = getWord(%pos, 2) - 1;
            %pos = %posX SPC %posY SPC %posZ;
            %client.aimAt(%pos, 500);
         }
         AIUnassignClient(%client);
         Game.AIChooseGameObjective(%client);
      }
   }
}

//------------------------------------------------------------------------------------------------------------- AIO Defend Location ---

//modified so if set to offensive the bot will defend a destroyed enemy object (can you say Camping in Base ?) - Lagg... 1/7/2004
//must be placed in the enemy teams objective simgroup and DO NOT set defense = 1
//for defense: it must be set to defense = 1, for Raping enemy: must not have defense > 0 in the .mis file  - * IMPORTANT * -

function AIODefendLocation::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (%this.targetObjectId > 0  && %this.defense > 0)
   {
      if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team != %client.team)
         return 0;
   }
   else if (%this.targetObjectId > 0  && %this.offense > 0)
   {
      if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
         return 0;

      //don't camp unless base is down
      if (%this.targetObjectId.getGroup().powerCount > 0)
         return 0;
   }
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   // ----------------------------------------------------------------------------------------------- ZONE CHECKS ---
   if (%client.inBase && %this.targetObjectId == (nameToId("EastTowerGen") || nameToId("WestTowerGen") || nameToId("TowerFlipFlop")))
      return 0;

	//do a quick check to disqualify this objective if it can't meet the minimum weight
	if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
	{
		if (%this.targetObjectId > 0 && %this.issuedByClientId == %client.controlByHuman)
		{
			if ($AIWeightHumanIssuedCommand < %minWeight)
				return 0;
		}
		else
			return 0;
	}

	%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);

        //if defensive and the object has been destroyed, reduce the weight / if offensive increase the weight if destroyed (Camping !)
	if (%this.targetObjectId > 0 && %this.defense > 0)
	{

		//see if we were forced on the objective
		if (%this.issuedByClientId == %client.controlByHuman && %weight < $AIWeightHumanIssuedCommand)
			%weight = $AIWeightHumanIssuedCommand;

		//else see if the object has been destroyed - slight modification here - Lagg... 11-7-2003
	        //else if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
                else if (!isObject(%this.targetObjectId) || %this.targetObjectId.isDisabled())
			%weight -= 320;

                // ---------------------------------------------------------------------------------------------- add a little extra here - Lagg...
                if (%client.team == Game.offenseTeam && %this.targetObjectId == nameToId("TowerFlipFlop") && nameToId("TowerGroup").powerCount > 0)
                   return 0;
	}
        else if (%this.targetObjectId > 0 && %this.offense > 0)
	{

		//see if we were forced on the objective
		if (%this.issuedByClientId == %client.controlByHuman && %weight < $AIWeightHumanIssuedCommand)
			%weight = $AIWeightHumanIssuedCommand;

		// - slight modification here - Lagg... 11-7-2003
                else if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() !$= "Destroyed")
			return 0;//don't camp if not destroyed
                if (%client.player.getInventory("InventoryDeployable") > 0)
                   return 0;
	}


	return %weight;
}

//----------------------------------------------------------------------------------------------- AIO Deploy Equipment ---

//modified here so bot will continue deploying if has equip and not get bumped
//can be set at a realistic weight now, like 3400               - Lagg... 4-12-2003
//If the function ShapeBaseImageData::testInvalidDeployConditions() changes at all, those changes need to be reflected here

function AIODeployEquipment::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //make sure the deploy objective is valid
   if (%this.isInvalid)
      return 0;

   // -------------------------------------------------------------------------- Force Field avoidance 
   InitContainerRadiusSearch(%client.player.getWorldBoxCenter(), 8, $TypeMasks::ForceFieldObjectType);
   %objSearch = containerSearchNext();
   if (%objSearch > 0)
   {
      %ffDis = %client.getPathDistance(%objSearch.getWorldBoxCenter());
      %myDis = %client.getPathDistance(%this.position);
      if (%ffDis < %myDis )
      {  
         if (%objSearch.isPowered() && %objSearch.team != %client.team)
            return 0;
      }
   }

   //if badly damaged and we have a repair pack, don't waste time
   %damage = %client.player.getDamagePercent();
   if (%client.player.getInventory("RepairPack") > 0 && %damage > 0.3)
      return 0;

   // --------------------------------------------------------------------------- special check for camping in enemy base
   if (%this.mode $= "camping1" && (nameToId("EntranceFFGenN").isEnabled() || nameToId("EntranceFFGenS").isEnabled()))
      return 0;

   else if (%this.mode $= "camping2" && (nameToId("InnerFFGenerator1").isEnabled() || nameToId("InnerFFGenerator2").isEnabled()))
      return 0;

   else if (%this.mode $= "Tower1")
   {
      if (%client.inBase || (nameToId("WestTowerGen").team != %client.team || nameToId("WestTurret").isEnabled()))
         return 0;
   }
   else if (%this.mode $= "Tower2")
   {
      if (nameToId("WestTowerGen").team != %client.team)
         return 0;
   }

   else if (%this.mode $= "inField1")
   {
      if (%client.inBase || nameToId("EastTurret").isEnabled())
         return 0;
   }
   else if (%this.mode $= "mainGens")
   {
      if (%client.inRoom || (!%client.inBase && (nameToId("EntranceFFGenN").isEnabled() || nameToId("EntranceFFGenS").isEnabled())))
         return 0;
      if (nameToId("BaseGenerator1").isEnabled() || nameToId("BaseGenerator2").isEnabled())
         return 0;
   }
   else if (%client.inRoom)
      return 0;

   //first, make sure we haven't deployed too many...
   if (%this.equipment $= "TurretOutdoorDeployable" || %this.equipment $= "TurretIndoorDeployable")
      %maxAllowed = countTurretsAllowed(%this.equipment);
   else
      %maxAllowed = $TeamDeployableMax[%this.equipment];

   if ($TeamDeployedCount[%client.team, %this.equipment] >= %maxAllowed)
      return 0;

   //now make sure there are no other items in the way...
   InitContainerRadiusSearch(%this.location, $MinDeployableDistance, $TypeMasks::VehicleObjectType |
  	                                             $TypeMasks::MoveableObjectType |
  	                                             $TypeMasks::StaticShapeObjectType |
  	                                             $TypeMasks::TSStaticShapeObjectType | 
  	                                             $TypeMasks::ForceFieldObjectType |
  	                                             $TypeMasks::ItemObjectType | 
  	                                             $TypeMasks::PlayerObjectType | 
  	                                             $TypeMasks::TurretObjectType);
      %objSearch = containerSearchNext();

      //make sure we're not invalidating the deploy location with the client's own player object
      if (%objSearch == %client.player)
         %objSearch = containerSearchNext();

      //did we find an object which would block deploying the equipment?
      if (isObject(%objSearch))
      {
         //error("AIODeployEquipment::weight - Area Saturated with " @ %this.equipment);
         return 0;
      }

   //now run individual checks based on the equipment type...
   if (%this.equipment $= "TurretIndoorDeployable")
   {
      //check if there's another turret close to the deploy location
      InitContainerRadiusSearch(%this.location, $TurretIndoorSpaceRadius, $TypeMasks::StaticShapeObjectType);
      %found = containerSearchNext();
      if (isObject(%found))
      {
         %foundName = %found.getDataBlock().getName();
 	 if ((%foundName $= TurretDeployedFloorIndoor) || (%foundName $= "TurretDeployedWallIndoor") ||
           (%foundName $= "TurretDeployedCeilingIndoor") || (%foundName $= "TurretDeployedOutdoor"))
 	    return 0;
      }
 
      //now see if there are too many turrets in the area...
      %highestDensity = 0;
      InitContainerRadiusSearch(%this.location, $TurretIndoorSphereRadius, $TypeMasks::StaticShapeObjectType);
      %found = containerSearchNext();
      while (isObject(%found))
      {
         %foundName = %found.getDataBlock().getName();
 	 if ((%foundName $= "TurretDeployedFloorIndoor") || (%foundName $= "TurretDeployedWallIndoor") ||
           (%foundName $= "TurretDeployedCeilingIndoor") || (%foundName $= "TurretDeployedOutdoor"))
 	 {
 	    //found one
 	    %numTurretsNearby++;//+++++++++++++++++++++++++++++++++++++++++ ahh review this - Lagg... +++
            %nearbyDensity = testNearbyDensity(%found, $TurretIndoorSphereRadius);
 	    if (%nearbyDensity > %highestDensity)
 	       %highestDensity = %nearbyDensity;
         }
 	 %found = containerSearchNext();
      }
 
      if (%numTurretsNearby > %highestDensity)
         %highestDensity = %numTurretsNearby;
 
      //now see if the area is already saturated
      if (%highestDensity > $TurretIndoorMaxPerSphere)
         return 0;
   }
   //--------------------left off here - Lagg...+++++++++++++++++++++++++
 
 	else if (%this.equipment $= "TurretOutdoorDeployable")
 	{
 		//check if there's another turret close to the deploy location
 	   InitContainerRadiusSearch(%this.location, $TurretOutdoorSpaceRadius, $TypeMasks::StaticShapeObjectType);
 	   %found = containerSearchNext();
 	   if (isObject(%found))
 		{
 			%foundName = %found.getDataBlock().getName();     
 			if ((%foundName $= "TurretDeployedFloorIndoor") || (%foundName $= "TurretDeployedWallIndoor") || (%foundName $= "TurretDeployedCeilingIndoor") || (%foundName $= "TurretDeployedOutdoor"))
 				return 0;
 		}
 
 		//now see if there are too many turrets in the area...
 	   %highestDensity = 0;
 	   InitContainerRadiusSearch(%this.location, $TurretOutdoorSphereRadius, $TypeMasks::StaticShapeObjectType);
 	   %found = containerSearchNext();
 	   while (isObject(%found))
 	   {
 	      %foundName = %found.getDataBlock().getName();
 	      if ((%foundName $= "TurretDeployedFloorIndoor") || (%foundName $= "TurretDeployedWallIndoor") || (%foundName $= "TurretDeployedCeilingIndoor") || (%foundName $= "TurretDeployedOutdoor"))
 	      {
 				//found one
 				%numTurretsNearby++;
 
 				%nearbyDensity = testNearbyDensity(%found, $TurretOutdoorSphereRadius);
 				if (%nearbyDensity > %highestDensity)
 					%highestDensity = %nearbyDensity;     
 	      }
 	     %found = containerSearchNext();
 	   }
 
 		if (%numTurretsNearby > %highestDensity)
 			%highestDensity = %numTurretsNearby;
 
 		//now see if the area is already saturated
 		if (%highestDensity > $TurretOutdoorMaxPerSphere)
 			return 0;
 	}

	//check equipment requirement
	%needEquipment = AINeedEquipment(%this.equipment, %client);

        %needArmor = AIMustUseRegularInvStation(%this.equipment, %client);
        %result = AIFindClosestInventory(%client, %needArmor);
        %closestInv = getWord(%result, 0);
        %closestDist = getWord(%result, 1);
	
        //if don't need equipment, see if we've past the "point of no return", and should continue regardless
 	if (! %needEquipment)
 	{
                
 		
 		//if we're too far from the inv to go back, or we're too close to the deploy location, force continue
 		////if (%closestDist > 50 && VectorDist(%client.player.getWorldBoxCenter(), %task.location) < 50)
                if (%closestDist > 25)
 		{
 			%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
 			if (%weight < $AIWeightContinueDeploying)
 				%weight = $AIWeightContinueDeploying;

 			return %weight;
 		}
 	}

	//if this bot is linked to a human who has issued this command, up the weight
	if (%this.issuedByClientId == %client.controlByHuman)
	{
		//make sure we have the potential to reach the minWeight
		if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
		{
			if ($AIWeightHumanIssuedCommand < %minWeight)
				return 0;
			else
				%weight = $AIWeightHumanIssuedCommand;
		}
		else
		{
			// calculate the default...
			%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
			if (%weight < $AIWeightHumanIssuedCommand)
				%weight = $AIWeightHumanIssuedCommand;
		}
	}
	else
	{
		//make sure we have the potential to reach the minWeight
		if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
			return 0;

		// calculate the default...
		%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
	}

	return %weight;
}

//----------------------------------------------------------------------------------------------- AI Deploy Euipment ---

function AIDeployEquipment::monitor(%task, %client)
{
   //first, make sure we haven't deployed too many...
   if (%task.equipment $= "TurretOutdoorDeployable" || %task.equipment $= "TurretIndoorDeployable")
      %maxAllowed = countTurretsAllowed(%task.equipment);
   else
      %maxAllowed = $TeamDeployableMax[%task.equipment];

   if ($TeamDeployedCount[%client.team, %task.equipment] >= %maxAllowed)
   {
      //if this task is the objective task, choose a new objective
      if (%task == %client.objectiveTask)
      {
         AIUnassignClient(%client);
	 Game.AIChooseGameObjective(%client);
         return;
      }
   }

   //make sure this was not deployed already
   InitContainerRadiusSearch(%task.location, $MinDeployableDistance, $TypeMasks::StaticShapeObjectType);
   %found = containerSearchNext();
   if (isObject(%found))
   {
      if (%found.team == %client.team)
      {
         if (%task == %client.objectiveTask)
	 {
            AIUnassignClient(%client);
	    Game.AIChooseGameObjective(%client);
	    return;
	 }
      }
   }

   //see if we are hung up on a force field
   InitContainerRadiusSearch(%client.player.getWorldBoxCenter(), 4, $TypeMasks::ForceFieldObjectType);
   %objSearch = containerSearchNext();
   if (%objSearch > 0)
   {
      %ffDis = %client.getPathDistance(%objSearch.getWorldBoxCenter());
      %myDis = %client.getPathDistance(%task.position);
      if (%ffDis < %myDis )
      {  
         if (%objSearch.isPowered() && %objSearch.team != %client.team)
         {
            //if this task is the objective task, choose a new objective
	    if (%task == %client.objectiveTask)
	    {
               %client.setDangerLocation(%objSearch.getWorldBoxCenter(), 20);
	       AIUnassignClient(%client);
	       Game.AIChooseGameObjective(%client);
	    }
            return;
         }
      }
   }

   //first, see if we still need the deployable pack - Lagg... 2-25-2004
   %itemType = getWord(%task.equipment, 0);
   if (%client.player.getInventory(%itemType) > 0)
   {
      %client.needEquipment = false;
      %task.setMonitorFreq(15);
   }

   //then, buy the equipment or find it if you can :) - Lagg... 2-25-2004
   else if (%client.needEquipment)
   {
      // check to see if there's a deployable pack nearby
      %closestItem = -1;
      %closestItemDist = 32767;
      %itemType = getWord(%task.equipment, 0);

      //search the AIItemSet for a deployable pack (someone might have dropped one...)
      %armor = %client.player.getArmorSize();
      %itemCount = $AIItemSet.getCount();
      for (%i = 0; %i < %itemCount; %i++)
      {
         %item = $AIItemSet.getObject(%i);
         if (%item.getDataBlock().getName() $= %itemType && !%item.isHidden())
	 {
            %cant = false;
            if ((%itemType $= "InventoryDeployable" || %itemType $= "TurretOutdoorDeployable" || %itemType $= "TurretIndoorDeployable") && %armor $= "Light")
               %cant = true;

            %dist = %client.getPathDistance(%item.getWorldBoxCenter());
	    if (%dist > 0 && %dist < %closestItemDist && !%cant)
	    {
               %closestItem = %item;
	       %closestItemDist = %dist;
	    }
         }
      }

      //choose whether we're picking up the closest pack, or buying from an inv station...
      if ((isObject(%closestItem) && %closestItem != %task.pickupPack) || (%task.buyInvTime != %client.buyInvTime))
      {
         %task.pickupPack = %closestItem;

	 //initialize the inv buying
	 %task.buyInvTime = getSimTime();
	 AIBuyInventory(%client, %task.equipment, %task.buyEquipmentSet, %task.buyInvTime);

	 //now decide which is closer
	 if (isObject(%closestItem))
	 {
            //added a little here to check for power - Lagg... - 3-25-2003
	    if (isObject(%client.invToUse) && (%client.invToUse.isEnabled()) && (%client.invToUse.isPowered()))
	    {
               %dist = %client.getPathDistance(%client.invToUse.getWorldBoxCenter());
	       if (%dist < %closestItemDist)
	          %task.usingInv = true;
	       else
		  %task.usingInv = false;
            }
	    else
               %task.usingInv = false;
	 }
	 else
	    %task.usingInv = true;
      }

      //now see if we found a closer deployable pack
      if (!%task.usingInv && isObject(%task.pickupPack))
      {
         %client.stepMove(%task.pickupPack.position, 0.25);
         %distToPack = %client.getPathDistance(%task.pickupPack.position);
         if (%distToPack < 10 && %client.player.getMountedImage($BackpackSlot) > 0)
	    %client.player.throwPack();

	 //and we're finished until we actually have the new pack... we should - Lagg...
	 return;
      }
      else
      {
         %task.setMonitorFreq(5);
         %result = AIBuyInventory(%client, %task.equipment, %task.buyEquipmentSet, %task.buyInvTime);
	 if (%result $= "InProgress")
         {
            //force a nervous reaction every 12 sec - Lagg...
            if (getSimTime() - %task.buyInvTime > 12000)
            {
               %client.setDangerLocation(%client.player.getWorldBoxCenter(), 20);
               %task.buyInvTime = getSimTime();
               %client.buyInvTime = %task.buyInvTime;
            }
            return;
         }
	 else if (%result $= "Finished")
	 {
	    %task.setMonitorFreq(30);
            %client.needEquipment = false;

            //if we made it past the inventory buying, reset the inv time
	    %task.buyInvTime = getSimTime();
         }
	 else if (%result $= "Failed")
	 {
            //if this task is the objective task, choose a new objective
	    if (%task == %client.objectiveTask)
            {
	       AIUnassignClient(%client);
	       Game.AIChooseGameObjective(%client);
	    }
	    return;
	 }
      }
   }

   //--------------------------------------------------- monitor telporter - start -
   //are we using teleporter
   if (%task.useTeleport)
   {
      %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
      %closestMPB = getWord(%result, 0);
      %closestMPBDist = getWord(%result, 1);
      %result = SweepForTeleporters(%client);//new function in aiVehicle.cs
      %closestTel = getWord(%result, 0);
      %closestTelDist = getWord(%result, 1);
      if (%closestMPB > 0 && %closestTel > 0)
      {
         //we are done teleporting
         if (%closestMPBDist < %closestTelDist)
         {
            //reset the clients inventory status
            if (%client.needEquipment)
            {
               %result = AIFindClosestInventory(%client, 0);
	       %closestInv = getWord(%result, 0);
               %client.invToUse = %closestInv;
            }
            %task.useTeleport = false;
            return;
         }

         if (%closestTelDist < 2)
            %client.pressJump();
         else
         {
            %client.stepMove(%closestTel.getWorldBoxCenter(), 0.25);
            return;
         }
      }
      else
         %task.useTeleport = false;
   }
   //--------------------------------------------------- monitor telporter - end -

   //make sure we still have equipment
		%client.needEquipment = AINeedEquipment(%task.equipment, %client);
      if (%client.needEquipment)
      {
         //if this task is the objective task, choose a new objective
         if (%task == %client.objectiveTask)
			{
            AIUnassignClient(%client);
	         Game.AIChooseGameObjective(%client);
				return;
			}
      }

	//chat
	if (%task.sendMsg)
	{
		if (%task.sendMsgTime == 0)
			%task.sendMsgTime = getSimTime();
		else if (getSimTime() - %task.sendMsgTime > 7000)
		{
			%task.sendMsg = false;
		   if (%client.isAIControlled())
			{
				if (%task.chat !$= "")
				{
					%chatMsg = getWord(%task.chat, 0);
					%chatTemplate = getWord(%task.chat, 1);
					if (%chatTemplate !$= "")
						AIMessageThreadTemplate(%chatTemplate, %chatMsg, %client, -1);
					else
						AIMessageThread(%task.chat, %client, -1);
				}
			}
		}
	}

   //see if we're supposed to be engaging anyone...
   if (AIClientIsAlive(%client.shouldEngage))
   {
	   %hasLOS = %client.hasLOSToClient(%client.shouldEngage);
	   %losTime = %client.getClientLOSTime(%client.shouldEngage);
	   if (%hasLOS || %losTime < 1000)
         %client.setEngageTarget(%client.shouldEngage);
      else
         %client.setEngageTarget(-1);
   }
   else
      %client.setEngageTarget(-1);

	//calculate the deployFromLocation
	%factor = -1 * (4 - (%task.passes * 0.5));//changed to 4m behind to improve proformance --- Lagg... 3-15-2003
   %task.deployFromLocation = VectorAdd(%task.location,VectorScale(%task.deployDirection, %factor));

	//see if we're within range of the deploy location
   %clLoc = %client.player.position;
   %distance = VectorDist(%clLoc, %task.deployFromLocation);
	%dist2D = VectorDist(%client.player.position, getWords(%task.deployFromLocation, 0, 1) SPC getWord(%client.player.position, 2));

	//set the aim when we get near the target...  this will be overwritten when we're actually trying to deploy
	if (%distance < 10 && %dist2D < 10)
      %client.aimAt(%task.location, 1000);

   if ((%client.pathDistRemaining(20) > %distance + 0.25) || %dist2D > 0.5)
	{
		%task.deployAttempts = 0;
		%task.checkObstructed = false;
		%task.waitMove = 0;
      %client.stepMove(%task.deployFromLocation, 0.25, $AIModeExpress);
	   %task.setMonitorFreq(15);
		return;
	}
   
	if (%task.deployAttempts < 10 && %task.passes < 5 && !AIClientIsAlive(%client.getEngageTarget()))
	{
		//dissolve the human control link
		if (%task == %client.objectiveTask)
			aiReleaseHumanControl(%client.controlByHuman, %client);

	   %task.setMonitorFreq(3);
      %client.stop();
		if (%task.deployAttempts == 0)
			%deployPoint = %task.location;
		else
	      %deployPoint = findTurretDeployPoint(%client, %task.location, %task.deployAttempts);
      if(%deployPoint !$= "")
      {
         // we have possible point
         %task.deployAttempts++;
         %client.aimAt(%deployPoint, 2000);

			//try to deploy the backpack
			%client.deployPack = true;
         %client.lastDeployedObject = -1;
         %client.player.use(Backpack);
         
         // check if pack deployed
         if (isObject(%client.lastDeployedObject))
			{
				//see if there's a "repairObject" objective for the newly deployed thingy...
				if (%task == %client.objectiveTask)
				{
					%deployedObject = %client.lastDeployedObject;

					//search the current objective group and search for a "repair Object" task...
					%objective = %client.objective;

					//delete any previously associated "AIORepairObject" objective
					if (isObject(%objective.repairObjective))
					{
						AIClearObjective(%objective.repairObjective);
						%objective.repairObjective.delete();
						%objective.repairObjective = "";
                                                clearObjectiveFromTable(%objective.repairObjective);//new function below to stop objective spam - Lagg... 1-27-2004
					}

					//add the repair objective
	            %objective.repairObjective = new AIObjective(AIORepairObject)
		                              {
											      dataBlock = "AIObjectiveMarker";
		                                 weightLevel1 = %objective.weightLevel1 - 50;
		                                 weightLevel2 = 0;
		                                 description = "Repair the " @ %deployedObject.getDataBlock().getName();
                                                 mode = %task.mode;
													targetObjectId = %deployedObject;
													issuedByClientId = %client;
		                                 offense = false;
													defense = true;
		                                 equipment = "RepairPack";
		                              };
					%objective.repairObjective.deployed = true;
					%objective.repairObjective.setTransform(%objective.getTransform());
					%objective.repairObjective.group = %objective.group;
                                        MissionCleanup.add(%objective.repairObjective);

   //if is siege game we have to do this right - Lagg... 11-3-2003
   if (Game.class $= "SiegeGame")
   {
      //the objectives in $ObjectiveQ[1] are all offense objectives, $ObjectiveQ[2] has the defensive ones..
      if (%client.team == game.offenseTeam)
         $ObjectiveQ[1].add(%objective.repairObjective);
      else
         $ObjectiveQ[2].add(%objective.repairObjective);
   }
   else
      $ObjectiveQ[%client.team].add(%objective.repairObjective);


                              //changed to fix Siege gameType wrong Q error - Lagg... 11-5-2003
			      //MissionCleanup.add(%objective.repairObjective);
	            //$ObjectiveQ[%client.team].add(%objective.repairObjective);

					//finally, unassign the client so he'll go do something else...
			      AIUnassignClient(%client);
					Game.AIChooseGameObjective(%client);
				}

				//finished
				return;
			}
      }
	}
	else if (!%task.checkObstructed)
	{
		%task.checkObstructed = true;

	   //see if anything is in our way
	   InitContainerRadiusSearch(%task.location, 4, $TypeMasks::MoveableObjectType | $TypeMasks::VehicleObjectType |
																					                      $TypeMasks::PlayerObjectType);
	   %objSrch = containerSearchNext();
		if (%objSrch == %client.player)
		   %objSrch = containerSearchNext();
	   if (%objSrch)
			AIMessageThread("ChatMove", %client, -1);
	}
	else if (%task.waitMove < 5 && %task.passes < 5)
	{
		%task.waitMove++;

		//try another pass at deploying 
		if (%task.waitMove == 5)
		{
			%task.waitMove = 0;
			%task.passes++;
			%task.deployAttempts = 0;

			//see if we're *right* underneath the deploy point
			%deployDist2D = VectorDist(getWords(%client.player.position, 0, 1) @ "0", getWords(%task.location, 0, 1) @ "0");
			if (%deployDist2D < 0.25)
			{
				%client.pressjump();
                                %client.pressJet();
				%client.deployPack = true;
	         %client.player.use(Backpack);

	         // check if pack deployed
	         if(%client.player.getMountedImage($BackpackSlot) == 0)
				{
					//don't add a "repairObject" objective for ceiling turrets
					if (%task == %client.objectiveTask)
					{
						AIUnassignClient(%client);
						Game.AIChooseGameObjective(%client);
					}
				}
			}
		}
	}
	else
	{
		//find a new assignment - and remove this one from the Queue
      if (%task == %client.objectiveTask)
		{
			error(getTaggedString(%client.name) SPC ", from team" SPC %client.team SPC ", is invalidating objective:" SPC %client.objectiveTask.equipment SPC ", UNABLE TO DEPLOY EQUIPMENT");
                
			%client.objective.isInvalid = true;
	                AIUnassignClient(%client);
			Game.AIChooseGameObjective(%client);
		}
	}
}

//----------------------------------------------------------------------------------------------- AIO Destroy Object ---

//place objective marker in spot you want bot to stand and destroy for sentry turrets and hard to
//reach spots. basically same as attackobject but not as severe - Lagg... 3-26-2003

function AIODestroyObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;

   //don't attack team 0 stuffs
   if (%this.targetObjectId.team <= 0)
      return 0;      
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   // -------------------------------------------------------------------------- Force Field Avoidance
   InitContainerRadiusSearch(%client.player.getWorldBoxCenter(), 8, $TypeMasks::ForceFieldObjectType);
   %objSearch = containerSearchNext();
   if (%objSearch > 0)
   {
      %ffDis = %client.getPathDistance(%objSearch.getWorldBoxCenter());
      %myDis = %client.getPathDistance(%this.position);
      if (%ffDis < %myDis)
      {  
         if (%objSearch.isPowered() && %objSearch.team != %client.team)
            return 0;
      }
   }
      
   //no need to attack if the object is already destroyed
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;
   else
   {
      //if this bot is linked to a human who has issued this command, up the weight
		if (%this.issuedByClientId == %client.controlByHuman)
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
			{
				if ($AIWeightHumanIssuedCommand < %minWeight)
					return 0;
				else
					%weight = $AIWeightHumanIssuedCommand;
			}
			else
			{
				// calculate the default...
				%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
				if (%weight < $AIWeightHumanIssuedCommand)
					%weight = $AIWeightHumanIssuedCommand;
			}
		}
		else
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
				return 0;

			// calculate the default...
                        %this.desiredEquipment = "Plasma PlasmaAmmo";
			%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);

                        // ----------------------------------------------------------------------------------------- ZONE CHECKS ---
                        if (%client.inRoom)
                           return 0;

                        if (%client.inBase && %this.targetObjectId == (nameToId("TowerInventory1") || nameToId("TowerInventory2") ||
                          nameToId("TowerInventory") || nameToId("TowerInventory4") || nameToId("TowerInventory5")))
                           return 0;

                        if (!%client.inBase && %this.targetObjectId == (nameToId("BaseInventory1") || nameToId("BaseInventory2") ||
                          nameToId("BaseInventory3") || nameToId("BaseInventory4") || nameToId("BaseInventory5") ||
                          nameToId("BaseInventory6") || nameToId("BaseInventory7")))
                           %weight -= 400;

                        
		}

                //lets give him some personallity on this one :) - Lagg...
                if ((findTargetInView(%client, 150)) == %this.targetObjectId)
                   %weight += 200;
  
		return %weight;
	}
}

function AIDestroyObject::monitor(%task, %client)
{
   InitContainerRadiusSearch(%client.player.getWorldBoxCenter(), 4, $TypeMasks::ForceFieldObjectType);
   %objSearch = containerSearchNext();
   if (%objSearch > 0)
   {
      %ffDis = %client.getPathDistance(%objSearch.getWorldBoxCenter());
      %myDis = %client.getPathDistance(%task.position);
      if (%ffDis < %myDis )
      {  
         if (%objSearch.isPowered() && %objSearch.team != %client.team)
         {
            //if this task is the objective task, choose a new objective
	    if (%task == %client.objectiveTask)
	    {
               %client.setDangerLocation(%objSearch.getWorldBoxCenter(), 20);
	       AIUnassignClient(%client);
	       Game.AIChooseGameObjective(%client);
	    }
            return;
         }
      }
   }
   //--------------------------------------------------- monitor telporter - start -
   //are we using teleporter
   if (%task.useTeleport)
   {
      %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
      %closestMPB = getWord(%result, 0);
      %closestMPBDist = getWord(%result, 1);
      %result = SweepForTeleporters(%client);//new function in aiVehicle.cs
      %closestTel = getWord(%result, 0);
      %closestTelDist = getWord(%result, 1);
      if (%closestMPB > 0 && %closestTel > 0)
      {
         //we are done teleporting
         if (%closestMPBDist < %closestTelDist)
         {
            //reset the clients inventory status
            if (%client.needEquipment)
            {
               %result = AIFindClosestInventory(%client, 0);
	       %closestInv = getWord(%result, 0);
               %client.invToUse = %closestInv;
            }
            %task.useTeleport = false;
            return;
         }

         if (%closestTelDist < 2)
            %client.pressJump();
         else
         {
            %client.stepMove(%closestTel.getWorldBoxCenter(), 0.25);
            return;
         }
      }
      else
         %task.useTeleport = false;
   }
   //--------------------------------------------------- monitor telporter - end -

   //buy the equipment - if we really really need some :) - Lagg... - 4-6-2003
   %hasMortar = (%client.player.getInventory("Mortar") > 0) && (%client.player.getInventory("MortarAmmo") > 0);
   %hasPlasma = (%client.player.getInventory("Plasma") > 0) && (%client.player.getInventory("PlasmaAmmo") > 0);
   %hasDisc = (%client.player.getInventory("Disc") > 0) && (%client.player.getInventory("DiscAmmo") > 0) && (%client.player.getInventory("Blaster") <= 0);
   if (%hasMortar || %hasPlasma || %hasDisc)
      %client.needEquipment = false;
   if (%client.needEquipment)
   {
      %task.setMonitorFreq(5);
      if (%task.equipment !$= "")
			%equipmentList = %task.equipment;
		else
			%equipmentList = %task.desiredEquipment;
      %result = AIBuyInventory(%client, %equipmentList, %task.buyEquipmentSet, %task.buyInvTime);
		if (%result $= "InProgress")
                {
                   //force a nervous reaction every 15 sec - Lagg...
                   if (getSimTime() - %task.buyInvTime > 15000)
                   {
                      %client.setDangerLocation(%client.player.getWorldBoxCenter(), 20);
                      %task.buyInvTime = getSimTime();
                      %client.buyInvTime = %task.buyInvTime;
                   }
                   return;
                }
		else if (%result $= "Finished")
		{
		   %task.setMonitorFreq(15);
			%client.needEquipment = false;
		}
		else if (%result $= "Failed")
		{
	      //if this task is the objective task, choose a new objective
	      if (%task == %client.objectiveTask)
	      {
	         AIUnassignClient(%client);
	         Game.AIChooseGameObjective(%client);
	      }
			return;
		}
   }
	//if we made it past the inventory buying, reset the inv time
	%task.buyInvTime = getSimTime();
   
	//chat
	if (%task.sendMsg)
	{
		if (%task.sendMsgTime == 0)
			%task.sendMsgTime = getSimTime();
		else if (getSimTime() - %task.sendMsgTime > 7000)
		{
			%task.sendMsg = false;
		   if (%client.isAIControlled())
			{
				if (%task.chat !$= "")
				{
					%chatMsg = getWord(%task.chat, 0);
					%chatTemplate = getWord(%task.chat, 1);
					if (%chatTemplate !$= "")
						AIMessageThreadTemplate(%chatTemplate, %chatMsg, %client, -1);
					else
						AIMessageThread(%task.chat, %client, -1);
				}
				else if (%task.targetObject > 0)
				{
					%type = %task.targetObject.getDataBlock().getName();
					if (%type $= "GeneratorLarge")
						AIMessageThreadTemplate("AttackBase", "ChatSelfAttackGenerator", %client, -1);
					else if (%type $= "SensorLargePulse")
						AIMessageThreadTemplate("AttackBase", "ChatSelfAttackSensors", %client, -1);
					else if (%type $= "SensorMediumPulse")
						AIMessageThreadTemplate("AttackBase", "ChatSelfAttackSensors", %client, -1);
					else if (%type $= "TurretBaseLarge")
						AIMessageThreadTemplate("AttackBase", "ChatSelfAttackTurrets", %client, -1);
					else if (%type $= "StationVehicle")
						AIMessageThreadTemplate("AttackBase", "ChatSelfAttackVehicle", %client, -1);
				}
			}
		}
	}

   //set the target object
   %outOfStuff = (AIAttackOutofAmmo(%client));
   if (isObject(%task.targetObject) && %task.targetObject.getDamageState() !$= "Destroyed" && !%outOfStuff)
   {
      %client.stepMove(%task.location);
      %targetLOS = "false";
      %mask = $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::ForceFieldObjectType;
      //%targetLOS = !containerRayCast(%client.player.getWorldBoxCenter(), %task.targetObject.getWorldBoxCenter(), %mask, 0);
      %targetLOS = !containerRayCast(%client.player.getMuzzlePoint($WeaponSlot), %task.targetObject.getWorldBoxCenter(), %mask, 0);
      if (%targetLOS)
         %client.setTargetObject(%task.targetObject, 40, "Destroy");
      else
      {
          %client.setTargetObject(-1);
          //%client.stepMove(%task.location);
      } 
   }
   else
   {
      %client.setTargetObject(-1);

      //aim at the floor if we need to repair ourself
      if (%client.player.getDamagePercent() > 0 && %client.player.getInventory(RepairPack) > 0)
      {
         %pos = %client.player.getWorldBoxCenter();
         %posX = getWord(%pos, 0);
         %posY = getWord(%pos, 1);
         %posZ = getWord(%pos, 2) - 1;
         %pos = %posX SPC %posY SPC %posZ;
         %client.aimAt(%pos, 500);
      }

      
      //if this task is the objective task, choose a new objective
      if (%task == %client.objectiveTask)
      {
         AIUnassignClient(%client);
         Game.AIChooseGameObjective(%client);
      }
   }
}

//---------------------------------------------------------------------------------------------- AIO Laze Object ---

//fixed here so bots will acually use the targetting lazer for the right team :) - Lagg... - 4-12-2003
//modified last laze time and distance to client we laze for.
   
function AIOLazeObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //not if we are in the base
   if (%client.inBase)
      return 0;

   //lets check the range on this one
   if (vectorDist(%client.Player.getWorldBoxCenter(), %this.targetObjectId.getWorldBoxCenter()) < 100)
      return 0;
      
	//see if it's already being lazed
	%numTargets = ServerTargetSet.getCount();
	for (%i = 0; %i < %numTargets; %i++)
	{
		%targ = ServerTargetSet.getObject(%i);
		if (%targ.sourceObject != %client.player)
		{
			%targDist = VectorDist(%targ.getWorldBoxCenter(), %this.targetObjectId.getWorldBoxCenter());
			if (%targDist < 10)
			{
				%this.lastLazedTime = getSimTime();
				%this.lastLazedClient = %targ.sourceObject.client;
				break;
 			}
		}
	}
   if (%this.issuedByClientId > 0 && %this.issuedByClinetId == %client)
   {
       echo("cant laze target for your self IDIOT !");
       return 0;
   }

   //no need to laze if the object is already destroyed
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;
	else if (%this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;      
	else if (getSimTime() - %this.lastLazedTime <= 10000 && %this.lastLazedClient == %client)
		return 0;
   else
	{
	   //set the base weight
	   switch (%level)
	   {
	      case 1:
	         %weight = %this.weightLevel1;
	      case 2:
	         %weight = %this.weightLevel2;
	      case 3:
	         %weight = %this.weightLevel3;
	      default:
	         %weight = %this.weightLevel4;
	   }
   
	   //check Affinity
	   if (ClientHasAffinity(%this, %client))
	      %weight += 100;
      
		//for now, do not deviate from the current assignment to laze a target, if you don't
		//already have a targeting laser.
		%needEquipment = AINeedEquipment(%this.equipment, %client);
		if (!%needEquipment)
			%weight += 100;
		else if (!aiHumanHasControl(%client.controlByHuman, %client))
			return 0;

		//see if this client is close to the issuing client
		if (%this.issuedByClientId > 0)
		{
			if (! AIClientIsAlive(%this.issuedByClientId))
				return 0;

		   %distance = %client.getPathDistance(%this.issuedByClientId.player.getWorldBoxCenter());
			if (%distance < 0)
				%distance = 32767;

		   //see if we're over 300 m
		   if (%distance > 300)
		      return 0;

                   //see if we're within 200 m
		   if (%distance < 200)
		      %weight += 30;

		   //see if we're within 90 m
		   if (%distance < 90)
		      %weight += 30;

		   //see if we're within 45 m
		   if (%distance < 45)
		      %weight += 30;
		}

		//now, if this bot is linked to a human who has issued this command, up the weight
		if (%this.issuedByClientId == %client.controlByHuman && %weight < $AIWeightHumanIssuedCommand)
			%weight = $AIWeightHumanIssuedCommand;

		return %weight;
	}
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ AIO MAttack Location +++
//modified version of AIAttackLocation, could be called AIMortarSpamLocation :) - Lagg...

function AIOMAttackLocation::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;
      
   //now, if this bot is linked to a human who has issued this command, up the weight
   if (%this.issuedByClientId == %client.controlByHuman)
   {
      //make sure we have the potential to reach the minWeight
      if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
      {
         if ($AIWeightHumanIssuedCommand < %minWeight)
	    return 0;
	 else
	    %weight = $AIWeightHumanIssuedCommand;
      }
      else
      {
         // calculate the default...
	 %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
	 if (%weight < $AIWeightHumanIssuedCommand)
	    %weight = $AIWeightHumanIssuedCommand;
      }
   }
   else
   {
      //make sure we have the potential to reach the minWeight
      if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
         return 0;

      // calculate the default...
      %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
   }

   //Special cases to account for force fields up or down and if we are in the base or not
   if (nameToId("EntranceFFNorth").powerCount > 0 && nameToId("EntranceFFEast").powerCount > 0 && nameToId("EntranceFFWest").powerCount > 0 && !%client.inBase)
      return 0;

   if (%this.mode $= "SwitchGenDown")
   {
      if (nameToId("SwitchFFGenerator").isEnabled())
         return 0;

      if (isObject(%client.objectiveTask) && (%client.objectiveTask.getName() $= "AIDefendLocation" || %client.objectiveTask.getName() $= "AIDeployEquipment"))
      {
         //error("AIOMAttackLocation::weight - we are in base but we are " @ getTaggedString(%client.name) SPC %client.objectiveTask.getName());
         return 0;
      }
   }
   return %weight;
}

//----------------------------------------------------------------------------------------------- AIO Missile Object ---

function AIOMissileObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;

   //don't attack team 0 stuffs
   if (%this.targetObjectId.team <= 0)
      return 0;      
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //check the zone
   if (%client.inBase)
      return 0;

   //lets check the range on this one
   if (vectorDist(%client.Player.getWorldBoxCenter(), %this.getWorldBoxCenter()) < 50)
      return 0;

   //echo("AIOMissileObject::weight");
    
   //no need to attack if the object is already destroyed
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;
   else
	{
		//if this bot is linked to a human who has issued this command, up the weight
		if (%this.issuedByClientId == %client.controlByHuman)
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
			{
				if ($AIWeightHumanIssuedCommand < %minWeight)
					return 0;
				else
					%weight = $AIWeightHumanIssuedCommand;
			}
			else
			{
				// calculate the default...
				%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
				if (%weight < $AIWeightHumanIssuedCommand)
					%weight = $AIWeightHumanIssuedCommand;
			}
		}
		else
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
				return 0;

			// calculate the default...
			%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
		}

		return %weight;
	}
}

//------------------------------------------------------------------------------------------------------------ AIO Mortar Object ---
//Modified so bot gets LOS to target before firing. Fixed a lot of stuff here.          - Lagg...


function AIOMortarObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team == %client.team)
      return 0;
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   //check the zone
   if (%client.inBase)
      return 0;
      
   //no need to attack if the object is already destroyed
   if (%this.targetObjectId.getDamageState() $= "Destroyed")
      return 0;
   else
   {
      //if this bot is linked to a human who has issued this command, up the weight
      if (%this.issuedByClientId == %client.controlByHuman)
      {
         //make sure we have the potential to reach the minWeight
	 if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
	 {
	    if ($AIWeightHumanIssuedCommand < %minWeight)
	       return 0;
	    else
	       %weight = $AIWeightHumanIssuedCommand;
	 }
	 else
	 {
	    // calculate the default...
	    %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
	    if (%weight < $AIWeightHumanIssuedCommand)
	       %weight = $AIWeightHumanIssuedCommand;
	 }
      }
      else
      {
         //make sure we have the potential to reach the minWeight
         if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
	    return 0;

	 // calculate the default...
	    %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
      }

      return %weight;
   }
}

//--------------------------------------------------------------------------------------- AIO Repair Object ---
//if you have a problem with bot getting stuck navigating to repair any object,
//place objective marker in spot you want bot to stand for repair at about bots waist level.
//if there is no problem with bot getting stuck repairing this object set the AIORepairObject
//markers transform to the same exact transform as the Object (x, y, z) updated - 10-18-2003

//fixed spam error when trying to repair a deployed object in case it gets destroyed while
//in loop. also fixed bots finding repair pack if base is down :) ----------- Lagg... 3-26-2003

function AIORepairObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team != %client.team)
      return 0;      
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   // -------------------------- ZOne Checks for camping in base
   if (%client.team == Game.offenseTeam && %client.inRoom)
      return 0;

   else if (%this.mode $= "inField1" && %client.inBase)
      return 0;

   else if (%this.mode $= "Tower1" && %client.inBase)
      return 0;

   else if (%this.mode $= "camping1" && !%client.inBase && (nameToId("EntranceFFGenN").isEnabled() || nameToId("EntranceFFGenS").isEnabled()))
      return 0;

   else if (%this.mode $= "camping2" && !%client.inBase && (nameToId("EntranceFFGenN").isEnabled() || nameToId("EntranceFFGenS").isEnabled()))
      return 0;

   else if (%this.mode $= "" && %client.team == Game.offenseTeam && %client.inBase)
      return 0;
      
   //no need to repair if the object isn't in need
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamagePercent() <= 0)
      return 0;
   else
	{
		//if this bot is linked to a human who has issued this command, up the weight
		if (%this.issuedByClientId == %client.controlByHuman)
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
			{
				if ($AIWeightHumanIssuedCommand < %minWeight)
					return 0;
				else
					%weight = $AIWeightHumanIssuedCommand;
			}
			else
			{
				// calculate the default...
				%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
				if (%weight < $AIWeightHumanIssuedCommand)
					%weight = $AIWeightHumanIssuedCommand;
			}
		}
		else
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
				return 0;

			// calculate the default...
			%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
		}

		return %weight;
	}
}

//--------------------------------------------------------------------------------------------------- AIO Touch Object ---

function AIOTouchObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;

   InitContainerRadiusSearch(%client.player.getWorldBoxCenter(), 4, $TypeMasks::ForceFieldObjectType);
   %objSearch = containerSearchNext();
   if (%objSearch > 0)
   {
      %ffDis = %client.getPathDistance(%objSearch.getWorldBoxCenter());
      %myDis = %client.getPathDistance(%this.position);
      if (%ffDis < %myDis)
      {  
         if (%objSearch.isPowered() && %objSearch.team != %client.team)
            return 0;
      }
   }

   if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
      return 0;

   switch$ (%this.mode)
   {
      case "TouchFlipFlop":

         if(%this.targetObjectId.team == %client.team || %this.targetObjectId.isHidden())
	    return 0;

         if ($CurrentMissionType $= "Siege")
         {
            %weight = AIODefault::weight(%this, %client, %level, %inventoryStr);

            InitContainerRadiusSearch(%this.location, 12, $TypeMasks::ForceFieldObjectType);
            %objSearch = containerSearchNext();
            if (%objSearch > 0 && %objSearch.isPowered() && %objSearch.team != %client.team)
               return 0;

            // ----------------------------------------------------------------------------------------- ZONE CHECKS ---               
            if (%this.targetObjectId == nameToId("objective"))
            {
               if (!%client.inBase && (nameToId("EntranceFFGenN").isEnabled() || nameToId("EntranceFFGenS").isEnabled()))
                  return 0;

               else if (!%client.inRoom && (nameToId("InnerFFGenerator1").isEnabled() || nameToId("InnerFFGenerator2").isEnabled()))
                  return 0;

               else if (%client.inRoom)
                   %weight += 400;
            }
            else if (%this.targetObjectId == nameToId("TowerFlipFlop"))
            {
               if (%client.inBase)
                  return 0;
            }        
         }

         return %weight;

      case "FlagGrab":
			if (! %this.targetObjectId.isHome)
				return 0;
			else
	                        return AIODefault::weight(%this, %client, %level, %inventoryStr);

      case "FlagDropped":
			if ((%this.targetObjectId.isHome) || (%this.targetObjectId.carrier !$= ""))
				return 0;
			else
	                        return AIODefault::weight(%this, %client, %level, %inventoryStr);

      case "FlagCapture":
			if (%this.targetObjectId.carrier != %client.player)
                                return 0;
                        else
			{
				//find our home flag location
				%homeTeam = %client.team;
				%homeFlag = $AITeamFlag[%homeTeam];
				%this.location = %homeFlag.originalPosition;
				return AIODefault::weight(%this, %client, %level, %inventoryStr);
			}
   }
   return 0;
}

//----------------------------------------------------------------------------------------------------- AI Touch Object ---

function AITouchObject::monitor(%task, %client)
{
   InitContainerRadiusSearch(%client.player.getWorldBoxCenter(), 4, $TypeMasks::ForceFieldObjectType);
   %objSearch = containerSearchNext();
   if (%objSearch > 0)
   {
      %ffDis = %client.getPathDistance(%objSearch.getWorldBoxCenter());
      %myDis = %client.getPathDistance(%task.location);
      if (%ffDis < %myDis )
      {  
         if (%objSearch.isPowered() && %objSearch.team != %client.team)
         {
            //if this task is the objective task, choose a new objective
	    if (%task == %client.objectiveTask)
	    {
               %client.setDangerLocation(%objSearch.getWorldBoxCenter(), 20);
	       AIUnassignClient(%client);
	       Game.AIChooseGameObjective(%client);
	    }
            return;
         }
      }
   }
   //--------------------------------------------------- monitor telporter - start -
   //are we using teleporter
   if (%task.useTeleport)
   {
      %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
      %closestMPB = getWord(%result, 0);
      %closestMPBDist = getWord(%result, 1);
      %result = SweepForTeleporters(%client);//new function in aiVehicle.cs
      %closestTel = getWord(%result, 0);
      %closestTelDist = getWord(%result, 1);
      if (%closestMPB > 0 && %closestTel > 0)
      {
         //we are done teleporting
         if (%closestMPBDist < %closestTelDist)
         {
            //reset the clients inventory status
            if (%client.needEquipment)
            {
               %result = AIFindClosestInventory(%client, 0);
	       %closestInv = getWord(%result, 0);
               %client.invToUse = %closestInv;
            }
            %task.useTeleport = false;
            return;
         }

         if (%closestTelDist < 2)
            %client.pressJump();
         else
         {
            %client.stepMove(%closestTel.getWorldBoxCenter(), 0.25);
            return;
         }
      }
      else
         %task.useTeleport = false;
   }
   //--------------------------------------------------- monitor telporter - end -

   if (%client.inBase)
      %client.needEquipment = false;

   // ---------------------- buy equipment
   if (%client.needEquipment)
   {
      %task.setMonitorFreq(5);
      if (%task.equipment !$= "")
         %equipmentList = %task.equipment;
      else
	 %equipmentList = %task.desiredEquipment;
      %result = AIBuyInventory(%client, %equipmentList, %task.buyEquipmentSet, %task.buyInvTime);
      if (%result $= "InProgress")
      {
         //force a nervous reaction every 10 sec - Lagg...
         if (getSimTime() - %task.buyInvTime > 10000)
         {
            %client.setDangerLocation(%client.player.getWorldBoxCenter(), 20);
            %task.buyInvTime = getSimTime();
            %client.buyInvTime = %task.buyInvTime;
         }
         return;
      }
      else if (%result $= "Finished")
      {
         %task.setMonitorFreq(15);
	 %client.needEquipment = false;
      }
      else if (%result $= "Failed")
      {
         %task.setMonitorFreq(15);
	 %client.needEquipment = false;
         //if this task is the objective task, choose a new objective
	 //if (%task == %client.objectiveTask)
	 //{
	    //AIUnassignClient(%client);
	    //Game.AIChooseGameObjective(%client);
	 //}
	 //return;
      }
   }

   //if we made it past the inventory buying, reset the inv time
   %task.buyInvTime = getSimTime();

   //chat
   if (%task.sendMsg)
   {
      if (%task.sendMsgTime == 0)
         %task.sendMsgTime = getSimTime();
      else if (getSimTime() - %task.sendMsgTime > 7000)
      {
         %task.sendMsg = false;
	 if (%client.isAIControlled())
	 {
	    if (%task.chat !$= "")
	    {
	       %chatMsg = getWord(%task.chat, 0);
	       %chatTemplate = getWord(%task.chat, 1);
	       if (%chatTemplate !$= "")
	          AIMessageThreadTemplate(%chatTemplate, %chatMsg, %client, -1);
	       else
		  AIMessageThread(%task.chat, %client, -1);
            }
         }
      }
   }

   //keep updating the position, in case the flag is flying through the air...
   if (%task.location !$= "")
      %touchPos = %task.location;
   else
      %touchPos = %task.targetObject.getWorldBoxCenter();
      
   //see if we need to engage a new target
   %engageTarget = %client.getEngageTarget();
   if (!AIClientIsAlive(%engageTarget) && %task.engageTarget > 0)
      %client.setEngageTarget(%task.engageTarget);
   
   //else see if we should abandon the engagement
   else if (AIClientIsAlive(%engageTarget))
   {
      %myPos = %client.player.getWorldBoxCenter();
      %testPos = %engageTarget.player.getWorldBoxCenter();
      %distance = %client.getPathDistance(%testPos);
      if (%distance < 0 || %distance > 50)
         %client.setEngageTarget(-1);
   }

   //see if we have completed our objective
   if (%task == %client.objectiveTask)
   {
      %completed = false;
      switch$ (%task.mode)
      {
         case "TouchFlipFlop":
	    if (%task.targetObject.team == %client.team)
	       %completed = true;
	 case "FlagGrab":
	    if (!%task.targetObject.isHome)
               %completed = true;
	 case "FlagDropped":
	    if ((%task.targetObject.isHome) || (%task.targetObject.carrier !$= ""))
	       %completed = true;
	 case "FlagCapture":
	    if (%task.targetObject.carrier != %client.player)
	       %completed = true;
      }
      if (%completed)
      {
         AIUnassignClient(%client);
	 Game.AIChooseGameObjective(%client);
	 return;
      }
   }

   if (%task.mode $= "FlagCapture")
   {
      %homeFlag = $AITeamFlag[%client.team];

      //if we're within range of the flag's home position, and the flag isn't home, start idling...
      if (VectorDist(%client.player.position, %touchPos) < 40 && !%homeFlag.isHome)
      {
         if (%client.getStepName() !$= "AIStepIdlePatrol")
	    %client.stepIdle(%touchPos);
      }
      else
         %client.stepMove(%touchPos, 0.25, $AIModeExpress);
   }

   //if siege game we want a special way of capturing the flip flop - Lagg... 9-11-2003
   else if ((%task.mode $= "TouchFlipFlop") && ($CurrentMissionType $= "Siege"))
   {

      //if there is a force field blocking the way - Lagg... 9-11-2003
      InitContainerRadiusSearch(%touchPos, 12, $TypeMasks::ForceFieldObjectType);
      %objSearch = containerSearchNext();
      if (%objSearch > 0 && %objSearch.isPowered())//should we check for all pass force fields? - Lagg ... (nah)
      {
         if (%task == %client.objectiveTask)
         {
            AIUnassignClient(%client);
	    Game.AIChooseGameObjective(%client);
	    return;
         }
      }
      else
         %client.stepMove(%touchPos, 0.25, $AIModeExpress);
   }
   else
      %client.stepMove(%touchPos, 0.25, $AIModeExpress);

   if (VectorDist(%client.player.position, %touchPos) < 10)
   {
      //dissolve the human control link
      if (%task == %client.objectiveTask)
      {
         if (aiHumanHasControl(%task.issuedByClient, %client))
	 {
	    aiReleaseHumanControl(%client.controlByHuman, %client);

	    //should re-evaluate the current objective weight
	    %inventoryStr = AIFindClosestInventories(%client);
	    %client.objectiveWeight = %client.objective.weight(%client, %client.objectiveLevel, 0, %inventoryStr);
	 }
      }
   }

   //see if we're supposed to be engaging anyone...
   if (!AIClientIsAlive(%client.getEngageTarget()) && AIClientIsAlive(%client.shouldEngage))
      %client.setEngageTarget(%client.shouldEngage);
}

//-----------------------------------------------------------------------------------------------------------------------
function AIMissionEnd()
{
	//disable the AI system
	AISystemEnabled(false);

   $AIGenDisabledCount[0] = 0; //team 1
   $AIGenDisabledCount[1] = 0; //team 2
   $AIGenTotalDestroyed[1] = 0;
   $AIGenTotalDestroyed[2] = 0;
   $AIHumansInTeam[1] = 0; 
   $AIHumansInTeam[2] = 0; 
   $AIDefenderWeightModifier[1] = -200; //team 1
   $AIDefenderWeightModifier[2] = -200; //team 2
   $AITeamLosing[1] = true; //AITeamLosing must be true to deploy cameras. A losing team will start deploying Cameras if they're not a GenDefend objective.
   $AITeamLosing[2] = true; 

	//loop through the client list, and clear the tasks of each bot
	%count = ClientGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%client = ClientGroup.getObject(%i);
		if (%client.isAIControlled())
		{
			//cancel the respawn thread and the objective thread...
			cancel(%client.respawnThread);
			cancel(%client.objectiveThread);

         //reset the clients tasks, variables, etc...
	      AIUnassignClient(%client);
         %client.stop();
			%client.clearTasks();
         %client.clearStep();
         %client.lastDamageClient = -1;
         %client.lastDamageTurret = -1;
         %client.shouldEngage = -1;
         %client.setEngageTarget(-1);
         %client.setTargetObject(-1);
         %client.engageRemeq = -1;//added - Lagg...
         %client.pickUpItem = -1;//added - Lagg...
	      %client.pilotVehicle = false;
         %client.defaultTasksAdded = false;

         %client.waitSpot = "";
      %client.chaseSpeedFar = 4.9;
      %client.chaseSpeedVeryFar = 6.7;
      %client.chaseSpeedMegaUltraFar = 7.2;
      %client.chaseSpeedMarker = 7.35;
      %client.runToBaseSpeed = 3.4;
      //when bots switch objectives and they were following a path, make them remember what path and spot they were at when they get back, -1 is no path/spot 
      %client.lastIndexPathToFlag = -1;
      %client.lastPathToFlag = -1;
      %client.lastIndexAttackPath = -1;
      %client.lastAttackPath = -1;
      %client.capperGrabbingFlag = false; //when this is true we ignore detecting turrets, mines, invs, or enemies and we just grab the flag 
      %client.waitTimeWasReset = false; //this will make the bot correctly wait at the marker with the waitTime datafield, shouldWaitTime will be reset when this is false 
      %client.lastRecordedPos = "";
      %client.stuckCount = 0;
      %client.stuckCheckSchedule1 = -1;
      %client.stuckCheckSchedule2 = -1;
      %client.stuckCheckSchedule3 = -1;
      //reset map record vars
      %client.diskMidairs = 0;
      %client.plasmaMidairs = 0;
      %client.blasterMidairs = 0;
      %client.sniperHeadshots = 0;
      %client.killingSpree = 0;
      %client.rabbitKills = 0;

         //reset the client zone flags - Lagg... 12-17-2003
         %client.inBase = false;
         %client.inRoom = false;

	      //do the nav graph cleanup
	      %client.missionCycleCleanup();
		}
	}

	//clear the objective Q's
	for (%i = 0; %i <= Game.numTeams; %i++)
	{
		if (isObject($ObjectiveQ[%i]))
		{
			$ObjectiveQ[%i].clear();
			$ObjectiveQ[%i].delete();
		}
		$ObjectiveQ[%i] = "";
	}

	//now delete all the sets used by the AI system...
	if (isObject($AIBombLocationSet))
   	$AIBombLocationSet.delete();
	$AIBombLocationSet = "";

	if (isObject($AIInvStationSet))
   	$AIInvStationSet.delete();
	$AIInvStationSet = "";

	if (isObject($AIItemSet))
   	$AIItemSet.delete();
	$AIItemSet = "";

	if (isObject($AIGrenadeSet))
   	$AIGrenadeSet.delete();
	$AIGrenadeSet = "";

	if (isObject($AIWeaponSet))
   	$AIWeaponSet.delete();
	$AIWeaponSet = "";

	if (isObject($AIRemoteTurretSet))
   	$AIRemoteTurretSet.delete();
	$AIRemoteTurretSet = "";

	if (isObject($AIDeployedMineSet))
   	$AIDeployedMineSet.delete();
	$AIDeployedMineSet = "";

	if (isObject($AIVehicleSet))
   	$AIVehicleSet.delete();
	$AIVehicleSet = "";

        //get rid of the aivehiclepadset as well ----------------------------------------- added Lagg... - 8-19-2003
        if (isObject($AIVehiclePadSet))
   	$AIVehiclePadSet.delete();
	$AIVehiclePadSet = "";

        //get rid of the aiteleportset as well ----------------------------------------- added Lagg... - 10-1-2003
        if (isObject($AITeleportSet))
   	$AITeleportSet.delete();
	$AITeleportSet = "";
}
