package CONN_CT_PATCH
{
	// Make sure we reset player count after a player connects!
	////////////////////
	//
	function GameConnection::onConnect(%client, %name, %raceGender, %skin, %voice, %voicePitch)
	{
		schedule(10, 0, "update_player_count");
		parent::onConnect(%client, %name, %raceGender, %skin, %voice, %voicePitch);
	}


	// Make sure we reset player count after a player drops!
	////////////////////
	//
	function GameConnection::onDrop(%client, %reason)
	{
		schedule(10, 0, "update_player_count");
		parent::onDrop(%client, %reason);
	}


	// Make sure we reset player count after a bot drops!
	////////////////////
	//
	function AIConnection::onAIDrop(%client)
	{
		schedule(10, 0, "update_player_count");
		parent::onAIDrop(%client);
	}


	// Make sure we reset player count after a bot connects!
	////////////////////
	//
	function AIConnection::onAIConnect(%client, %name, %team, %skill, %offense, %voice, %voicePitch)
	{
		schedule(10, 0, "update_player_count");
		parent::onAIConnect(%client, %name, %team, %skill, %offense, %voice, %voicePitch);
	}


	// Reset player count when somebody is forced observer.
	//  (extra security...)
	////////////////////
	//
	function DefaultGame::forceObserver(%game, %client, %reason)
	{
		update_player_count();
		parent::forceObserver(%game, %client, %reason);
	}


	// Reset player count when a match starts.
	//  (extra security...)
	////////////////////
	//
	function DefaultGame::startMatch(%game)
	{
		update_player_count();
		parent::startMatch(%game);
	}


	// Reset player count when a match ends.
	//  (extra security...)
	////////////////////
	//
	function DefaultGame::gameOver(%game)
	{
		update_player_count();
		parent::gameOver(%game);
	}


	// Actually set the player count.
	//  (Didn't want to use eval)
	////////////////////
	//
	function update_player_count()
	{
		$HostGamePlayerCount = ClientGroup.getCount();
	}
};
if (!isActivePackage(CONN_CT_PATCH))
	activatePackage(CONN_CT_PATCH);