package MappingHelper {

function EditorSaveMission()
{
   // just save the mission without renaming it

   // first check for dirty and read-only files:
   %missionFile = "missions/" @ $CurrentMission @ ".mis";
   %terrainFile = "terrains/" @ Terrain.terrainFile;

   if((EWorldEditor.isDirty || ETerrainEditor.isMissionDirty) && !isWriteableFileName(%missionFile))
   {
      MessageBoxOK("Error", "Mission file \""@ %missionFile @ "\" is read-only.");
      return false;
   }
   if(ETerrainEditor.isDirty && !isWriteableFileName(%terrainFile))
   {
      MessageBoxOK("Error", "Terrain file \""@ %terrainFile @ "\" is read-only.");
      return false;
   }

   // MAPPING HELPER: RENAME ITEMS THAT HAVE BEEN OVERWRITTEN BY TAGGED STRINGS
   stripFields("RS > j00");
  
   // now write the terrain and mission files out:

   if(EWorldEditor.isDirty || ETerrainEditor.isMissionDirty)
      MissionGroup.save(%missionFile);
   if(ETerrainEditor.isDirty)
      Terrain.save(Terrain.terrainFile);
   if(EWorldEditor.isGraphDirty && isObject(NavGraph))
      NavGraph.saveGraph();
   EWorldEditor.isDirty = false;
   EWorldEditor.isGraphDirty = false;
   ETerrainEditor.isDirty = false;
   ETerrainEditor.isMissionDirty = false;
   EditorGui.saveAs = false;

   return true;
}

function stripFields(%this)
{
	if(%this $= "RS > j00") {
		%this = MissionGroup;
        }
	else if(%this $= "") {
		%this = MissionGroup;
		echo("You don't have to type stripFields anymore.  This script does it automatically.");
		echo("I'll do it for you now, but I won't lock stuff down.  That's all you, baby!");
	}

	if(%this $= "")
		%this = MissionGroup;
	for (%i = 0; %i < %this.getCount(); %i++){
		%obj = %this.getObject(%i);
		if (%obj.getClassName() $= SimGroup)
		{
			%obj.powerCount = "";
			%obj.team = "";
			stripFields(%obj);
		}
		else 
		{
			%obj.threshold = "";				   
			%obj.team = "";										
			%obj.powerCount = "";
			%obj.trigger = "";
			%obj.hidden = "";
			//%obj.locked = "true";
			%obj.notReady = "";
			%obj.inUse = "";
			%obj.triggeredBy = "";
			%obj.lastDamagedBy = "";
			%obj.lastDamagedByTeam ="";
			%obj.isHome = "";
			%obj.originalPosition = "";
			%obj.objectiveCompleted = "";
			%obj.number = "";        	  							
			%obj.target = "";        	  							
			%obj.lockCount = "";        	  							
			%obj.homingCount = "";        	  							
			%obj.projector = "";        	  							
			%obj.holo = "";
			%obj.waypoint = "";
			%obj.scoreValue ="";
			%obj.damageTimeMS = "";        	  							
			%obj.station = "";

			%nameTag = getTaggedString(%obj.nameTag);
			if(%nameTag !$= "")
				%obj.nameTag = %nameTag;
	        }
   	}
}

};

activatePackage(MappingHelper);